unit JS_KEY;


interface

Uses
 graph,dos,crt,js_sub,pc_mouse;

Type
 FktTst = 1..10;
 FktTxt = string[6];
 KeyTxt = array [0..10] of FktTxt;


procedure GetFktTstG(x,y:Integer;       keys:KeyTxt; VAR taste:FktTst);
procedure GetFktTstT(zeile,spalte:Byte; keys:KeyTxt; VAR taste:FktTst);



Implementation

procedure GetFktTstG(x,y:Integer; keys:KeyTxt; VAR taste:FktTst);

 Const
  Anz=      10;
  ChrPtch=  8;
  ChrHght=  8;
  TxtLen =  6;
  KeyStep=  25;
  KeyLen =  TxtLen*ChrPtch;
  KeyHght=  ChrHght+4;
  BoxWdth=  KeyLen+32;
  ColorBox= Lightgray;

 Var
  BoxHght:  Integer;
  titel:    FktTxt;
  tastcode: Longint;
  i:        Byte;
  ch:       Char;
  xx,yy:    Integer;
  t1,t2:    Integer;

 procedure PlotKeyXY(x,y:integer; txt:FktTxt; active:Boolean);
  var ColorKey,ColorShdw,ColorTxt: Byte;
  begin
  if active then
   begin
   ColorKey:=Red; ColorShdw:=DarkGray; ColorTxt:=Black;
   SetFillstyle(SolidFill,ColorBox ); bar(x  ,y  ,x+KeyLen  ,y+Keyhght  );
   SetFillstyle(SolidFill,ColorShdw); bar(x+4,y+6,x+KeyLen+4,y+Keyhght+6);
   SetFillstyle(SolidFill,ColorKey ); bar(x+2,y+3,x+KeyLen+2,y+KeyHght+3);
   SetColor(ColorTxt); OutTextXY(x+3,y+6,txt);
   end
  else
   begin
   ColorKey:=Green; ColorShdw:=DarkGray; ColorTxt:=Black;
   SetFillstyle(SolidFill,ColorShdw); bar(x+4,y+6,x+KeyLen+4,y+KeyHght+6);
   SetFillstyle(SolidFill,ColorKey ); bar(x  ,y  ,x+KeyLen  ,y+Keyhght  );
   SetColor(ColorTxt); OutTextXY(x+1,y+3,txt);
   end;
  end;



 begin
 BoxHght:=anz*KeyStep+10;
 titel:=keys[0];
 SetFillstyle(SolidFill,LightGray); Bar(x,y,x+BoxWdth-1,y+BoxHght-1);
 SetColor(DarkGray);  RectAngle(x+2,y+3,x+BoxWdth-3,y+BoxHght-4);
 Bar(x+7,y+1,x+8+Length(titel)*ChrPtch,y+1+ChrHght); OutTextXY(x+8,y+1,titel);

 for i:=1 to anz do
  begin
  OutTextXY(x+ 8,y+10+(i-1)*KeyStep+3,StrI(i mod 10,1));
  PlotKeyXY(x+20,y+10+(i-1)*KeyStep  ,keys[i],FALSE);
 end;

 Delay(5); ShowMouseCursor;

 repeat
  tastcode:=0;
  if KeyPressed then if ReadKey=#0 then
                     if KeyPressed then tastcode:=Ord(ReadKey)-58;
  if not LeftButton then begin
                         Delay(10); 
                         if LeftButton then
                          begin
                          GetMousePosition(xx,yy);
                          if (xx>x+20) and (xx<x+68) and (yy-y-9>=0) then
                           begin
                           t1:=(yy-y-9) div KeyStep +1;
                           t2:=(yy-y-9+KeyHght) div KeyStep +1;
                           if t1=t2 then tastcode:=t1;
                           end;
                          end;
                         end;
 until (tastcode>=1) and (tastcode<=10);
 taste:=tastcode;

 HideMouseCursor;

 PlotKeyXY(x+20,y+10+(taste-1)*KeyStep,keys[taste],TRUE);
 end;


procedure GetFktTstT(zeile,spalte:Byte; keys:KeyTxt; VAR taste:FktTst);

 Const
  Anz=      10;
  TxtLen =  6;
  KeyStep=  2;
  ColorBox= Lightgray;

 Var
  i:        Byte;
  titel:    FktTxt;
  tastcode: Longint;
  ch:       Char;
  fertig:   Boolean;
  ta:       Word;

 procedure PlotKeyZS(zeile,spalte:Byte; txt:FktTxt; active:Boolean);
  var ColorKey,ColorShdw,ColorTxt: Byte;
  begin
  txt:=txt+RptStr(Length(txt)-6,' ');
  if active then
   begin
   ColorKey:=Red; ColorShdw:=DarkGray; ColorTxt:=Black;
   TextColor(ColorTxt); TextBackground(ColorKey); 
   GoToXY(spalte,zeile); Write(txt);
   TextColor(ColorShdw); TextBackground(ColorBox);
   GoToXY(spalte+6,zeile); Write('');
   GoToXY(spalte+1,zeile+1); Write('');
   end
  else
   begin
   ColorKey:=Green; ColorShdw:=DarkGray; ColorTxt:=Black;
   TextColor(ColorTxt); TextBackground(ColorKey);
   GoToXY(spalte,zeile); Write(txt);
   TextColor(ColorShdw); TextBackground(ColorBox);
   GoToXY(spalte+6,zeile); Write('');
   GoToXY(spalte+1,zeile+1); Write('');
   end
  end;


 begin
 ta:=TextAttr;
 titel:=keys[0]; titel:=titel+RptStr(Length(titel),'');
 TextColor(DarkGray); TextBackGround(ColorBox);
 GoToXY(spalte,zeile);             Write(''+titel+'Ŀ');
 for i:=1 to anz*KeyStep-1 do
  begin GoToXY(spalte,zeile+i);    Write('         '); end;
 GoToXY(spalte,zeile+anz*KeyStep); Write('');

 for i:=1 to anz do
  begin
  GoToXY(spalte+1,zeile+(i-1)*KeyStep+1); Write(StrI(i mod 10,1));
  PlotKeyZS(zeile+(i-1)*KeyStep+1,spalte+3,keys[i],FALSE);
 end;

 fertig:=false;
 while not fertig do
  begin
  ch:=ReadKey;
  case ch of
   #0: begin
       tastcode:=0;
       if keypressed then begin
                          tastcode:=Ord(ReadKey);
                          case tastcode of
                           59..68: tastcode:=tastcode-58;
                           84..93: tastcode:=tastcode-73;
                          end;
                          end;
       fertig:=true;
       if tastcode in [1..10] then taste:=tastcode;
       end;
  end;
  end;
 PlotKeyZS(zeile+(taste-1)*KeyStep+1,spalte+3,keys[taste],TRUE);
 TextAttr:=ta;
 end;

begin
end.