unit JS_PLOT;


Interface

Uses
 graph,dos,crt,js_sub,js_acc,js_tio,js_koor,
 js_mtr,js_mat,js_gra;

Const
 XShw= 100; YShw= 50;

Type
 PltFkt_T = function(x:Real;nr:Integer):Real;
 PltPar_T = Array [1..9] of Real;

Var
 PfadePfad,PfadeRdDflt,PfadeRdDatei,PfadeSvDatei: PathStr;
 KoorPfad, KoorRdDflt, KoorRdDatei, KoorSvDatei:  PathStr;
 FarbePfad,FarbeRdDflt,FarbeRdDatei,FarbeSvDatei: PathStr;
 PtbPfad,              PtbRdDatei:                PathStr;
 EditorPfad: PathStr;


 KoorColor:    Word;
 BeschrColor:  Word;

 Von, Bis:       Real;
 Steps:          Integer;
 FktNr:          Integer;
 PltPar:         PltPar_T;
 LineColor:      Word;
 LineArt:        Integer;
 IncColor:       Boolean;
 IncLnArt:       Boolean;
 AbZeile:        Integer;
 XSpalte:        Integer;
 YSpalte:        Integer;
 XMove:          Real;
 XAnf:           Real;
 Xdel:           Real;


procedure PfadeInitPlt(PfadeMaske:MskPar_T);
procedure ColorInitPlt(FarbeMaske:MskPar_T);
procedure ShowPar;
procedure PlotFkt(PltFkt:PltFkt_T);
procedure PlotTab(PtbRdDatei:PathStr);
procedure PlotHist(PtbRdDatei:PathStr);


Implementation

procedure PfadeInitPlt(PfadeMaske: MskPar_T);
 begin
 KoorPfad:=     PfadeMaske.erg[ 1];
 KoorRdDflt:=   PfadeMaske.erg[ 2];
 FarbePfad:=    PfadeMaske.erg[ 3];
 FarbeRdDflt:=  PfadeMaske.erg[ 4];
 PtbPfad:=      PfadeMaske.erg[ 5];
 EditorPfad:=   PfadeMaske.erg[ 6];

 KoorRdDatei:=   KoorRdDflt;
 FarbeRdDatei:=  FarbeRdDflt;
 end;


procedure ColorInitPlt(FarbeMaske:MskPar_T);
 Var i:Word; s:String; wert:Real;
 begin
 DskTpColor[0]:=     ColorFromStr(FarbeMaske.erg[1]);
 DskTpColor[1]:=     ColorFromStr(FarbeMaske.erg[2]);
 KoorColor:=         ColorFromStr(FarbeMaske.erg[3]);
 LineColor:=         ColorFromStr(FarbeMaske.erg[4]);
 LineArt:=           ValI(Trim(FarbeMaske.erg[5]));
 Steps:=             ValI(Trim(FarbeMaske.erg[6]));
 end;


procedure ShowPar;
 Const ChrHght=10;
       L1='   ';
       L2=' = ';
 Var   i:Word;
       ta:Byte;
 begin
 ta:=TextAttr;
 TextBackGround(LightGray); TextColor(Black);

 RahmenXYG(XShw,YShw,23*ChrPtch,13*ChrHght);
 writeXYG(XShw+2*ChrPtch,YShw+ChrHght,'Parameter      Wert');
 for i:=1 to 9 do
 writeXYG(XShw+2*ChrPtch,YShw+(2+i)*ChrHght,L1+'A'+StrI(i,1)+L2+StrR(PltPar[i],11,3));

 TextAttr:=ta;
 end;


procedure PlotFkt(PltFkt:PltFkt_T);
 Var    x,xDel,xFak: Real;
 begin
 if Koor.logx then xFak:=XHochY(Bis/Von,1/Steps)
              else xDel:=(Bis-Von)/Steps;
 x:=Von;
 SetV(x,PltFkt(x,FktNr),v); LMoveToV(v);
 repeat
  if Koor.logx then x:=x*xFak
               else x:=x+xDel;
  SetV(x,PltFkt(x,FktNr),v); LLineToV(v);
 until x>Bis;
 end;



procedure PlotTab(PtbRdDatei:PathStr);
 Var
  f:Text; s:String;
  n:Integer;
  strt:Boolean;

 begin
 Assign(f,PtbRdDatei); {$I-} Reset(f); {$I+} OK:=(IOResult=0);

 if OK then
  begin
  n:=0; strt:=True;
  while not Eof(f) do
   begin
   readln(f,s);
   if s[1]<>'*' then
    begin
    Inc(n);
    if n>=AbZeile then
     begin
     GetPar(s);
     SetV(ValR(Trim(ParStr(XSpalte)))+XMove,ValR(Trim(ParStr(YSpalte))),v);
     if strt then begin LMoveToV(v); strt:=False; end
     else LLineToV(v);
     end;
    end;
   end;
  Close(f);
  end;
 end;


procedure PlotHist(PtbRdDatei:PathStr);
 Var
  f:Text; s:String;
  n:Integer; x:Real;

 begin
 Assign(f,PtbRdDatei); {$I-} Reset(f); {$I+} OK:=(IOResult=0);

 if OK then
  begin
  n:=0; x:=XAnf;
  while not Eof(f) do
   begin
   readln(f,s);
   if s[1]<>'*' then
    begin
    Inc(n);
    if n>=AbZeile then
     begin
     GetPar(s);
     SetV(x,0,v);                           LMoveToV(v);
     SetV(x,ValR(Trim(ParStr(YSpalte))),v); LLineToV(v);
     x:=x+Xdel;
     end;
    end;
   end;
  Close(f);
  end;
 end;


begin
end.