unit JS_STM;


Interface

Uses
 dos,crt,graph,js_gra,js_sub,js_tio,js_acc,js_mtr,js_koor,js_mat,
 js_glbw,matrix,js_zepas;

Const
 AnzElemMod=50;
 XGet= 20; YGet=300;
 XMss= 50; YMss= 50;
 XShw= 50; YShw= 50;
 ClassColor: array [0..12] of Word =(4,2,1,3,5,6,12,10,9,11,13,14,0);
 AnzFldsStat=50;

 AnzIntv=100;
 XAnf   =-0.5;
 XEnd   =+1.5;
 XDel   =(XEnd-XAnf)/AnzIntv;
 Fak    =1/XDel;



Type
 ClCntRec_T = record
               class: Char;
               count: Word;
               akzri: Word;
               akzfa: Word;
               rejri: Word;
               rejfa: Word;
              end;

 ClCnt_T = record
            anz: Word;
            anzclasses: Word;
            cnt: array [1..AnzElemMod] of ClCntRec_T;
           end;

 ModRec_T = record
             class: Char;
             cprob: Real;
             anzsc: Word;
             sbcls: Char;
             scprb: Real;
             meanx: Real;
             meany: Real;
             alpha: Real;
             eigv1: Real;
             eigv2: Real;
            end;

 StMod_T = record
            anz,anzcl: Word;
            tab: array [1..AnzElemMod] of ModRec_T;
           end;


 ModParRec_T = record
                class,sbcls: Char;
                apr,sumapr: Real;
                pmax,dmax: Real;
                cen: Vector_2;
                trm: Matrix_2;
                kov: Matrix_2;
                det: Real;
                ikv: Matrix_2;
                color: Word;
               end;

 ModPar_P = ^ModPar_T;
 ModPar_T = record
             anz: Word;
             par: array [1..AnzElemMod] of ModParRec_T;
            end;

 SetChar_T = Set of Char;

 MomRec_T = record
             class: Char;
             count: Word;
             aprio: Real;
             matrx: Matrix_6;
            end;

 MomDat_P = ^MomDat_T;
 MomDat_T = record
             anz: Word;
             dat: array [1..AnzElemMod] of MomRec_T;
            end;

 ClsLst_T = array [1..AnzElemMod] of Char;

 MomMat_P = ^MomMat_T;
 MomMat_T = record
             anz:    Word;
             clslst: ClsLst_T;
             mm:     array [0..5+AnzElemMod,0..5+AnzElemMod] of Real;
            end;

 RzpRec_T = record
             zeigr: Word;
             anzsc: Word;
             class: Char;
             cprob: Real;
             sbcls: Char;
             scprb: Real;
             name:  String[12];
            end;

 RzpDat_T = record
             anz:   Word;
             anzcl: Word;
             dat:   array [1..AnzElemMod] of RzpRec_T;
            end;

 Strat_T = (no,ms,lu);

 KlfRec_T = record
             class: Char;
             eqtyp: String[3];             {Typ der Gleichung bei PKL,PKX}
             cmpcl: Char;                  {Komplementrklasse           }
             koeff: array [1..10] of Real;
            end;

 KlfDat_T = record
             typ: String[3];
             anz: Word;
             dat: array [1..AnzElemMod] of KlfRec_T;
            end;

 DVkt_T   = array[1..AnzelemMod] of Real;

 ErkErg_T = record
             anz:     Word;
             class:   Char;
             radqcls: Real;
             radqnxt: Real;
             clnr: array[1..AnzelemMod] of Word;
             labl: ClsLst_T;
             glbw: DVkt_T;
             dvkt: DVkt_T;
            end;

 Statistik_T = record
                anzsmpl: Word;
                feld:  array [1..AnzFldsStat,1..2] of Word;
                radst: array [1..AnzFldsStat,1..4] of Word;
               end;

 GlbwRec_T = record
              class:   Char;
              cmpcl:   Char;                  {bei PKL Komplementrklasse}
              param:   ParGlbwMod_T;
              outlfrm: Array [1..2] of Real;
              outloth: Array [1..2] of Real;
              outleig: Array [1..2] of Real;
             end;

 GlbwDat_T = record
              typ: String[3];
              anz: Word;
              dat: array [1..AnzElemMod] of GlbwRec_T;
             end;



Var
 PfadePfad,PfadeRdDflt,PfadeRdDatei,PfadeSvDatei: PathStr;
 KoorPfad, KoorRdDflt, KoorRdDatei, KoorSvDatei:  PathStr;
 StModPfad,StModRdDflt,StModRdDatei,StModSvDatei: PathStr;
 FarbePfad,FarbeRdDflt,FarbeRdDatei,FarbeSvDatei: PathStr;
 StchpPfad,StchpRdDflt,StchpRdDatei,StchpSvDatei: PathStr;
 DVektPfad,            DvektRdDatei,DVektSvDatei: PathStr;
 MomPfad,              MomRdDatei,  MomSvDatei:   PathStr;
 RzpPfad,              RzpRdDatei:                PathStr;
 KlfPfad,              KLfRdDatei,  KlfSvDatei:   PathStr;
 ZKlfPfad,             ZKLfRdDatei:               PathStr;
 ZRdbPfad,             ZRdbRdDatei:               PathStr;
 CnfPfad,              CnfRdDatei,  CnfSvDatei:   PathStr;
 StatPfad,             StatRdDatei, StatSvDatei:  PathStr;
                   RadStaRdDatei, RadStaSvDatei:  PathStr;
 EditorPfad: PathStr;

 ModPar: ModPar_P;
 MomDat: Momdat_P;
 MomMat: MomMat_P;
 RzpDat: RzpDat_T;
 KlfDat: KlfDat_T;
 ErkErg: ErkErg_T;

 KoorColor:              Word;
 HauptachsenColor:       Word;
 HauptachsenLnWdth:      Word;
 EllipsenColor:          Word;
 EllipsenTyp:            Char;
 EllipsenAnz:            Word;
 Ellipsenwert:           Array[1..6] of Real;
 ModellGrenzenColor:     Word;
 ModellGrenzenLineStyle: Word;
 DFunktColor:            Word;
 DFunktLineStyle:        Word;
 QMKGrenzenColor:        Word;
 QMKGrenzenLineStyle:    Word;
 RelevanteGrenzen:       Boolean;
 HyperbelStep:           Real;

 PltSmpl:           Byte;
 SmplSrcMod:        Boolean;
 SmplZykl:          Boolean;
 SmplCount:         Boolean;
 SmplMom:           Boolean;
 WrSmpl:            Boolean;
 WrDVkt:            Boolean;
 EmpModActive:      Boolean;
 EmpModFertig:      Boolean;
 SmplNr:            Word;
 SmplClass:         Char;
 SmplColor:         Word;
 StchpRdFile:       Text;
 StchpSvFile:       Text;
 DVektSvFile:       Text;
 StAnz:             LongInt;
 StchpEnde:         Boolean;

 ClCnt:             ClCnt_T;

 ClSlct:            SetChar_T;

 MomMatFertig:      Boolean;
 Strat:             Strat_T;
 MinDiag:           Real;
 DsplMom:           Boolean;

 KlfDatFertig:      Boolean;
 ZKlfDatFertig:     Boolean;
 ZRdbDatFertig:     Boolean;
 Classify:          Boolean;
 DsplErkErg:        Boolean;
 SnglStp:           Boolean;

 OutlSchw:          Real;
 GlbwSchw:          Real;
 RadqSchw:          Real;
 Block:             Integer;
 SlctCode:          Integer;

 Statistik:         Statistik_T;
 AkkStat:           Boolean;
 Statistikfertig:   Boolean;
 StatColor:         Word;
 StatLineStyle:     Integer;
 MeanGlbw:          DVkt_T;
 ShMeanGlbw:        Boolean;
 RadKriterium:      Boolean;

 StchpSrc:          PathStr;
 KlfSrc:            PathStr;
 BeschrColor:       Word;

 Index1,Index2:     Word;
 Stchp40:           Boolean;

 GlbwDat:           GlbwDat_T;
 GlbwDatFertig:     Boolean;
 ClsLst:            ClsLst_T;
 KlAnz:             Word;
 CnfMap:            Boolean;

 RhoColor:          Word;
 EpsColor:          Word;

 RandSeedInit:      Integer;


 ModeKlf:           (stm,nnt,zep);
 Klf:               ClfDat_P;
 Psl:               PslDat_T;
 Koeff:             PMatrix;
 RdbDat:            RdbDat_P;
 RadBas:            Boolean;
 RdbFak:            Real;
 RdbTyp:            RdbTyp_T;


procedure PfadeInitStm(PfadeMaske: MskPar_T);

procedure LoadStMod(StModFile:PathStr; Var StMod:StMod_T; Var OK:Boolean);
procedure SaveStMod(StModFile:PathStr; StMod:StMod_T; Var OK:Boolean);

procedure StModInit(StMod:StMod_T);
procedure ProjWV(nr:Word; w:Vector_2; Var v:Vector_2);
procedure PlotHauptAchse(nr:Word);
procedure PlotAequivElli(nr:Word; q:Real);

procedure PlotGrenzGerade(nr1,nr2:Word; a0:Real; a:Vector_2; Chck:ChckF_T);
procedure PlotGrenzEllipse(nr1,nr2:Word; trm:Matrix_2; cen:Vector_2; Chck:ChckF_T);
procedure PlotGrenzHyperbel(nr1,nr2:Word; trm:Matrix_2; cen:Vector_2; typ:Byte; step,aa,bb:Real; Chck:ChckF_T);
procedure PlotModellGrenze(nr1,nr2:Word);

procedure EditClassColorG(x,y:Integer; Var ModPar:ModPar_P);
procedure EditAPrioG(x,y:Integer; Var StMod:StMod_T);

procedure ColorInitStm(FarbeMaske:MskPar_T);

function  PltSmplStr(PltSmpl:Byte):String;

procedure GetNxtSmpl(Var v:Vector_2; Var StchpEnde:Boolean);

procedure GetSelectCode(Var SlctCode:Integer);

procedure ClrClCnt;
procedure CountClasses;
procedure ShwClCnt;

procedure SetFromStr(s:String; Var ClSlct:SetChar_T);
function  SetToStr(ClSlct:SetChar_T):String;

procedure ClearMom;
procedure AkkumMom;
procedure CmpltMom;
procedure MakeEmpMod(Var EmpMod:StMod_T);

procedure SaveMom(MomSvDatei:PathStr; Mom:MomRec_T; Var OK:Boolean);
procedure LoadMom(MomLdDatei:PathStr; Var Mom:MomRec_T; Var OK:Boolean);
procedure ShowMom(Mom:MomRec_T);
procedure SaveEmpMod(MomSvDatei:PathStr; MomDat:MomDat_P; Var OK:Boolean);
procedure GenMom(MomSvDatei:PathStr; ModPar:ModPar_P; OK:Boolean);

procedure LoadRezept(RzpRdDatei:PathStr; Var RzpDat:RzpDat_T; OK:Boolean);
procedure ClearMomMat(Var MomMat:MomMat_P);
procedure MakeMomMat(RzpDat:RzpDat_T; MomPfad:PathStr; Var MomMat:MomMat_P; Var OK:Boolean);
procedure ShowMomMat(MomMat:MomMat_P);
procedure Regre(MomMat:MomMat_P; Strat:Strat_T; MinDiag:Real; VAR KlfDat:KlfDat_T);
procedure NvtRefClssfr(ModPar:ModPar_P; Var KlfDat:KlfDat_T);
procedure SaveKlf(KlfSvDatei:PathStr; KlfDat:KlfDat_T; Var OK:Boolean);
procedure LoadKlf(KlfRdDatei:PathStr; Var KlfDat:KlfDat_T; Var OK:Boolean);
procedure MakePkl(RzpDat:RzpDat_T; MomPfad:PathStr; Var KlfDat:KlfDat_T; Var OK:Boolean);

function  GlaubwS(d,s:Real):Real;
function  Glaubw(d:Real; anz:Integer; mwerteigen,sigmaeigen,mwertfremd,sigmafremd:Real):Real;
function  BwrtFkt(x:Real):Real;
procedure DVekt(KlfDat:KlfDat_T; v:Vector_2; SmplClass:Char; Var ErkErg:ErkErg_T);
procedure DVektZep(Psl:PslDat_T; Cls:ClsLst_T; Koeff:PMatrix; v:Vector_2; SmplClass:Char; Var ErkErg:ErkErg_T);

function  Quality(ErkErg:ErkErg_T):Byte;
procedure ShowErkErg(ErkErg:ErkErg_T);
procedure ShowMeanGlbw(MeanGlbw:Dvkt_T);

procedure PlotQfkt(KlfVkt:KlfRec_T; q:Real);
procedure PlotQMKGrenze(nr1,nr2:Word);

procedure PlotClassRegions(KlfDat:KlfDat_T);
procedure PlotClassBorders(KlfDat:KlfDat_T);

procedure ClearStatistik;
procedure AkkumStatistik;
procedure SaveStatistik(StatSvDatei:PathStr; OK:Boolean);
procedure LoadStatistik(StatRdDatei:PathStr; OK:Boolean);
procedure PlotEpsAlt;
procedure PlotEps;
procedure PlotAlt;

procedure LoadRadSta(RadStaRdDatei:PathStr; OK:Boolean);
procedure SaveRadSta(RadStaSvDatei:PathStr; OK:Boolean);

procedure PlotRadStaRho;
procedure PlotRadStaEps;
procedure PlotRadStaEpsRho;
procedure PlotRadStaAlle;
procedure PlotRadStaFal1;

procedure ClsLstFromKlfDat(KlfDat:KlfDat_T; Var ClsLst:ClsLst_T; Var KlAnz:Word);
procedure ClSlctFromClsLst(ClsLst:ClsLst_T; Klanz:Word; Var ClSlct:SetChar_T);

procedure RdVersion40(Var StchpRdFile:Text; Var SmplClass:Char; Var SmplNr:Word; Index1,Index2:Word; Var v:Vector_2);

procedure LoadGlbw(CnfRdDatei:PathStr; Var OK:Boolean);
function  CheckCompatKlfCnf:Boolean;


Implementation

procedure Titel(s:String);
 Var
  savecolor:Word;
  tp:TextSettingsType;
  i:Integer;
 begin
 savecolor:=GetColor;
   SetColor(Red);
   GetTextSettings(tp);
     SetTextJustify(0,2);
     SetTextStyle(TriplexFont,HorizDir,8);
     for i:=0 to 3 do OutTextXY(50+i,120,s);
   SetTextStyle(tp.Font,tp.Direction,tp.CharSize);
   SetTextJustify(tp.Horiz,tp.Vert);
 SetColor(savecolor);
 end;

procedure PfadeInitStm(PfadeMaske: MskPar_T);
 begin
 KoorPfad:=   PfadeMaske.erg[ 1];
 KoorRdDflt:= PfadeMaske.erg[ 2];
 StModPfad:=  PfadeMaske.erg[ 3];
 StModRdDflt:=PfadeMaske.erg[ 4];
 FarbePfad:=  PfadeMaske.erg[ 5];
 FarbeRdDflt:=PfadeMaske.erg[ 6];
 StchpPfad:=  PfadeMaske.erg[ 7];
 StchpRdDflt:=PfadeMaske.erg[ 8];
 DVektPfad:=  PfadeMaske.erg[ 9];
 MomPfad:=    PfadeMaske.erg[10];
 RzpPfad:=    PfadeMaske.erg[11];
 KlfPfad:=    PfadeMaske.erg[12];
 ZKlfPfad:=   PfadeMaske.erg[13];
 ZRdbPfad:=   PfadeMaske.erg[14];
 CnfPfad:=    PfadeMaske.erg[15];
 StatPfad:=   PfadeMaske.erg[16];
 EditorPfad:= PfadeMaske.erg[17];

 KoorRdDatei:= KoorRdDflt;
 StModRdDatei:=StModRdDflt;
 FarbeRdDatei:=FarbeRdDflt;
 StchpRdDatei:=StchpRdDflt;
 end;


procedure LoadStMod(StModFile:PathStr;
                    Var StMod:StMod_T;
                    Var OK:Boolean);

 Const dontcare='-';
 Var f:Text; s,cs:String; anzsbcl:Word; lastcl:Word;

 begin
 Assign(f,StModFile); {$I-} Reset(f); {$I+} OK:=(IOResult=0);
 if OK then with StMod do
  begin
  anz:=0; anzcl:=0; lastcl:=1;
  repeat
   readln(f,s);
   if (s[1]<>'*') and not Leer(s) then
    begin
    GetPar(s);
    if ParCount<>9 then OK:=False
     else begin
          cs:=Trim(ParStr(1));
          if (anz<>0) or (cs<>dontcare) then
           begin
           Inc(anz);
           if cs=dontcare then Inc(anzsbcl)
                          else begin
                               tab[lastcl].anzsc:=anzsbcl;
                               anzsbcl:=1;
                               lastcl:=anz;
                               Inc(anzcl);
                               end;
           with tab[anz] do
            begin
            class:=cs[1];
            cprob:=ValR(ParStr(2));
            cs:=Trim(ParStr(3));
            sbcls:=cs[1];
            scprb:=ValR(ParStr(4));
            meanx:=ValR(ParStr(5));
            meany:=ValR(ParStr(6));
            alpha:=ValR(ParStr(7));
            eigv1:=ValR(ParStr(8));
            eigv2:=ValR(ParStr(9));
            end;
           end;
          end;
    end;
  until Eof(f);
  tab[lastcl].anzsc:=anzsbcl;
  Close(f);
  end;
 end;


procedure SaveStMod(StModFile:PathStr; StMod:StMod_T; Var OK:Boolean);

 Const
 s1='*  Class    Prob  SbClass   Prob   MeanX   MeanY   Alpha   EigVal1   EigVal2';
 s2='* --------------------------------------------------------------------------';

 Const spc7='       '; dontcare='-';
 Var   f:text; cprob_s,scprb_s:string; i:Word;

 begin
 Assign(f,StModFile); {$I-} Rewrite(f); {$I+} OK:=(IOResult=0);
 if OK then with StMod do 
  begin
  writeln(f,s1);
  writeln(f,s2);
  for i:=1 to anz do with tab[i] do
   begin
   if class=dontcare then cprob_s:=spc7+dontcare
                     else Str(cprob:8:3,cprob_s);
   writeln(f,spc7,class,
             cprob_s,
             spc7,sbcls,
             scprb:8:3,
             meanx:8:3,
             meany:8:3,
             alpha:8:3,
             eigv1:10:3,
             eigv2:10:3);
   end;
  Close(f);
  end;
 end;


procedure ModellInit(ModRec:ModRec_T; Var ModParRec:ModParRec_T);
 Var b,bt,d,m:Matrix_2; 
 begin
 with ModRec do
  begin
  SetV(meanx,meany,ModParRec.cen);
  RotM(alpha,b);
  DiaM(eigv1,eigv2,d);
  SqrtMd(d,m); MulMM(b,m,ModParRec.trm);
  TrpM(b,bt); MulMM(b,d,m); MulMM(m,bt,ModParRec.kov);
  InvM(ModParRec.kov,ModParRec.ikv);
  ModParRec.det:=eigv1*eigv2;
  end;
 end;


procedure StModInit(StMod:StMod_T);

 Const
  dontcare='-';
 Var
  i,j:Word; clsprb,prb,sum:Real; cls:Char;
 begin
 with StMod do
  begin
  ModPar^.anz:=anz;
  cls:=dontcare; clsprb:=1;
  sum:=0; j:=0;
  for i:=1 to anz do with tab[i] do
   begin
   if class<>dontcare then begin
                           cls:=class;
                           clsprb:=cprob;
                           Inc(j);
                           end;
   ModPar^.par[i].class:=cls;
   ModPar^.par[i].sbcls:=sbcls;
   prb:=clsprb*scprb;
   sum:=sum+prb;
   ModPar^.par[i].apr:=prb;
   ModPar^.par[i].sumapr:=sum;
   ModellInit(tab[i], ModPar^.par[i]);
   ModPar^.par[i].pmax:=1/(2*Pi*Sqrt(ModPar^.par[i].det));
   ModPar^.par[i].dmax:=ModPar^.par[i].apr*ModPar^.par[i].pmax;
   ModPar^.par[i].color:=Classcolor[(j-1) mod 12];
   end;
  end;
 end;


procedure ProjWV(nr:Word; w:Vector_2; Var v:Vector_2);
 Var v1:Vector_2;
 begin
 with ModPar^.par[nr] do
  begin MulMV(trm,w,v1); AddVV(cen,v1,v); end;
 end;

procedure PlotHauptAchse(nr:Word);
 Const anzsteps=50; step=2/anzsteps;
 Var i:Word; w,v,v1,v2,wstep:Vector_2;
 begin
 if Koor.logx or Koor.logy then
  begin
  MulSV(step,einhvx,wstep);
  MulSV(-1,einhvx,w); ProjWV(nr,w,v); MoveToV(v);
  for i:=1 to anzsteps do
   begin AddVV(w,wstep,w); ProjWV(nr,w,v); LineToV(v); end;
  MulSV(step,einhvy,wstep);
  MulSV(-1,einhvy,w); ProjWV(nr,w,v); MoveToV(v);
  for i:=1 to anzsteps do
   begin AddVV(w,wstep,w); ProjWV(nr,w,v); LineToV(v); end;
  end
 else
  begin
  MulSV(-1,einhvx,w); ProjWV(nr,w,v1); ProjWV(nr,einhvx,v2); LineV(v1,v2);
  MulSV(-1,einhvy,w); ProjWV(nr,w,v1); ProjWV(nr,einhvy,v2); LineV(v1,v2);
  end;
 end;


procedure PlotAequivElli(nr:Word; q:Real);
 Const anzsteps=100; step=2*Pi/anzsteps;
 Var i:Word; h,t:Real; w,v:Vector_2;
 begin
 h:=sqrt(q);
 t:=0; SetV(h*cos(t),h*sin(t),w); ProjWV(nr,w,v); LMoveToV(v);
 for i:=1 to anzsteps do
  begin
  t:=t+step; SetV(h*cos(t),h*sin(t),w); ProjWV(nr,w,v); LLineToV(v);
  end;
 end;


function  ChckPltNvt(x,y:Integer;nr1,nr2:Word):Boolean;
 Const eps=1.0E-30;
 Var i:Word; wertbrdr:Real; v:Vector_2;
 begin                                                 
 ChckPltNvt:=True;
 SetV(XFInv(XSInv(x)),YFInv(YSInv(y)),v);
 with ModPar^ do
  begin
  wertbrdr:=par[nr1].apr*WdNvtV(par[nr1].ikv,par[nr1].pmax,par[nr1].cen,v);
  for i:=1 to anz do
   if (ClSlct=[]) or (par[i].class in ClSlct) then
    begin
    if (i<>nr1) and (i<>nr2) then
     if not (wertbrdr-par[i].apr*WdNvtV(par[i].ikv,par[i].pmax,par[i].cen,v)>eps) then
      begin ChckPltNvt:=False; Exit; end;
    end;
  end;
 end;


procedure PlotGrenzGerade(nr1,nr2:Word; a0:Real; a:Vector_2; Chck:ChckF_T);

 Var   v1,v2:Vector_2;
       a1,a2:Real;
       xl,xr,yu,yo:Real;
       flu,flo,fro,fru:Real;
       found1,found2:Boolean;
 
 begin
 xl:=Koor.lmtl; xr:=Koor.lmtr;
 yu:=Koor.lmtu; yo:=Koor.lmto;
 a1:=a[1]; a2:=a[2];

 flu:=a0+a1*xl+a2*yu;
 flo:=a0+a1*xl+a2*yo;
 fro:=a0+a1*xr+a2*yo;
 fru:=a0+a1*xr+a2*yu;

 found1:=False; found2:=False;

 if Sign(flu)<>Sign(flo) then begin
                              found1:=True;
                              SetV(xl,-(a0+a1*xl)/a2,v1);
                              end;
 if Sign(flo)<>Sign(fro) then
               if found1 then begin
                              found2:=True;
                              SetV(-(a0+a2*yo)/a1,yo,v2);
                              end
                         else begin
                              found1:=True;
                              SetV(-(a0+a2*yo)/a1,yo,v1);
                              end;
 if not found2
    and (Sign(fro)<>Sign(fru)) then
               if found1 then begin
                              found2:=True;
                              SetV(xr,-(a0+a1*xr)/a2,v2);
                              end
                         else begin
                              found1:=True;
                              SetV(xr,-(a0+a1*xr)/a2,v1);
                              end;
 if (not found2) and found1
    and (Sign(fru)<>Sign(flu)) then
                              begin
                              found2:=True;
                              SetV(-(a0+a2*yu)/a1,yu,v2);
                              end;
 if found2 then begin
                LMoveToVChck(v1,nr1,nr2,Chck);
                if RelevanteGrenzen then LLineToVChck(v2,nr1,nr2,Chck)
                                    else LLineToV(v2);
               end;
 end;


procedure PlotGrenzEllipse(nr1,nr2:Word; trm:Matrix_2; cen:Vector_2; Chck:ChckF_T);

 Var i:Word; t,tanf,tend:Real; found:Boolean;
     w,v:Vector_2;

 procedure ProjWV(w:Vector_2; Var v:Vector_2);
  Var v1:Vector_2;
  begin MulMV(trm,w,v1); AddVV(cen,v1,v); end;

 procedure Find(Var found:Boolean; t:Real; Var tanf,tend:Real);
  Const anzsteps=100; step=2*Pi/anzsteps;
  Var i:Integer; foundend:Boolean;
  begin
  found:=False; foundend:=False;
  tanf:=t; SetV(cos(t),sin(t),w); ProjWV(w,v);
  if ChckInFldV(v) then found:=True; 
  repeat
   t:=t+step; SetV(cos(t),sin(t),w); ProjWV(w,v);
   if not found then
     if not ChckInFldV(v) then tanf:=t else found:=True
   else
     if not foundend then
       if ChckInFldV(v) then tend:=t
                        else begin tend:=t; foundend:=True; end;
  until foundend or (t>2*Pi);
  if not foundend then tend:=t;
  end;

 procedure Plot(tanf,tend:Real);
  Const anzsteps=50;
  Var tdelt:Real; i:Integer;
  begin
  tdelt:=(tend-tanf)/anzsteps;
  t:=tanf; SetV(cos(t),sin(t),w); ProjWV(w,v); 
  if RelevanteGrenzen then LMoveToVChck(v,nr1,nr2,Chck)
                      else LMoveToV(v);
  for i:=1 to anzsteps do
   begin
   t:=t+tdelt; SetV(cos(t),sin(t),w); ProjWV(w,v);
   if RelevanteGrenzen then LLineToVChck(v,nr1,nr2,Chck)
                       else LLineToV(v);
   end;
  end;

 begin
 t:=0;

 repeat
  Find(found,t,tanf,tend);
  if found then Plot(tanf,tend);
  t:=tend;
 until t>=2*PI;

 end;


procedure PlotGrenzHyperbel(nr1,nr2:Word; trm:Matrix_2; cen:Vector_2; typ:Byte; step,aa,bb:Real; Chck:ChckF_T);

 Const anzsteps=100;
 Var   i:Word; t,such,tanf,tend:Real; found:Boolean;
       w,v:Vector_2;
     
 procedure ProjWV(w:Vector_2; Var v:Vector_2);
  Var v1:Vector_2;
  begin MulMV(trm,w,v1); AddVV(cen,v1,v); end;

 procedure WVonT(n:Integer; t:Real; Var w:Vector_2);
  begin
  case n of
   1: SetV( Cosh(t), Sinh(t),w);
   2: SetV(-Cosh(t), Sinh(t),w);
   3: SetV( Sinh(t), Cosh(t),w);
   4: SetV( Sinh(t),-Cosh(t),w);
  end;
  end;

  procedure Find(n:integer; Var found:Boolean; t:Real; Var tanf,tend:Real);
  Var i:Integer; foundend:Boolean;
  begin
  found:=False; foundend:=False;
  tanf:=t; WVonT(n,t,w); ProjWV(w,v);
  if ChckInFldV(v) then found:=True;
  repeat
   t:=t+step; WVonT(n,t,w); ProjWV(w,v);
   if not found then
     if not ChckInFldV(v) then tanf:=t else found:=True
   else
     if not foundend then
       if ChckInFldV(v) then tend:=t
                        else begin tend:=t; foundend:=True; end;
  until foundend or (t>such);
  if not foundend then tend:=t;
  end;

 procedure Plot(n:Integer; tanf,tend:Real);
  Var tdelt:Real; i:Integer;
  begin
  tdelt:=(tend-tanf)/anzsteps;
  t:=tanf; WVonT(n,t,w); ProjWV(w,v);
  if RelevanteGrenzen then LMoveToVChck(v,nr1,nr2,Chck)
                      else LMoveToV(v);
  for i:=1 to anzsteps do
   begin
   t:=t+tdelt; WVonT(n,t,w); ProjWV(w,v);
   if RelevanteGrenzen then LLineToVChck(v,nr1,nr2,Chck)
                       else LLineToV(v);
   end;
  end;

 begin
 such:=anzsteps*step;
 case typ of
  1: {W1 ist Achse}
     begin
     t:=-such;
     repeat
      Find(1,found,t,tanf,tend);
      if found then Plot(1,tanf,tend);
      t:=tend;
     until t>=such;
     t:=-such;
     repeat
      Find(2,found,t,tanf,tend);
      if found then Plot(2,tanf,tend);
      t:=tend;
     until t>=such;
     end;
  2: {W2 ist Achse}
     begin
     t:=-such;
     repeat
      Find(3,found,t,tanf,tend);
      if found then Plot(3,tanf,tend);
      t:=tend;
     until t>=such;
     t:=-such;
     repeat
      Find(4,found,t,tanf,tend);
      if found then Plot(4,tanf,tend);
      t:=tend;
     until t>=such;
     end;
 end;
 end;


procedure PlotModellGrenze(nr1,nr2:Word);
 Var imm,mm,d,b,gtrm:Matrix_2; a,v1,v2,vv,gcen:Vector_2; a0,g0,aa,bb:Real;
 begin
 with ModPar^ do
  begin
  SubMM(par[nr1].ikv,par[nr2].ikv,imm);
  if BetrqM(imm)<1E-12 then
   begin
   SubVV(par[nr1].cen,par[nr2].cen,v1);
   MulMV(par[nr1].ikv,v1,a);
   AddVV(par[nr1].cen,par[nr2].cen,vv);
   a0:=ln(par[nr1].apr/par[nr2].apr)-1/2*SkPVV(vv,a);
   PlotGrenzGerade(nr1,nr2,a0,a,ChckPltNvt);
   end
  else if DetM(imm)<>0 then
   begin
   InvM(imm,mm);
   MulMV(par[nr1].ikv,par[nr1].cen,v1);
   MulMV(par[nr2].ikv,par[nr2].cen,v2);
   SubVV(v1,v2,vv); MulMV(mm,vv,gcen);
   g0:=ln(par[nr1].det/par[nr2].det)-2*ln(par[nr1].apr/par[nr2].apr)
       +Quaf(par[nr1].ikv,par[nr1].cen)
       -Quaf(par[nr2].ikv,par[nr2].cen)
       -Quaf(imm,gcen);
   EigMs(mm,d,b); aa:=-g0*d[1,1]; bb:=-g0*d[2,2];
   DiaM(abs(aa),abs(bb),d);
   SqrtMd(d,gtrm); MulMM(b,gtrm,gtrm);
   if (aa>0) and (bb>0) then PlotGrenzEllipse(nr1,nr2,gtrm,gcen,ChckPltNvt);
   if (aa>0) and (bb<0) then PlotGrenzHyperbel(nr1,nr2,gtrm,gcen,1,HyperbelStep,aa,bb,ChckPltNvt);
   if (aa<0) and (bb>0) then PlotGrenzHyperbel(nr1,nr2,gtrm,gcen,2,HyperbelStep,aa,bb,ChckPltNvt);
  end;
  end;
 end;


procedure EditClassColorG(x,y:Integer; Var ModPar:ModPar_P);
 Const ChrHght=10;
 Var i,hoehe,xx:Word; ta:Byte;
     fertig:Boolean; s:String[12]; cls:Char;
 begin
 with ModPar^ do
  begin
  ta:=TextAttr;
  hoehe:=3+anz;
  TextColor(Black); TextBackGround(LightGray);
  RahmenXYG(x,y,28*ChrPtch,hoehe*ChrHght);
  WriteXYG(x+2*ChrPtch,y+ChrHght,'Klass SbKls Color');
  cls:=' ';
  for i:=1 to anz do with par[i] do
   begin
   if class<>cls then cls:=class
                 else cls:=' ';
   WriteXYG(x+ 2*ChrPtch,y+(i+1)*ChrHght,FillStr(cls,6)+
                                         FillStr(sbcls,6)+
                                         ColorToStr(color));
   end;
  xx:=x+14*ChrPtch;
  i:=1; fertig:=False;
  repeat
   with par[i] do
    begin
    TextBackGround(Cyan);
    s:=ColorToStr(color);
    repeat
     AcceptXYG(xx,y+(i+1)*ChrHght,12,'',ValBu,s,rm);
     color:=ColorFromStr(s);
    until color<>255;
    TextBackGround(LightGray);
    WriteXYG(xx,y+(i+1)*ChrHght,s);
    case rm of
     rtrn: if i=anz then fertig:=True else Inc(i);
     wtr : i:=MinI(Succ(i),anz);
     zrck: i:=MaxI(Pred(i),1);
     pgup: fertig:=True;
     escp: fertig:=True;
    end;
    end;
  until fertig;
  end;
 end;


procedure EditAPrioG(x,y:Integer; Var StMod:StMod_T);

 Const ChrHght=10; spc8='        '; eps=0.0001; dontcare='-';
 Var   i,hoehe:Word; ta:Byte; s:String[8]; cls:Char;
       sum:Real;


 procedure ChkSum(bg,nd,modus:Word);
  Var i:Word; ss:String[13];
  begin
  with StMod do
   begin
   sum:=0;
   case modus of
    0: for i:=bg to nd do sum:=sum+tab[i].cprob;
    1: for i:=bg to nd do sum:=sum+tab[i].scprb;
   end;
   if abs(sum-1.0)>eps then
    begin
    ss:=' ungleich 1.0';
    TextColor(Red);
    WriteXYG(x+2*ChrPtch,y+(hoehe-2)*ChrHght,'Sum'+StrR(sum,7,3)+ss);
    TextColor(Black);
    end
   else
    begin
    ss:='             ';
    WriteXYG(x+2*ChrPtch,y+(hoehe-2)*ChrHght,'Sum'+StrR(sum,7,3)+ss);
    end;
   end;
  end;


 procedure ScPrbEdt(bg,nd:Word);                  
  Var i:Word; fertig:Boolean; xx:Integer;
  begin
  xx:=x+17*ChrPtch;
  with StMod do
   begin
   repeat
    i:=bg; fertig:=False; 
    repeat
     with tab[i] do
      begin
      TextBackGround(Cyan);
      s:=Trim(StrR(scprb,8,3));
      AcceptXYG(xx,y+(i+1)*ChrHght,8,'',ValNu,s,rm);
      TextBackground(LightGray);
      scprb:=ValR(Trim(s));
      WriteXYG(xx,y+(i+1)*ChrHght,StrR(scprb,8,3));
      ChkSum(bg,nd,1);
      case rm of
       rtrn: if i=nd then fertig:=True else Inc(i);
       wtr : i:=MinI(Succ(i),nd);
       zrck: i:=MaxI(Pred(i),bg);
       pgup: fertig:=True;
       escp: fertig:=True;
      end;
      end;
    until fertig;
   until abs(sum-1.0)<eps;
  end;
 end;


 procedure PrbEdt(bg,nd:Word);
  Var i,lasti:Word; fertig:Boolean; xx:Integer;
  begin
  xx:=x+4*ChrPtch;
  with StMod do
   begin
   repeat
    i:=bg; fertig:=False;
    repeat
     with tab[i] do
      begin
      TextBackGround(Cyan);
      s:=Trim(StrR(cprob,8,3));
      AcceptXYG(xx,y+(i+1)*ChrHght,8,'',ValNu,s,rm);
      TextBackground(LightGray);
      cprob:=ValR(Trim(s));
      WriteXYG(xx,y+(i+1)*ChrHght,StrR(cprob,8,3));
      ChkSum(bg,nd,0);
      case rm of
       rtrn: if (i+anzsc-1=nd) then fertig:=True
                               else i:=i+anzsc; 
       wtr : if (i+anzsc-1<nd) then i:=i+anzsc; 
       zrck: if i>bg then repeat i:=Pred(i); until tab[i].class<>dontcare;
       pgdn: if anzsc>1 then ScPrbEdt(i,i+anzsc-1);
       escp: fertig:=True;
      end;
     end;
    until fertig;
   until abs(sum-1.0)<eps;
  end;
  end;



 begin
 with StMod do
  begin
  ta:=TextAttr;
  hoehe:=5+anz;
  TextColor(Black); TextBackGround(LightGray);
  RahmenXYG(x,y,27*ChrPtch,hoehe*ChrHght);
  WriteXYG(x+2*ChrPtch,y+ChrHght,'Klass/Prob   SbKls/Prob');
  for i:=1 to anz do with tab[i] do
   begin
   if class=dontcare then cls:=' '
                     else cls:=class;
   if cprob=0 then s:=spc8 else Str(cprob:8:3,s);
   WriteXYG(x+ 2*ChrPtch,y+(i+1)*ChrHght,cls+' '+s);
   if scprb<1 then begin
                   Str(scprb:8:3,s);
                   WriteXYG(x+15*ChrPtch,y+(i+1)*ChrHght,sbcls+' '+s);
                   end;
   end;
  ChkSum(1,anz,0);

  ovwrt:=True;
  PrbEdt(1,anz);

  TextAttr:=ta;
  end;
 end;

procedure ColorInitStm(FarbeMaske:MskPar_T);
 Var i:Word; s:String; wert:Real;
 begin
 DskTpColor[0]:=     ColorFromStr(FarbeMaske.erg[1]);
 DskTpColor[1]:=     ColorFromStr(FarbeMaske.erg[2]);
 KoorColor:=         ColorFromStr(FarbeMaske.erg[3]);
 if UpCaseWord(FarbeMaske.erg[4])='KLASSE'
  then HauptachsenColor:= 255
  else HauptachsenColor:= ColorFromStr(FarbeMaske.erg[4]);
 HauptachsenLnWdth:= ValI(Trim(FarbeMaske.erg[5]));
 if UpCaseWord(FarbeMaske.erg[6])='KLASSE'
  then EllipsenColor:=    255
  else EllipsenColor:=    ColorFromStr(FarbeMaske.erg[6]);
 s:=UpCaseWord(Trim(FarbeMaske.erg[7]));
 EllipsenTyp:=s[1];
 i:=0;
 wert:=ValR(Trim(FarbeMaske.erg[8+i]));
 while wert<>0 do
  begin
  Inc(i);
  EllipsenWert[i]:=wert;
  wert:=ValR(Trim(FarbeMaske.erg[8+i]));
  end;
 EllipsenAnz:=i;
 ModellGrenzenColor:=     ColorFromStr(FarbeMaske.erg[14]);
 ModellGrenzenLineStyle:= ValI(Trim(FarbeMaske.erg[15]));
 if UpCaseWord(FarbeMaske.erg[16])='KLASSE'
  then DFunktColor:=      255
  else DfunktColor:=      ColorFromStr(FarbeMaske.erg[16]);
 DFunktLineStyle:=        ValI(Trim(FarbeMaske.erg[17]));
 QMKGrenzenColor:=        ColorFromStr(FarbeMaske.erg[18]);
 QMKGrenzenLineStyle:=    ValI(Trim(FarbeMaske.erg[19]));
 end;


function PltSmplStr(PltSmpl:Byte):String;
 Const PStr: array [0..2] of String[6] = (' NOPLT','POIPLT','SYMPLT');
 begin PltSmplStr:=Pstr[PltSmpl]; end;



procedure GetNxtSmpl(Var v:Vector_2; Var StchpEnde:Boolean);
 Var w:Vector_2; zuf:Real; modnr:Word; ch:Char; k:Word; slct:Boolean;
 begin
 if SmplSrcMod then
  begin
  zuf:=Random;
  modnr:=1; while not (zuf<=ModPar^.par[modnr].sumapr) do Inc(modnr);
  NvtV(w); ProjWV(modnr,w,v);
  SmplClass:=ModPar^.par[modnr].class;
  SmplColor:=ModPar^.par[modnr].color;
  Inc(SmplNr);
  end
 else
  begin
  if Eof(StchpRdFile) then
   begin
   if SmplZykl then Reset(StchpRdFile)
   else StchpEnde:=True;
   end;
  if not StchpEnde then
   begin
   if Stchp40 then RdVersion40(StchpRdFile,SmplClass,SmplNr,Index1,Index2,v)
              else ReadLn(StchpRdFile,SmplClass,SmplNr,v[1],v[2]);
   modnr:=1;
   while (not (SmplClass=ModPar^.par[modnr].class)
          and (modnr<ModPar^.anz)) do Inc(modnr);
   SmplColor:=ModPar^.par[modnr].color;
   end;
  end;
 if not StchpEnde then
  if (ClSlct=[]) or (SmplClass in ClSlct) then
   begin
   case PltSmpl of
    1: PlotV(v,SmplColor);
    2: begin
       SetColor(SmplColor);
       PlotSymbV(v,SmplClass);
       end;
   end;

   slct:=True;

   if Classify  then begin
                     case ModeKlf of
                      stm: DVekt(KlfDat,v,SmplClass,ErkErg);
                      zep: DVektZep(Psl,ClsLst,Koeff,v,SmplClass,ErkErg);
                     end;
                     if DsplErkErg then ShowErkErg(ErkErg);
                     slct:=((Quality(ErkErg) and Byte(SlctCode))>0);
                     if WrDVkt and slct then with ErkErg do
                                              begin
                                              Write(DvektSvFile,SmplClass:1,
       		                                                SmplNr:12);
                                              for k:=1 to anz do
                                               Write(DVektSvFile,dvkt[k]:12:6);
                                              WriteLn(DvektSvFile);
                                              end;
                     if AkkStat then AkkumStatistik;
                     end;

   if WrSmpl and slct then WriteLn(StchpSvFile,SmplClass:1,
       		                               SmplNr:12,
                                               v[1]:12:6,
                                               v[2]:12:6);
   if SmplCount then CountClasses;
   if SmplMom   then AkkumMom;

   if KeyPressed or SnglStp then begin
                                 ch:=ReadKey;
                                 case ch of
                                  's','S': Snglstp   :=not Snglstp;
                                  #27:     StchpEnde :=True;
                                  end;
                                 end;

   end;
 end;


procedure GetSelectCode(Var SlctCode:Integer);
 Const ChrHght=10;
       z1='Bilde den Code durch        akz  rej ';
       z2='Aufsummieren aus den   ';
       z3='Werten des Schemas.    ri    1    2  ';
       z4='Selectcode = [1..15]   fa    4    8  ';

 Var ta:Byte; 
 begin
 ta:=TextAttr;
 TextBackGround(LightGray); TextColor(Blue);
 RahmenXYG(XMss,YMss,43*ChrPtch,6*ChrHght);
 WriteXYG(XMss+2*ChrPtch,YMss+  ChrHght,z1);
 WriteXYG(XMss+2*ChrPtch,YMss+2*ChrHght,z2);
 WriteXYG(XMss+2*ChrPtch,YMss+3*ChrHght,z3);
 WriteXYG(XMss+2*ChrPtch,YMss+4*ChrHght,z4);
 OvWrt:=True;
 repeat 
  GetWertI('SelectCode : ',SlctCode)
 until SlctCode in [1..15];
 TextAttr:=ta;
 end;


procedure ClrClCnt;
 begin
 with ClCnt do
  begin
  anz:=0;
  anzclasses:=0;
  end;
 end;


procedure CountClasses;
 Var i:Word; found:Boolean;
 begin
 with ClCnt do
  begin
  Inc(anz);
  found:=False; i:=1;
  while not found and (i<=anzclasses) do with cnt[i] do
   begin
   if SmplClass=class then begin
                           Inc(count);
                           if Classify then case Quality(ErkErg) of
                                             1: Inc(akzri);
                                             2: Inc(rejri);
                                             4: Inc(akzfa);
                                             8: Inc(rejfa);
                                            end;
                           found:=True;
                           end;
   Inc(i);
   end;
  if not found then
   begin
   Inc(anzclasses);
   cnt[anzclasses].count:=1;
   cnt[anzclasses].class:=SmplClass;
   cnt[anzclasses].akzri:=0;
   cnt[anzclasses].akzfa:=0;
   cnt[anzclasses].rejri:=0;
   cnt[anzclasses].rejfa:=0;
   if Classify then case Quality(ErkErg) of
                     1: cnt[anzclasses].akzri:=1;
                     2: cnt[anzclasses].rejri:=1;
                     4: cnt[anzclasses].akzfa:=1;
                     8: cnt[anzclasses].rejfa:=1;
                    end;
   end;
  end;
 end;

procedure ShwClCnt;
 Const ChrHght=10;
 Var   i:Word; ta:Byte; sumakzri,sumakzfa,sumrejri,sumrejfa:Word;
 begin
 ta:=TextAttr;
 TextBackGround(LightGray); TextColor(Black);
 sumakzri:=0; sumakzfa:=0; sumrejri:=0; sumrejfa:=0;
 with ClCnt do
  begin
  RahmenXYG(XShw,YShw,49*ChrPtch,(anzclasses+6)*ChrHght);
  WriteXYG(XShw+2*ChrPtch,YShw+ChrHght,'Class  Count  Akz_Ri  Akz_Fa  Rej_Ri  Rej_Fa');
  for i:=1 to anzclasses do with cnt[i] do
   begin
   WriteXYG(XShw+4*ChrPtch,YShw+(1+i)*ChrHght,class+StrI(count,9)
                                                   +StrI(akzri,8)
                                                   +StrI(akzfa,8)
                                                   +StrI(rejri,8)
                                                   +StrI(rejfa,8));
   sumakzri:=sumakzri+akzri;
   sumakzfa:=sumakzfa+akzfa;
   sumrejri:=sumrejri+rejri;
   sumrejfa:=sumrejfa+rejfa;
   end;
  WriteXYG(XShw+2*ChrPtch,YShw+(2+anzclasses)*ChrHght,'Summe'+StrI(anz,7)
                                                             +StrI(sumakzri,8)
                                                             +StrI(sumakzfa,8)
                                                             +StrI(sumrejri,8)
                                                             +StrI(sumrejfa,8));
  if anz>0 then
   begin
   WriteXYG(XShw+16*ChrPtch,YShw+(3+anzclasses)*ChrHght,'Forced Recogn.   Error: '+StrR((sumakzfa+sumrejfa)/anz,6,3));
   WriteXYG(XShw+16*ChrPtch,YShw+(4+anzclasses)*ChrHght,'Reject: '+StrR((sumrejri+sumrejfa)/anz,6,3)
                                                      +'   Error: '+StrR(sumakzfa/anz,6,3));
   end;
  end;
 TextAttr:=ta;
 end;

procedure SetFromStr(s:String; Var ClSlct:SetChar_T);
 Var p: Byte;
 begin
 s:=Trim(s); ClSlct:=[];
 if UpCaseWord(s)<>'ALLE' then begin
                               for p:=1 to length(s) do
                                if s[p]<>' ' then ClSlct:=ClSlct+[s[p]];
                               end;
 end;

function  SetToStr(ClSlct:SetChar_T):String;
 Var i: Byte; s:String;
 begin
 if ClSlct=[] then SetToStr:='Alle'
              else begin
                   s:='';
                   for i:=33 to 255 do
                    if Char(i) in Clslct then s:=s+' '+char(i);
                   SetToStr:=s;
                   end;
 end;

procedure ClearMom;
 Var n,i,j:Word;
 begin
 with MomDat^ do
  begin
  for n:=1 to AnzElemMod do with dat[n] do
   begin
   class:=' '; count:=0; aprio:=0;
   for i:=1 to 6 do
    for j:=1 to 6 do matrx[i,j]:=0;
   end;
  anz:=0;
  end;
 end;

procedure AkkumMom;
 Var n,i,j:Word; found:Boolean; x:Vector_6;
 begin
 with Momdat^ do
  begin
  found:=False; n:=1;
  while not found and (n<=anz) do with dat[n] do
   begin
   found:=(SmplClass=class);
   Inc(n);
   end;
  if found then Dec(n)
           else begin
                Inc(anz);
                n:=anz; dat[n].class:=SmplClass;
                end;
  with dat[n] do
   begin
   Inc(count);
   VqPV(v,x);
   for i:=1 to 6 do
    for j:=i to 6 do matrx[i,j]:=matrx[i,j]+x[i]*x[j];
   end;
  end;
 end;


procedure CmpltMom;
 Var n,i,j:Word; sum:Word; anzi,sumi:Real;
 begin
 with MomDat^ do
  begin
  sum:=0;

  for n:=1 to anz do with dat[n] do
   for i:=1 to 6 do
    for j:=1 to i-1 do matrx[i,j]:=matrx[j,i];

  for n:=1 to anz do with dat[n] do
   begin
   sum:=sum+count;
   if count>0 then begin
                   anzi:=1/count;
                   for i:=1 to 6 do
                    for j:=1 to 6 do matrx[i,j]:=anzi*matrx[i,j];
                   end;
   end;

  if sum>0 then begin
                sumi:=1/sum;
                for n:=1 to anz do with dat[n] do
                 aprio:=sumi*count;
                end;

  end;
 end;

procedure MakeEmpMod(Var EmpMod:StMod_T);
 Var n,i:Word; e:Vector_2; m,k,d,b:Matrix_2; a:Real;
     ind: array[1..AnzElemMod] of Word; fertig:Boolean;
 begin
 with Momdat^ do
  begin
  EmpMod.anz:=anz;
  EmpMod.anzcl:=anz;

  {sortieren nach class-Label aufsteigend}
   for n:=1 to anz do ind[n]:=n;
   repeat
   fertig:=True;
   for n:=1 to anz-1 do if dat[ind[n]].class>dat[ind[n+1]].class then
    begin
    i:=ind[n]; ind[n]:=ind[n+1]; ind[n+1]:=i; fertig:=False;
    end;
   until fertig;

  for n:=1 to anz do with dat[ind[n]] do
   begin
   EmpMod.tab[n].class:=class;
   EmpMod.tab[n].cprob:=aprio;
   EmpMod.tab[n].anzsc:=1;
   EmpMod.tab[n].sbcls:='1';
   EmpMod.tab[n].scprb:=1;
   EmpMod.tab[n].meanx:=matrx[2,1];
   EmpMod.tab[n].meany:=matrx[3,1];
   SetV(matrx[2,1],matrx[3,1],e);
   DyaVV(e,k);
   SetM(matrx[2,2],matrx[2,3],matrx[3,2],matrx[3,3],m);
   SubMM(m,k,k);
   EigMs(k,d,b);
   AlpB(b,a);
   EmpMod.tab[n].alpha:=a;
   EmpMod.tab[n].eigv1:=d[1,1];
   EmpMod.tab[n].eigv2:=d[2,2];
   end;
  end;
 end;

procedure SaveMom(MomSvDatei:PathStr; Mom:MomRec_T; Var OK:Boolean);
 Var i,j:Word; f:text;
 begin
 Assign(f,MomSvDatei); {$I-} Rewrite(f); {$I+} OK:=(IOResult=0);
 if Ok then with Mom do
  begin
  writeln(f,class,count:10);
  for i:=1 to 6 do
   begin
   for j:=1 to 6 do write(f,matrx[i,j]:14:6);
   writeln(f);
   end;
  Close(f);
  end;
 end;


procedure ShowMom(Mom:MomRec_T);
 Const ChrHght=10;
 Var   i,j:Word; ta:Byte;
 begin
 ta:=TextAttr;
 TextBackGround(LightGray); TextColor(Black);
 with Mom do
  begin
  RahmenXYG(XShw,YShw,58*ChrPtch,10*ChrHght);
  writeXYG(XShw+2*ChrPtch,YShw+ChrHght,'Mom-Matrix    class: '+class+'    count: '+StrI(count,0));
  for i:=1 to 6 do
   for j:=1 to 6 do
    writeXYG(XShw+(2+9*(j-1))*ChrPtch,YShw+(2+i)*ChrHght,StrR(matrx[i,j],8,2));
  end;
 TextAttr:=ta;
 end;


procedure LoadMom(MomLdDatei:PathStr; Var Mom:MomRec_T; Var OK:Boolean);
 Var i,j:Word; f:text;
 begin
 Assign(f,MomLdDatei); {$I-} Reset(f); {$I+} OK:=(IOResult=0);
 if Ok then with Mom do
  begin
  readln(f,class,count);
  for i:=1 to 6 do
   begin
   for j:=1 to 6 do read(f,matrx[i,j]);
   readln(f);
   end;
  Close(f);
  end;
 end;


procedure SaveEmpMod(MomSvDatei:PathStr; MomDat:MomDat_P; Var OK:Boolean);
 Var n:Word; di:DirStr; na:NameStr; ex:ExtStr;
 begin
 FSplit(MomSvDatei,di,na,ex);
 with MomDat^ do
  for n:=1 to anz do SaveMom(di+na+dat[n].class+ex,dat[n],OK);
 end;


procedure GenMom(MomSvDatei:PathStr; ModPar:ModPar_P; OK:Boolean);
 Var n:Word; di:DirStr; na:NameStr; ex:ExtStr;
     dat:MomRec_T;
     v1,v2,v3,v4,i,j: Integer;
     m2: Matrix_2;
     mz3,m3: array [1..2,1..2,1..2] of Real;
     mz4,m4: array [1..2,1..2,1..2,1..2] of Real;

 begin
 FSplit(MomSvDatei,di,na,ex);
 with ModPar^ do
  begin
  for n:=1 to anz do with par[n] do
   begin
   dat.class:=class;
   dat.count:=0;

   for v1:=1 to 2 do                        {zentrale Momente vierter Ordnung}
    for v2:=1 to 2 do
     for v3:=1 to 2 do
      for v4:=1 to 2 do
       mz4[v1,v2,v3,v4] := kov[v1,v2]*kov[v3,v4]+
                           kov[v1,v3]*kov[v2,v4]+
                           kov[v1,v4]*kov[v2,v3];

   for v1:=1 to 2 do                      {dezentrale Momente zweiter Ordnung}
    for v2:=1 to 2 do
     m2[v1,v2] := kov[v1,v2]+
                  cen[v1]*cen[v2];

   for v1:=1 to 2 do                      {dezentrale Momente dritter Ordnung}
    for v2:=1 to 2 do
     for v3:=1 to 2 do
      m3[v1,v2,v3] := kov[v1,v2]*cen[v3]+
                      kov[v1,v3]*cen[v2]+
                      kov[v2,v3]*cen[v1]+
                      cen[v1]*cen[v2]*cen[v3];

   for v1:=1 to 2 do                      {dezentrale Momente vierter Ordnung}
    for v2:=1 to 2 do
     for v3:=1 to 2 do
      for v4:=1 to 2 do
       m4[v1,v2,v3,v4] := mz4[v1,v2,v3,v4]+
                          kov[v1,v2]*cen[v3]*cen[v4]+
                          kov[v1,v3]*cen[v2]*cen[v4]+
                          kov[v1,v4]*cen[v2]*cen[v3]+
                          kov[v2,v3]*cen[v1]*cen[v4]+
                          kov[v2,v4]*cen[v1]*cen[v3]+
                          kov[v3,v4]*cen[v1]*cen[v2]+
                          cen[v1]*cen[v2]*cen[v3]*cen[v4];

   dat.matrx[1,1]:=1;       {Einsetzen in die vollst. quadratische Mom.matrix}
   dat.matrx[1,2]:=cen[1];
   dat.matrx[1,3]:=cen[2];
   dat.matrx[1,4]:=m2[1,1];
   dat.matrx[1,5]:=m2[1,2];
   dat.matrx[1,6]:=m2[2,2];
   dat.matrx[2,2]:=m2[1,1];
   dat.matrx[2,3]:=m2[1,2];
   dat.matrx[2,4]:=m3[1,1,1];
   dat.matrx[2,5]:=m3[1,1,2];
   dat.matrx[2,6]:=m3[1,2,2];
   dat.matrx[3,3]:=m2[2,2];
   dat.matrx[3,4]:=m3[1,1,2];
   dat.matrx[3,5]:=m3[1,2,2];
   dat.matrx[3,6]:=m3[2,2,2];
   dat.matrx[4,4]:=m4[1,1,1,1];
   dat.matrx[4,5]:=m4[1,1,1,2];
   dat.matrx[4,6]:=m4[1,1,2,2];
   dat.matrx[5,5]:=m4[1,1,2,2];
   dat.matrx[5,6]:=m4[1,2,2,2];
   dat.matrx[6,6]:=m4[2,2,2,2];

   for i:=1 to 6 do                                     {symmetrisch ergnzen}
    for j:=1 to i-1 do dat.matrx[i,j]:=dat.matrx[j,i];

   SaveMom(di+na+class+sbcls+ex,dat,OK);
   end;
  end;
 end;


procedure LoadRezept(RzpRdDatei:PathStr; Var RzpDat:RzpDat_T; OK:Boolean);
 Const dontcare='-';
 Var rf:text; k,zgr,nsc:Word; s,cs:String;
 begin
 Assign(rf,RzpRdDatei); {$I-} Reset(rf); {$I+} OK:=(IOResult=0);
 if OK then
  begin
  k:=0; zgr:=0; nsc:=1;
  with RzpDat do
   begin
   repeat
    readln(rf,s);
    if (s[1]<>'*') and not Leer(s) then
     begin
     GetPar(s);
     if not (ParCount=5) then OK:=False
      else begin
           Inc(k);
           cs:=ParStr(1);
           if cs<>dontcare then begin
                                Inc(zgr);
                                dat[zgr].zeigr:=k;
                                if zgr>1 then dat[zgr-1].anzsc:=nsc;
                                nsc:=1;
                                end
                           else begin
                                Inc(nsc);
                                dat[k].anzsc:=0;
                                end;
           with dat[k] do begin
                          class:=cs[1];
                          cprob:=ValR(ParStr(2));
                          cs:=ParStr(3);
                          sbcls:=cs[1];
                          scprb:=ValR(ParStr(4));
                          name:=ParStr(5);
                          end;
           end;
     end;
   until Eof(rf);
   Close(rf);
   if zgr>0 then dat[zgr].anzsc:=nsc;
   anz:=k;
   anzcl:=zgr;
   end;
  end;
 end;

procedure ClearMomMat(Var MomMat:MomMat_P);
 Var i,j:Word;
 begin
 for i:=0 to 5+AnzElemMod do
 for j:=0 to 5+AnzElemMod do MomMat^.mm[i,j]:=0;
 end;


procedure MakeMomMat(RzpDat:RzpDat_T; MomPfad:PathStr;
                     Var MomMat:MomMat_P;
                     Var OK:Boolean);

 Var   di:DirStr; na:NameStr; ex:ExtStr;
       mf:text; Mom:MomRec_T; clprb:Real;
       i,j:Integer; k,ks,zgr,nsc:Word;

 begin
 ClearMomMat(MomMat);
 FSplit(MomPfad,di,na,ex);
 with RzpDat do
  begin
  for k:=1 to anzcl do
   begin
   zgr:=dat[k].zeigr;
   nsc:=dat[k].anzsc;
   MomMat^.clslst[k]:=dat[zgr].class;
   clprb:=dat[zgr].cprob;
   for ks:=zgr to zgr+nsc-1 do with dat[ks] do
    begin
    LoadMom(di+name,Mom,OK);
    if DsplMom then begin
                    ShowMom(Mom);
                    WaitForReturn;
                    end;
    with Mom do
     begin
     for i:=0 to 5 do
      begin
      for j:=i to 5 do MomMat^.mm[i,j]:=MomMat^.mm[i,j]+clprb*scprb*matrx[i+1,j+1];
      MomMat^.mm[i  ,5+k]:=MomMat^.mm[i  ,5+k]+clprb*scprb*matrx[i+1,1];
      end;
     MomMat^.mm[5+k,5+k]:=MomMat^.mm[5+k,5+k]+clprb*scprb;
     end;
    end;
   end;
  MomMat^.anz:=anzcl;
  with MomMat^ do
   begin
   for i:=0 to 5+anz do
    for j:=0 to i-1 do mm[i,j]:=mm[j,i];
   end;
  end;
 end;


procedure ShowMomMat(MomMat:MomMat_P);
 Const ChrHght=10; XShw=3;
 Var   i,j:Word; ta:Byte;
 begin
 ta:=TextAttr;
 TextBackGround(LightGray); TextColor(Black);
 with MomMat^ do
  begin
  RahmenXYG(XShw,YShw,75*ChrPtch,13*ChrHght);
  writeXYG(XShw+2*ChrPtch,YShw+ChrHght,'Mom-Matrix : '+StrI(anz,0)+' Klassen, maximal drei Klassen dargestellt');
  for i:=0 to 5+MinI(anz,3) do
   for j:=0 to 5+MinI(anz,3) do
    writeXYG(XShw+(2+8*j)*ChrPtch,YShw+(3+i)*ChrHght,StrR(mm[i,j],6,2));
  end;
 TextAttr:=ta;
 end;


procedure Regre(MomMat:MomMat_P; Strat:Strat_T; MinDiag:Real; VAR KlfDat:KlfDat_T);

 Type Stat_T = (elim,avail,used,target);
      Prtk_T = record
                variabl: Word;
                res_var: Real;
                rec_err: Real;
               end;

 Var  StatusList: array [0..5+AnzElemMod] of Stat_T;
      Protokoll:  array [0..6] of Prtk_T;
      next:       Integer;   {nchste zu bearb. Variable}
      n: Word;               {laufende Nr. REGRE-Schritt}
      nn: Word;              {5+Klassenanzahl -- Obergrenze Index}
      fertig: boolean;


 procedure Init;
  VAR i: Word;
  begin
  for i:=0 to 5 do StatusList[i]:=avail;
  nn:=5+MomMat^.anz;
  for i:=6 to nn do Statuslist[i]:=target;
  n:=0; next:=-1; fertig:=False;
  end;

 procedure Trace;
  Var i:Word; rr,ss: Real;
  begin
  ss:=0; rr:=0;
  for i:=0 to nn do
   begin
   with MomMat^ do
   case Statuslist[i] of
    avail:  rr:=rr+mm[i,i];
    target: ss:=ss+mm[i,i];
   end;
   end;
  with Protokoll[n] do begin variabl:=next+1; res_var:=ss; rec_err:=rr; end;
  end;

 procedure Select;
  Var i,j: Word; ds,mxds,dr,mxdr: Real;
  begin
  with MomMat^ do
   begin
   next:=0; mxds:=0; mxdr:=0; fertig:=TRUE;
   for i:=0 to 5 do
    if Statuslist[i]=avail then
     begin
     dr:=mm[i,i];
     if dr<MinDiag then Statuslist[i]:=elim
     else
      begin
      fertig:=False;
      if n=0 then next:=0
             else begin
                  case strat of
                  no: next:=n;
                  ms: begin
                      ds:=0; for j:=1 to anz do ds:=ds+sqr(mm[i,5+j]); ds:=ds/dr;
                      if ds>mxds then begin mxds:=ds; next:=i; end;
                      end;
                  lu: if dr>mxdr then begin mxdr:=dr; next:=i; end;
                  end;
                  end;
      end;
     end;
   end;
  end;

 procedure Regreschritt;
  Var pivot,fak: Real;
      hzeile: array [0..5+AnzElemMod] of Real;
      i,j: Word;

  begin
  with MomMat^ do
   begin
   pivot:=1/mm[next,next];

   for j:=0 to nn do
    if not ((Statuslist[j]=elim) or (Statuslist[j]=used)) then
     begin
     hzeile[j]:=mm[next,j]*pivot;
     mm[next,j]:=hzeile[j];
     end;

   for i:=0 to nn do
    begin
    if not((i=next) or (Statuslist[i]=elim)) then
     begin
     fak:=mm[i,next];
     for j:=0 to nn do
      if not ((Statuslist[j]=elim) or (Statuslist[j]=used)) then
       mm[i,j]:=mm[i,j]-fak*hzeile[j];
     end;
    end;

   Statuslist[next]:=used;

   Inc(n);

   Trace;

   end;
  end;

 procedure AblQMK;
  VAR i,j,k:Word;
  begin
  j:=6;
  with MomMat^ do
   begin
   KlfDat.typ:='QMK';
   KlfDat.anz:=anz;
   for k:=1 to anz do
    begin
    KLfDat.dat[k].class:=clslst[k];
    for i:=0 to 5 do KlfDat.dat[k].koeff[i+1]:=mm[i,j];
    KlfDat.dat[k].koeff[7]:=mm[j,j];
    for i:=8 to 10 do KlfDat.dat[k].koeff[i]:=0;
    Inc(j);
    end;
   end;
  end;

 procedure ShowProtokoll;
  Const ChrHght=10; XShw=30; YShw=150;
  Var   i:Word; ta:Byte;
  begin
  ta:=TextAttr;
  TextBackGround(LightGray); TextColor(Black);
  RahmenXYG(XShw,YShw,42*ChrPtch,11*ChrHght);
  WriteXYG(XShw+2*ChrPtch,YShw+ChrHght,'Klassen:');
  for i:=1 to MomMat^.anz do
   WriteXYG(XShw+(11+2*(i-1))*ChrPtch,YShw+ChrHght,MomMat^.clslst[i]);
  WriteXYG(XShw+2*ChrPtch,YShw+2*ChrHght,'Schritt  Variable  Rekonstr.  Reststr.');
  for i:=0 to 6 do
   writeXYG(XShw+2*ChrPtch,YShw+(3+i)*ChrHght,StrI(i,4)+
                                              StrI(Protokoll[i].variabl,10)+
                                              StrR(Protokoll[i].rec_err,13,3)+
                                              StrR(Protokoll[i].res_var,10,3));
  TextAttr:=ta;
  end;

 begin
 Init;
 Trace;
 if DsplMom then begin ShowMomMat(MomMat); WaitForReturn; end;
 Select;
 while not fertig do
  begin
  Regreschritt;
  if DsplMom then begin ShowMomMat(MomMat); WaitForReturn; end;
  Select;
  end;
 ShowProtokoll; WaitForReturn;
 AblQMK;

 end;

procedure NvtRefClssfr(ModPar:ModPar_P; Var KlfDat:KlfDat_T);
 VAR i,j,k:Word; v:Vector_2;
 begin
 with ModPar^ do
  begin
  KlfDat.typ:='NVK';
  KlfDat.anz:=anz;
  for k:=1 to anz do with par[k] do
   begin
   MulMV(ikv,cen,v);
   KLfDat.dat[k].class:=class;
   KLfDat.dat[k].koeff[1]:=ln(dmax)-0.5*QuaF(ikv,cen);
   KLfDat.dat[k].koeff[2]:=v[1];
   KLfDat.dat[k].koeff[3]:=v[2];
   KLfDat.dat[k].koeff[4]:=-0.5*ikv[1,1];
   KLfDat.dat[k].koeff[5]:=    -ikv[1,2];
   KLfDat.dat[k].koeff[6]:=-0.5*ikv[2,2];
   for i:=7 to 10 do KlfDat.dat[k].koeff[i]:=0;
   end;
  end;
 end;


procedure SaveKlf(KlfSvDatei:PathStr; KlfDat:KlfDat_T; Var OK:Boolean);
 Var k,i:Word; f:text;
 begin
 Assign(f,KlfSvDatei); {$I-} Rewrite(f); {$I+} OK:=(IOResult=0);
 if Ok then with KlfDat do
  begin
  writeln(f,typ);
  for k:=1 to anz do
   begin
   write(f,dat[k].class:3);
   if (typ='PKL') or (typ='PKX') then
    write(f,dat[k].cmpcl:3,'   ',dat[k].eqtyp);
   for i:=1 to 10 do write(f,dat[k].koeff[i]:12:6);
   writeln(f);
   end;
  Close(f);
  end;
 end;


procedure LoadKlf(KlfRdDatei:PathStr; Var KlfDat:KlfDat_T; Var OK:Boolean);
 Var k,i:Word; f:text; s,cs:String;
 begin
 Assign(f,KlfRdDatei); {$I-} Reset(f); {$I+} OK:=(IOResult=0);
 if Ok then with KlfDat do
  begin
  readln(f,typ);
  k:=1;
  while not Eof(f) do
   begin
   readln(f,s);
   if not Leer(s) then
    begin
    GetPar(s);
    if (typ='PKL') or (typ='PKX') then
     begin
     cs:=ParStr(1); dat[k].class:=cs[1];
     cs:=ParStr(2); dat[k].cmpcl:=cs[1];
     dat[k].eqtyp:=ParStr(3);
     for i:=1 to 10 do dat[k].koeff[i]:=ValR(ParStr(i+3));
     end
    else
     begin
     cs:=ParStr(1); dat[k].class:=cs[1];
     for i:=1 to 10 do dat[k].koeff[i]:=ValR(ParStr(i+1));
     end;
    Inc(k);
    end;
   end;
  Close(f);
  anz:=k-1;
  end;
 end;


procedure MakePkl(RzpDat:RzpDat_T; MomPfad:PathStr;
                  Var KlfDat:KlfDat_T;
                  Var OK:Boolean);

 Var di:DirStr; na:NameStr; ex:ExtStr;
     mf:text; Mom:MomRec_T; clprb:Real;
     MMat:MomMat_P; i,j:Integer;
     k1,k2,ks,zgr1,zgr2,nsc1,nsc2,n:Word;
     Klf:KlfDat_T;


 procedure AddMom(c:Real; k:Word; Var M:MomMat_P);
  Var i,j:Word;
  begin
  with Mom do
   begin
   for i:=0 to 5 do
    begin
    for j:=i to 5 do M^.mm[i,j]:=M^.mm[i,j]+c*matrx[i+1,j+1];
     M^.mm[i  ,5+k]:=M^.mm[i  ,5+k]+c*matrx[i+1,1];
    end;
   M^.mm[5+k,5+k]:=M^.mm[5+k,5+k]+c;
   end;
  end;

 procedure Ablegen(n:Word);
  VAR i:Word;
  begin
  with Klf do
   begin
   KLfDat.dat[n].class:=Klf.dat[1].class;
   KLfDat.dat[n].cmpcl:=Klf.dat[2].class;
   KLfDat.dat[n].eqtyp:='QMK';
   KlfDat.dat[n].koeff:=Klf.dat[1].koeff;
   end;
  end;

 begin
 New(MMat);             (* Speicher fuer lokale MMat-Variable alloziieren *)
 FSplit(MomPfad,di,na,ex);
 with RzpDat do
  begin
  n:=0;
  for k1:=1 to anzcl-1 do
   begin
   zgr1:=dat[k1].zeigr;
   nsc1:=dat[k1].anzsc;
   MMat^.clslst[1]:=dat[zgr1].class;
   ClearMomMat(MMat);
   clprb:=dat[zgr1].cprob;
   for ks:=zgr1 to zgr1+nsc1-1 do with dat[ks] do
    begin
    LoadMom(di+name,Mom,OK);
    AddMom(clprb*scprb,1,MMat);
    end;
   for k2:=k1+1 to anzcl do
    begin
    zgr2:=dat[k2].zeigr;
    nsc2:=dat[k2].anzsc;
    MomMat^:=MMat^;
    MomMat^.clslst[2]:=dat[zgr2].class;
    clprb:=dat[zgr2].cprob;
    for ks:=zgr2 to zgr2+nsc2-1 do with dat[ks] do
     begin
     LoadMom(di+name,Mom,OK);
     AddMom(clprb*scprb,2,MomMat);
     end;
    MomMat^.anz:=2;
    with MomMat^ do
     begin
     for i:=0 to 5+anz do
      for j:=0 to i-1 do mm[i,j]:=mm[j,i];
     end;
    Regre(MomMat,Strat,MinDiag,Klf);
    Inc(n);
    Ablegen(n);
    end;
   end;
   KlfDat.typ:='PKL';
   KlfDat.anz:=n;
  end;
  Dispose(MMat);      (* Lokale MMat-Variable freigeben *)
 end;

function  GlaubwS(d,s:Real):Real;
 Var   f1,f2,s2: Real;
 begin
 s2:=2*s;
 f1:=exp(MaxR(-70,-sqr(d-1+s2)/s2));
 f2:=exp(MaxR(-70,-sqr(d  -s2)/s2));
 GlaubwS:=f1/(f1+f2);
 end;

function Glaubw(d:Real; anz:Integer; mwerteigen,sigmaeigen,mwertfremd,sigmafremd:Real):Real;
 VAR peigen,pfremd:Real;
 begin
 peigen:=WdNvt(d,mwerteigen,sigmaeigen);
 pfremd:=WdNvt(d,mwertfremd,sigmafremd);
 Glaubw:=1/(1+(anz-1)*pfremd/peigen);
 end;

function BwrtFkt(x:Real):Real;
 begin BwrtFkt:=x/MaxR(1-x,1.0E-6); end;


procedure DVekt(KlfDat:KlfDat_T; v:Vector_2; SmplClass:Char; Var ErkErg:ErkErg_T);
 Var
  xv:Vector_6; Outside:Boolean;
  n,i,cmax,anz,anzcl,k:Word; j:Integer; xxx,ddd:Real;
  sum,dk,dmax,deigen,dn,s,ss,s2,ilv12,ilv21:Real;
  mweig,sigmeig,mwfrd,sigmfrd: Real;
  d:  DVkt_T;
  l:  ClsLst_T;
  ind:array[1..AnzElemMod] of Word;
  fertig:Boolean;


 function Find(cl:Char):Word;
  Var k:Word; found:Boolean;
  begin
  k:=1; found:=False;
  while not (found or (k>anzcl)) do if l[k]=cl then found:=True else Inc(k);
  if not found then begin Inc(anzcl); l[k]:=cl; end;
  Find:=k;
  end;


 begin
 with KlfDat do
  begin

  VqPV(v,xv);

  {berechne d-Vektor}
  if (typ='PKL') or (typ='PKX') then
   {Klassifikatornetz: PKL, kann bestehen aus NVK, QMK}
   {                   PKX, besteht aus QMF           }
   begin
   Outside:=False;
   anzcl:=0; for k:=1 to AnzElemMod do d[k]:=1;
   for n:=1 to anz do with dat[n] do
    begin
    dn:=0; for i:=1 to 6 do dn:=dn+koeff[i]*xv[i];
    if eqtyp='QMF' then
     begin
     s:=koeff[7]; s2:=2*s;
     ss:=OutlSchw*sqrt(s);
     if (Abs(dn-1+s2)     > ss)                 and
        (Abs(dn-koeff[9]) > OutlSchw*koeff[10]) and
        (Abs(dn-  s2)     > ss)                 then Outside:=True;
     dn:=GlaubwS(dn,s);
     end;
    if eqtyp='QMK' then begin
                        s:=koeff[7];
                        dn:=GlaubwS(dn,s);
                        end;
    if eqtyp='NVK' then dn:=exp(MaxR(-70,dn));
    ilv21:=BwrtFkt(dn);
    ilv12:=1/ilv21;
    k:=Find(class); d[k]:=d[k]+ilv12;
    k:=Find(cmpcl); d[k]:=d[k]+ilv21;
    end;
   anz:=anzcl; sum:=0;
   for k:=1 to anz do begin d[k]:=1/d[k]; sum:=sum+d[k]; end;
   if typ='PKX' then for k:=1 to anz do begin
                                        if Outside then d[k]:=0
                                         else d[k]:=d[k]/sum;
                                        end;
   end

  else
   {gewhnliche Klassifkatoren: NVK, QMK, QMX}
   begin
   sum:=0;
   if (typ='QMK') or (typ='QMX') then Outside:=False;
   for n:=1 to anz do
    begin
    dk:=0;
    for i:=1 to 6 do dk:=dk+dat[n].koeff[i]*xv[i];
    if typ='NVK' then begin dk:=exp(MaxR(-70,dk)); sum:=sum+dk; end;
    if typ='QMX' then begin
                      mweig:=dat[n].koeff[ 7]; sigmeig:=dat[n].koeff[ 8];
                      mwfrd:=dat[n].koeff[ 9]; sigmfrd:=dat[n].koeff[10];
                      if (dk<mwfrd-OutlSchw*sigmfrd) or (dk>mweig+OutlSchw*sigmeig) then
                       Outside:=TRUE
                      else
                       begin
                       dk:=Glaubw(dk,anz,mweig,sigmeig,mwfrd,sigmfrd);
                       sum:=sum+dk;
                       end;
                      end;
    d[n]:=dk;
    l[n]:=dat[n].class;
    end;

   if typ='NVK' then for n:=1 to anz do d[n]:=d[n]/sum;
   if typ='QMX' then for n:=1 to anz do begin
                                        if Outside then d[n]:=0
                                        else d[n]:=d[n]/sum;
                                        end;
   end;

   if CnfMap and (typ='QMK') then
    begin
    sum:=0; Outside:=False;
    for n:=1 to KlfDat.anz do
     begin
     with GlbwDat.dat[n] do
      begin
      ParGlbwMod:=param;
      if not (((d[n]>outlfrm[1]) and (d[n]<outlfrm[2]))
              or ((d[n]>outleig[1]) and (d[n]<outleig[2]))) then Outside:=True;
      d[n]:=GlbwMod(d[n]);
      sum:=sum+d[n];
      end;
     end;
     for n:=1 to anz do begin
                        if Outside then d[n]:=0
                                   else if sum>0 then d[n]:=d[n]/sum;
                        end;
    end;


  {berechne Radien}
  sum:=1; dmax:=0; deigen:=0;
  for n:=1 to anz do
   begin
   dk:=d[n];
   sum:=sum+sqr(dk);
   if dk>dmax then begin dmax:=dk; cmax:=n; end;
   if l[n]=SmplClass then deigen:=dk;
   end;
  ErkErg.radqnxt:=sum-2*dmax;
  ErkErg.radqcls:=sum-2*deigen;

  if typ='QMK' then
   if ErkErg.radqnxt>RadqSchw then
    begin
    Outside:=True;
    for n:=1 to anz do d[n]:=0;
    end;

  {sortieren nach dk abfallend}
   for n:=1 to anz do ind[n]:=n;
   repeat
   fertig:=True;
   for n:=1 to anz-1 do if d[ind[n]]<d[ind[n+1]] then
    begin
    i:=ind[n]; ind[n]:=ind[n+1]; ind[n+1]:=i; fertig:=False;
    end;
   until fertig;

  {deponiere Ergebnisse unsortiert in dvkt       }
  {                 und sortiert in glbw und labl}
  for n:=1 to anz do
   begin
   ErkErg.clnr[n]:=ind[n];
   ErkErg.glbw[n]:=d[ind[n]];
   ErkErg.labl[n]:=l[ind[n]];
   ErkErg.dvkt[n]:=d[n];
   end;

  ErkErg.anz:=anz;
  ErkErg.class:=SmplClass;

  end;
 end;

procedure ShowErkErg(ErkErg:ErkErg_T);
 Const ChrHght=10; XShw=520; YShw=10;
 Var   n:Word; ta:Byte;
 begin
 ta:=TextAttr;
 with ErkErg do
  begin
  TextBackGround(LightGray); TextColor(Black);
  RahmenXYG(XShw,YShw,13*ChrPtch,(anz+6)*ChrHght);
  writeXYG(XShw+2*ChrPtch,YShw+ChrHght,'Cls  Glbw');
  for n:=1 to anz do
   writeXYG(XShw+3*ChrPtch,YShw+(1+n)*ChrHght,labl[n]+StrR(glbw[n],7,3));
  writeXYG(XShw+2*ChrPtch,YShw+(3+anz)*ChrHght,'RQN'+StrR(radqnxt,6,3));
  writeXYG(XShw+2*ChrPtch,YShw+(4+anz)*ChrHght,'RQE'+StrR(radqcls,6,3));
  TextAttr:=ta;
  end;
 end;

procedure ShowMeanGlbw(MeanGlbw:Dvkt_T);
 Const ChrHght=10; XShw=50; YShw=85;
 Var   n,nn:Word; ta:Byte;
 begin
 ta:=TextAttr;
 ClsLstFromKlfDat(KlfDat,ClsLst,KlAnz);
 nn:=Statistik.anzsmpl;
 TextBackGround(LightGray); TextColor(Black);
 RahmenXYG(XShw,YShw,13*ChrPtch,(Klanz+3)*ChrHght);
 writeXYG(XShw+2*ChrPtch,YShw+ChrHght,'Rng  MGlb');
 for n:=1 to Klanz do
  writeXYG(XShw+2*ChrPtch,YShw+(1+n)*ChrHght,StrI(n,2)+StrR(MeanGlbw[n]/nn,7,3));
 TextAttr:=ta;
 end;


function  Quality(ErkErg:ErkErg_T):Byte;
 Var qua,erg:Byte;
 begin
 with ErkErg do
  begin
  if labl[1]=class    then erg:=1 else erg:=4;
  if glbw[1]>GlbwSchw then qua:=1 else qua:=2;
  Quality:=erg*qua;
  end;
 end;

function  ChckPltTrue(x,y:Integer;nr1,nr2:Word):Boolean;
 begin
 ChckPltTrue:=True;
 end;

function  ChckPltQMK(x,y:Integer; nr1,nr2:Word):Boolean;
 Const eps=1.0E-30;
 Var i,k:Word; wertbrdr,wertand:Real; v:Vector_2; xv:Vector_6;
 begin
 ChckPltQMK:=True;
 SetV(XFInv(XSInv(x)),YFInv(YSInv(y)),v);
 VqPV(v,xv);
 with KlfDat do
  begin
  wertbrdr:=0;
  for i:=1 to 6 do wertbrdr:=wertbrdr+dat[nr1].koeff[i]*xv[i];
  for k:=1 to anz do
   if (ClSlct=[]) or (dat[k].class in ClSlct) then
    begin
    if (k<>nr1) and (k<>nr2) then
     begin
     wertand:=0;
     for i:=1 to 6 do wertand:=wertand+dat[k].koeff[i]*xv[i];
     if not (wertbrdr-wertand>eps) then
      begin ChckPltQMK:=False; Exit; end;
     end;
    end;
  end;
 end;


procedure PlotQfkt(KlfVkt:KlfRec_T; q:Real);
 VAR k,d,b,trm:Matrix_2; h,cen:Vector_2; a0,g0,aa,bb:Real;
 begin
 with KlfVkt do
  begin

  SetM(koeff[4],koeff[5]/2,koeff[5]/2,koeff[6],k);

  if BetrqM(k)<1E-12 then
   begin
   a0:=koeff[1]; SetV(koeff[2],koeff[3],h);
   PlotGrenzGerade(1,1,a0,h,ChckPltTrue);
   end
  else if DetM(k)<>0 then
   begin
   InvM(k,k); MulSM(-1,k,k);
   SetV(koeff[2]/2,koeff[3]/2,h); MulMV(k,h,cen);
   g0:=koeff[1]+SkPVV(h,cen)-q;

   EigMs(k,d,b); aa:=g0*d[1,1]; bb:=g0*d[2,2];
   DiaM(abs(aa),abs(bb),d);
   SqrtMd(d,trm); MulMM(b,trm,trm);

   if (aa>0) and (bb>0) then PlotGrenzEllipse(1,1,trm,cen,ChckPltTrue);
   if (aa>0) and (bb<0) then PlotGrenzHyperbel(1,1,trm,cen,1,Hyperbelstep,aa,bb,ChckPltTrue);
   if (aa<0) and (bb>0) then PlotGrenzHyperbel(1,1,trm,cen,2,Hyperbelstep,aa,bb,ChckPltTrue);
   end;
  end;
 end;


procedure PlotQMKGrenze(nr1,nr2:Word);
 VAR k,d,b,trm:Matrix_2; h,cen:Vector_2; a:Vector_6; a0,g0,aa,bb:Real; i:Word;
 begin
 with KlfDat do
  begin
  for i:=1 to 6 do a[i]:=dat[nr1].koeff[i]-dat[nr2].koeff[i];

  SetM(a[4],a[5]/2,a[5]/2,a[6],k);

  if BetrqM(k)<1E-12 then
   begin
   a0:=a[1]; SetV(a[2],a[3],h);
   PlotGrenzGerade(nr1,nr2,a0,h,ChckPltQMK);
   end
  else if DetM(k)<>0 then
   begin
   InvM(k,k); MulSM(-1,k,k);
   SetV(a[2]/2,a[3]/2,h); MulMV(k,h,cen);
   g0:=a[1]+SkPVV(h,cen);

   EigMs(k,d,b); aa:=g0*d[1,1]; bb:=g0*d[2,2];
   DiaM(abs(aa),abs(bb),d);
   SqrtMd(d,trm); MulMM(b,trm,trm);

   if (aa>0) and (bb>0) then PlotGrenzEllipse(nr1,nr2,trm,cen,ChckPltQMK);
   if (aa>0) and (bb<0) then PlotGrenzHyperbel(nr1,nr2,trm,cen,1,Hyperbelstep,aa,bb,ChckPltQMK);
   if (aa<0) and (bb>0) then PlotGrenzHyperbel(nr1,nr2,trm,cen,2,Hyperbelstep,aa,bb,ChckPltQMK);
   end;
  end;
 end;


procedure PlotClassRegions(KlfDat:KlfDat_T);
 Const dontcare='-';
 Var   i,j:Word; x,y,xx,yy:Word; v:Vector_2; ErkErg:ErkErg_T;
       korr:Integer;
       zeile,zeilev:array [0..199] of Byte;
       akt:Byte;

 function Erg(x,y:Word):Byte;
  begin
  SetV(XFInv(XSInv(x)),YFInv(YSInv(y)),v);
  case ModeKlf of
   stm: DVekt(KlfDat,v,dontcare,ErkErg);
   zep: DVektZep(Psl,ClsLst,Koeff,v,dontcare,ErkErg);
  end;
  if ((ClSlct=[]) or (ErkErg.labl[1] in ClSlct)) and (ErkErg.glbw[1]>GlbwSchw) then Erg:=ErkErg.clnr[1]
  else Erg:=0;
  end;

 begin
 {Buffer zeile initialisieren}
 y:=0; x:=0;
 for i:=0 to AnzPxH div Block do
  begin zeile[i]:=Erg(x,y); x:=x+Block; end;

 korr:=ErkErg.anz-1;

 y:=Block;
 for j:=1 to AnzPxV div Block do
  begin
  {Vorgngerzeile nach zeilev[], neue Zeile in zeile[] bringen}
  zeilev:=zeile;
  x:=0;
  for i:=0 to AnzPxH div Block do begin zeile[i]:=Erg(x,y); x:=x+Block; end;
  {Bild aus den beiden Zeilen erzeugen}
  x:=Block;
  for i:=1 to AnzPxH div Block do
   begin
   akt:=zeile[i];
   if (zeile[i-1]=akt) and (zeilev[i-1]=akt) and (zeilev[i]=akt) then
    begin
    if akt<>0 then
     begin
     SetFillStyle(Solidfill,ClassColor[(akt+korr) mod 12]);
     Bar(x-Block,y-Block,x-1,y-1);
     end;
    end
   else
    for yy:=y-Block to y-1 do
     for xx:=x-Block to x-1 do
      begin
      akt:=Erg(xx,yy);
      if akt<>0 then PutPixel(xx,yy,ClassColor[(akt+korr) mod 12]);
      end;
   x:=x+Block;
   end;
  y:=y+Block;
  if KeyPressed then Exit;
  end;
 end;


procedure PlotClassBorders(KlfDat:KlfDat_T);
 Const dontcare='-';
 Var   i,ii,j,jj:Word; x,y,xx,yy:Word; v:Vector_2; ErkErg:ErkErg_T;
       zeile,zeilev:array [0..199] of Byte;
       localimage:array [0..20,0..20] of Byte;
       akt:Byte;

 function Erg(x,y:Word):Byte;
  begin
  SetV(XFInv(XSInv(x)),YFInv(YSInv(y)),v);
  case ModeKlf of
   stm: DVekt(KlfDat,v,dontcare,ErkErg);
   zep: DVektZep(Psl,ClsLst,Koeff,v,dontcare,ErkErg);
  end;
  if (ClSlct=[]) or (ErkErg.labl[1] in ClSlct) then Erg:=ErkErg.clnr[1]
  else Erg:=0;
  end;



 begin

 {Buffer zeile initialisieren}
 y:=0; x:=0;
 for i:=0 to AnzPxH div Block do
  begin zeile[i]:=Erg(x,y); x:=x+Block; end;

 y:=Block;
 for j:=1 to AnzPxV div Block do
  begin
  {Vorgngerzeile nach zeilev[], neue Zeile in zeile[] bringen}
  zeilev:=zeile;
  x:=0;
  for i:=0 to AnzPxH div Block do begin zeile[i]:=Erg(x,y); x:=x+Block; end;
  {Bild aus den beiden Zeilen erzeugen}
  x:=Block;
  for i:=1 to AnzPxH div Block do
   begin
   akt:=zeile[i];
   if not ((zeile[i-1]=akt) and (zeilev[i-1]=akt) and (zeilev[i]=akt)) then
    begin
    {localimage bereitstellen}
    for ii:=0 to Block+1 do
     for jj:=0 to Block+1 do
     localimage[ii,jj]:=Erg(MaxI(x-Block-1+ii,0),MaxI(y-Block-1+jj,0));

    for ii:=1 to Block+1 do
     for jj:=1 to Block+1 do
      begin
      akt:=localimage[ii,jj];
      if (localimage[ii-1,jj]<>akt) or (localimage[ii,jj-1]<>akt) then
       PutPixel(x-Block-1+ii,y-Block-1+jj,QMKGrenzenColor);
      end;
    end;
   x:=x+Block;
   end;
  y:=y+Block;
  if KeyPressed then Exit;
  end;
 end;



procedure ClearStatistik;
 Var i,j:Word;
 begin
 for i:=1 to AnzelemMod do MeanGlbw[i]:=0;

 with Statistik do
  begin
  anzsmpl:=0;
  for i:=1 to AnzFldsStat do begin
                             for j:=1 to 2 do feld[i,j]:=0;  
                             for j:=1 to 4 do radst[i,j]:=0;
                             end;
  end;
 end;


procedure AkkumStatistik;
 Var i,a,k:Word; GwSchwelle,GwAkkum:Real; richtig:Boolean;
     sum:Real;
 begin
 with ErkErg do
  begin
  Inc(Statistik.anzsmpl);

  for a:=1 to anz do MeanGlbw[a]:=MeanGlbw[a]+glbw[a];

  GwSchwelle:=1;
  for i:=1 to AnzFldsStat do
   begin
   GwSchwelle:=GwSchwelle-0.02;
   a:=0; GwAkkum:=0; richtig:=False;
   repeat
    Inc(a);
    Inc(Statistik.feld[i,1]);
    GwAkkum:=GwAkkum+glbw[a];
    richtig:=richtig or (labl[a]=SmplClass);
   until (GwAkkum>=GwSchwelle) or (a=ErkErg.anz);
   if not richtig then Inc(Statistik.feld[i,2]);
   end;

  if RadKriterium
          then i:=MinI(Trunc(sqrt(radqnxt)*AnzFldsStat)+1,AnzFldsStat)
          else begin
               sum:=0;
               for k:=1 to anz do sum:=sum-glbw[k]*ln(MaxR(glbw[k],10E-6));
               sum:=sum/ln(anz);
               i:=MinI(Trunc(sum*AnzFldsStat)+1,AnzFldsStat)
               end;
  Inc(Statistik.radst[i,1]);
  a:=1; richtig:=(labl[1]=SmplClass);
  while not richtig and (a<=MinI(ErkErg.anz,3)) do
   begin
   Inc(Statistik.radst[i,a+1]);
   Inc(a);
   richtig:=richtig or (labl[a]=SmplClass);
   end;
  end;

 end;

procedure SaveStatistik(StatSvDatei:PathStr; OK:Boolean);
 Var f:text; i:Word; GwSchwelle:Real;
 begin
 Assign(f,StatSvDatei); {$I-} Rewrite(f); {$I+} OK:=(IOResult=0);
 if Ok then with Statistik do
  begin
  writeln(f,'* Stichprobe ..: '+StchpSrc);
  writeln(f,'*     Anzahl   = '+StrI(anzsmpl,0));
  writeln(f,'* Klassifikator: '+KlfSrc);
  writeln(f,'*     Typ .....: '+KlfDat.typ);
  if CnfMap then
  writeln(f,'*     mit .....: '+CnfRdDatei);
  writeln(f,'* --------------');
  writeln(f,'* Schwelle  Numb_Alt  Numb_Err  Mean_Alt  Err_Rate');
            {12345678901234567890123456789012345678901234567890}
  writeln(f,'* ------------------------------------------------');
  GwSchwelle:=1;
  for i:=1 to AnzFldsStat do
   begin
   GwSchwelle:=GwSchwelle-0.02;
   writeln(f,GwSchwelle:10:3,
             feld[i,1]:10,
             feld[i,2]:10,
             feld[i,1]/anzsmpl:10:3,
             feld[i,2]/anzsmpl:10:3);
   end;
  Close(f);
  end;
 end;


procedure SaveRadSta(RadStaSvDatei:PathStr; OK:Boolean);
 Var f:text; i:Word; untGr:Real; sumrho,sumeps1,sumeps2,sumeps3:Real;
 begin
 Assign(f,RadStaSvDatei); {$I-} Rewrite(f); {$I+} OK:=(IOResult=0);
 if Ok then with Statistik do
  begin
  writeln(f,'* Stichprobe ..: '+StchpSrc);
  writeln(f,'*     Anzahl   = '+StrI(anzsmpl,0));
  writeln(f,'* Klassifikator: '+KlfSrc);
  writeln(f,'*     Typ .....: '+KlfDat.typ);
  if CnfMap then
  writeln(f,'*     mit .....: '+CnfRdDatei);
  writeln(f,'* --------------');
  writeln(f,'*unt.Gr.    Alle    Fal1    Fal2    Fal3     Rho    Eps1    Eps2    Eps3');
            {123456789012345678901234567890123456789012345678901234567890123456789012}
  writeln(f,'* ----------------------------------------------------------------------');

  sumeps1:=0; sumeps2:=0; sumeps3:=0;
  for i:=1 to AnzFldsStat do
   begin
   sumeps1:=sumeps1+radst[i,2];
   sumeps2:=sumeps2+radst[i,3];
   sumeps3:=sumeps3+radst[i,4];
   end;

  untGr:=1; sumrho:=0;
  for i:=AnzFldsStat downto 1 do
   begin
   untGr:=untGr-0.02;
   sumrho :=sumrho +radst[i,1];
   sumeps1:=sumeps1-radst[i,2];
   sumeps2:=sumeps2-radst[i,3];
   sumeps3:=sumeps3-radst[i,4];
   writeln(f,untGr:8:2,
             radst[i,1]:8,
             radst[i,2]:8,
             radst[i,3]:8,
             radst[i,4]:8,
             sumrho/anzsmpl:8:3,
             sumeps1/anzsmpl:8:3,
             sumeps2/anzsmpl:8:3,
             sumeps3/anzsmpl:8:3);
   end;
  Close(f);
  end;
 end;



procedure LoadStatistik(StatRdDatei:PathStr; OK:Boolean);
 Var f:text; i:Word; GwSchwelle:Real; s:String;
 begin
 Assign(f,StatRdDatei); {$I-} Reset(f); {$I+} OK:=(IOResult=0);
 if Ok then with Statistik do
  repeat
   readln(f,s);
   if s[1]='*' then
    begin
    GetPar(s);
    if ParStr(2)='Anzahl' then anzsmpl:=ValI(ParStr(4));
    end
   else if not Leer(s) then
    begin
    GetPar(s);
    if ParCount<>5 then OK:=False
     else begin
          GwSchwelle:=ValR(ParStr(1));
          i:=round(50*(1-GwSchwelle));
          feld[i,1]:=ValI(ParStr(2));
          feld[i,2]:=ValI(ParStr(3));
          end;
    end;
  until Eof(f);
  Close(f);
 end;


procedure LoadRadSta(RadStaRdDatei:PathStr; OK:Boolean);
 Var f:text; i:Word; s:String;
 begin
 Assign(f,RadStaRdDatei); {$I-} Reset(f); {$I+} OK:=(IOResult=0);
 if Ok then with Statistik do
  begin
  i:=AnzFldsStat;
  repeat
   readln(f,s);
   if s[1]='*' then
    begin
    GetPar(s);
    if ParStr(2)='Anzahl' then anzsmpl:=ValI(ParStr(4));
    end
   else if not Leer(s) then
    begin
    GetPar(s);
    if ParCount<>9 then OK:=False
     else begin
          radst[i,1]:=ValI(ParStr(2));
          radst[i,2]:=ValI(ParStr(3));
          radst[i,3]:=ValI(ParStr(4));
          radst[i,4]:=ValI(ParStr(5));
          Dec(i);
          end;
    end;
  until Eof(f);
  end;
  Close(f);
 end;


procedure PlotEpsAlt;
 Var i:Word; fak:Real; v:Vector_2;
 begin
 with Statistik do
  begin
  fak:=1/anzsmpl;
  SetV(fak*feld[1,1],fak*feld[1,2],v); LMoveToV(v);
  for i:=2 to AnzFldsStat do
   begin
   SetV(fak*feld[i,1],fak*feld[i,2],v); LLineToV(v);
   end;
  end;
 end;

procedure PlotEps;
 Var i:Word; fak:Real; v:Vector_2; gws:Real;
 begin
 with Statistik do
  begin
  fak:=1/anzsmpl;
  gws:=0.98;
  SetV(gws,fak*feld[1,2],v); LMoveToV(v);
  for i:=2 to AnzFldsStat do
   begin
   gws:=gws-0.02;
   SetV(gws,fak*feld[i,2],v); LLineToV(v);
   end;
  end;
 end;

procedure PlotAlt;
 Var i:Word; fak:Real; v:Vector_2; gws:Real;
 begin
 with Statistik do
  begin
  fak:=1/anzsmpl;
  gws:=0.98;
  SetV(gws,fak*feld[1,1],v); LMoveToV(v);
  for i:=2 to AnzFldsStat do
   begin
   gws:=gws-0.02;
   SetV(gws,fak*feld[i,1],v); LLineToV(v);
   end;
  end;
 end;


procedure PlotRadStaRho;
 Var i,a:Word; v:Vector_2; radsw,sum,delta:Real;
 begin
 delta:=1/AnzFldsStat;
 with Statistik do
  begin
  sum:=anzsmpl;
  radsw:=0;
  SetV(radsw,1,v); LMoveToV(v);
  for i:=1 to AnzFldsStat do
   begin
   radsw:=radsw+delta;
   sum:=sum-radst[i,1];
   SetV(radsw,MaxR(sum/anzsmpl,1E-6),v); LLineToV(v);
   end;
  end;
 end;


procedure PlotRadStaEps;
 Var i,a:Word; v:Vector_2; radsw,sum,delta:Real;
 begin
 delta:=1/AnzFldsStat;
 with Statistik do
  begin
  for a:=1 to 3 do
   begin
   sum:=0;
   radsw:=0;
   SetV(radsw,MaxR(sum/anzsmpl,1E-6),v); LMoveToV(v);
   for i:=1 to AnzFldsStat do
    begin
    radsw:=radsw+delta;
    sum:=sum+radst[i,a+1];
    SetV(radsw,MaxR(sum/anzsmpl,1E-12),v); LLineToV(v);
    end;
   end;
  end;
 end;

procedure PlotRadStaEpsRho;
 Var i:Word; v:Vector_2; fak,sumeps,sumrho:Real;
 begin
 with Statistik do
  begin
  sumeps:=0; for i:=1 to AnzFldsStat do sumeps:=sumeps+radst[i,2];
  sumrho:=0;
  fak:=1/anzsmpl;
  SetV(fak*sumrho,fak*sumeps,v); LMoveToV(v);
  for i:=AnzFldsStat-1 downto 1 do
   begin
   sumrho :=sumrho+radst[i,1];
   sumeps :=sumeps-radst[i,2];
   SetV(fak*sumrho,fak*sumeps,v); LLineToV(v);
   end;
  end;
 end;


procedure PlotRadStaAlle;
 Var i,a:Word; v:Vector_2; radsw,delta:Real;
 begin
 delta:=1/AnzFldsStat;
 with Statistik do
  begin
  radsw:=0.4*delta;
  for i:=1 to AnzFldsStat do
   begin
   SetV(radsw,0,v);          LMoveToV(v);
   SetV(radsw,radst[i,1],v); LLineToV(v);
   radsw:=radsw+delta;
   end;
  end;
 end;


procedure PlotRadStaFal1;
 Var i,a:Word; v:Vector_2; radsw,delta:Real;
 begin
 delta:=1/AnzFldsStat;
 with Statistik do
  begin
  radsw:=0.6*delta;
  for i:=1 to AnzFldsStat do
   begin
   SetV(radsw,0,v);          LMoveToV(v);
   SetV(radsw,radst[i,2],v); LLineToV(v);
   radsw:=radsw+delta;
   end;
  end;
 end;




procedure ClsLstFromKlfDat(KlfDat:KlfDat_T; Var ClsLst:ClsLst_T; Var KlAnz:Word);
 Var k,kanz:Word;

 procedure Check(ch:Char);
  Var k:Word; found:Boolean;
  begin
  k:=1; found:=False;
  while not (found or (k>kanz)) do
   begin found:=(ClsLst[k]=ch); Inc(k); end;
  if not found then begin Inc(kanz); ClsLst[kanz]:=ch; end;
  end;

 begin
 with KlfDat do
  if (typ='PKL') or (typ='PKX') then
   begin
   kanz:=0;
   for k:=1 to anz do with dat[k] do
    begin
    Check(class);
    Check(cmpcl);
    end;
   KlAnz:=kanz;
   end
  else
   begin
   for k:=1 to anz do ClsLst[k]:=dat[k].class;
   KlAnz:=anz;
   end;
 end;

procedure ClSlctFromClsLst(ClsLst:ClsLst_T; Klanz:Word; Var ClSlct:SetChar_T);
 Var k:Word;
 begin
 ClSlct:=[]; for k:=1 to KlAnz do ClSlct:=ClSlct+[ClsLst[k]];
 end;

procedure RdVersion40(Var StchpRdFile:Text; Var SmplClass:Char;
                                            Var SmplNr:Word;
                                            Index1,Index2:Word;
                                            Var v:Vector_2);
 Var s,sc:String; i,j:Word;
     vv: array[1..40] of Real;
 begin
 repeat
  Readln(StchpRdFile,s);
 until not Leer(s);
 GetPar(s);
 sc:=ParStr(1); SmplClass:=sc[1];
 SmplNr:=ValI(ParStr(2));
 for i:=0 to 3 do
  begin
  repeat
   Readln(StchpRdFile,s);
  until not Leer(s);
  GetPar(s);
  for j:=1 to 10 do vv[i*10+j]:=ValR(ParStr(j));
  end;
 v[1]:=vv[Index1]; v[2]:=vv[Index2];
 end;


procedure LoadGlbw(CnfRdDatei:PathStr; Var OK:Boolean);
 Var k,i:Word; f:Text; s,cs:String;
 begin
 Assign(f,CnfRdDatei); {$I-} ReSet(f); {$I+} OK:=(IOResult=0);
 if Ok then with GlbwDat do
  begin
  readln(f,typ);
  k:=1;
  while not Eof(f) do
   begin
   readln(f,s);
   if not Leer(s) then
    begin
    GetPar(s);
    if typ='GLP' then
     begin
     cs:=ParStr(1); dat[k].class:=cs[1];
     cs:=ParStr(2); dat[k].cmpcl:=cs[1];
     for i:=1 to 6 do dat[k].param[i]  :=ValR(ParStr(i+ 2));
     for i:=1 to 2 do dat[k].outlfrm[i]:=ValR(ParStr(i+ 8));
     for i:=1 to 2 do dat[k].outloth[i]:=ValR(ParStr(i+10));
     for i:=1 to 2 do dat[k].outleig[i]:=ValR(ParStr(i+12));
     end
    else
     begin
     cs:=ParStr(1); dat[k].class:=cs[1];
     for i:=1 to 6 do dat[k].param[i]  :=ValR(ParStr(i+ 1));
     for i:=1 to 2 do dat[k].outlfrm[i]:=ValR(ParStr(i+ 7));
     for i:=1 to 2 do dat[k].outloth[i]:=ValR(ParStr(i+ 9));
     for i:=1 to 2 do dat[k].outleig[i]:=ValR(ParStr(i+11));
     end;
    Inc(k);
    end;
   end;
  Close(f);
  anz:=k-1;
  end;
 end;


function CheckCompatKlfCnf:Boolean;
 Var compat:Boolean; n:Word;
 begin
 compat:=True;
 compat:=compat and ((KlfDat.typ='QMK') and (GlbwDat.typ='GLK') or
                     (KlfDat.typ='PKL') and (GlbwDat.typ='GLP'));
 compat:=compat and (KlfDat.anz=GlbwDat.anz);
 for n:=1 to KlfDat.anz do
  begin
  compat:=compat and (KlfDat.dat[n].class=GlbwDat.dat[n].class);
  end;
 CheckCompatKlfCnf:=compat;
 end;


procedure DVektZep(Psl:PslDat_T; Cls:ClsLst_T; Koeff:PMatrix; v:Vector_2; SmplClass:Char; Var ErkErg:ErkErg_T);
 Var
  zv,rv,x,d:          PMatrix;
  n,anz,cmax,i:       Word;
  w:                  Extended;
  dv:                 DVkt_T;
  sum,dk,dmax,deigen: Real;
  ind:                array[1..AnzElemMod] of Word;
  Outside,fertig:     Boolean;


 begin

 zv:=New(PMatrix,Init('V',2,1));
 zv^.WriteMatrixelement(0,0,v[1]);
 zv^.WriteMatrixelement(1,0,v[2]);

 x:=New(PMatrix,Init('X',Koeff^.col,1));

 if RadBas then begin
                rv:=New(PMatrix,Init('R',RdbDat^.LengthPv,1));
                RadBasVToX(RdbDat,RdbTyp,zv,rv);
                VtoX(Psl,rv,x);
                dispose(rv,done);
                end
           else VtoX(Psl,zv,x);

 dispose(zv,done);


   Matrix_Mult(Koeff,x,d);
   dispose(x,done);
   anz:=d^.row;
   for n:=0 to anz-1 do begin
                        d^.ReadMatrixElement(n,0,w);
                        dv[n+1]:=w;
                        end;
   dispose(d,done);

 if RadBas and (RdbTyp=clcprb) then
   begin
   sum:=0; for n:=1 to anz do sum:=sum+dv[n];
   for n:=1 to anz do dv[n]:=dv[n]/sum;
   end;

 if CnfMap then
  begin
  sum:=0; Outside:=False;
  for n:=1 to anz do
   begin
   with GlbwDat.dat[n] do
    begin
    ParGlbwMod:=param;
    if not (((dv[n]>outlfrm[1]) and (dv[n]<outlfrm[2]))
         or ((dv[n]>outleig[1]) and (dv[n]<outleig[2]))) then Outside:=True;
    dv[n]:=GlbwMod(dv[n]);
    sum:=sum+dv[n];
    end;
   end;
  for n:=1 to anz do begin
                     if Outside then dv[n]:=0
                                else if sum>0 then dv[n]:=dv[n]/sum;
                     end;
  end;


  {berechne Radien}
  sum:=1; dmax:=0; deigen:=0;
  for n:=1 to anz do
   begin
   dk:=dv[n];
   sum:=sum+sqr(dk);
   if dk>dmax then begin dmax:=dk; cmax:=n; end;
   if Cls[n]=SmplClass then deigen:=dk;
   end;
  ErkErg.radqnxt:=sum-2*dmax;
  ErkErg.radqcls:=sum-2*deigen;

  if ErkErg.radqnxt>RadqSchw then begin
                                  Outside:=True;
                                  for n:=1 to anz do dv[n]:=0;
                                  end;

  {sortieren nach dk abfallend}
   for n:=1 to anz do ind[n]:=n;
   repeat
   fertig:=True;
   for n:=1 to anz-1 do if dv[ind[n]]<dv[ind[n+1]] then
    begin
    i:=ind[n]; ind[n]:=ind[n+1]; ind[n+1]:=i; fertig:=False;
    end;
   until fertig;

  {deponiere Ergebnisse unsortiert in dvkt       }
  {                 und sortiert in glbw und labl}
  for n:=1 to anz do
   begin
   ErkErg.clnr[n]:=ind[n];
   ErkErg.glbw[n]:=dv[ind[n]];
   ErkErg.labl[n]:=Cls[ind[n]];
   ErkErg.dvkt[n]:=dv[n];
   end;

  ErkErg.anz:=anz;
  ErkErg.class:=SmplClass;

 end;

begin
 New(ModPar);
 New(MomDat);
 New(MomMat);
end.