program test;


uses dos,crt,graph;

var GraphDriver:         integer;   (* Globale Variable fr InitGraph *)
    GraphMode:           integer;   (* Globale Variable fr InitGraph *)
    TSENG256DriverMode:  integer;   (* Globale Variable mit TSENG256 Modus *)
r:registers;

(* AutoDetect-Funktion fr den TSENG256 Treiber. *)

(*$F+*) function AutoDetectTSENG256: integer (*$F-*);
begin
  AutoDetectTSENG256 := TSENG256DriverMode;
end;


procedure InitializeGraphics;
var DriverNumber, ErrorCode: integer;
begin

  DriverNumber := InstallUserDriver ('TSENG256', @AutoDetectTSENG256);
  if GraphResult <> grOK then begin
    WriteLn ('Fehler beim Installieren des BGI-Treibers TSENG256.');
    Halt (1)
  end;

  (* ... anderer Code ... *)

  (* Initialisierung und Umschaltung in den Graphik-Modus, *)
  (* zum Beispiel TSENG16 Modus 7, 800x600, 16 Farben *)
  GraphDriver := Detect;             (* benutze AutoDetect *)
  TSENG256DriverMode := 1;     (* TSENG256 Treiber ausschalten *)
  InitGraph (GraphDriver, GraphMode, 'c:\turbo\tp6\bgi');
  ErrorCode := GraphResult;
  if ErrorCode <> grOK then begin
    WriteLn ('Fehler im Graphiksystem: ', GraphErrorMsg (ErrorCode));
    Halt (1)
  end;

end;


var i:integer;
    ch:char;

begin
 InitializeGraphics;
 for i:=1 to 256 do
  begin
   Setcolor(i);
   line(i,1,100+i,599);
  end;
  r.ax:=0;intr($33,r);
  r.ax:=1;intr($33,r);
  ch:=readkey;
end.
