unit JS_ACC;



Interface

Uses
 graph,dos,crt,js_sub,js_tio;

Type
 Validate_T = Set of Char;
 AccptRm    = (escp,zrck,wtr,home,rtrn,pgup,pgdn);
 AccPar_T   = record
               acczeile,accspalte,feldl:Byte;
               frage:string[35];
               validate:Validate_T;
              end;
 MskPar_T   = record
               anz:Byte;
               zeile,spalte,hoehe,breite,hgfarbe,vgfarbe:Byte;
               titel:string[30];
               par:array[1..StrFldLen] of AccPar_T;
               erg:StrFld_T;
              end;


Const
 ValGb=[' ']+['A'..'Z']+['','',''];
 VALKb=[' ']+['a'..'z']+['','','',''];
 ValBu=ValGb+ValKb;
 ValZi=[' ']+['0'..'9'];
 ValNu=ValZi+['.','+','-','E'];
 ValDn=ValGb+ValKb+ValZi+['_','\',':','.','$','&','%','*','~','{','}','[',']'];
 ValJN=['J','j','N','n'];


 XGet = 20;   YGet = 300;
 XMss = 50;   YMss =  50;




Var
 Rm:AccptRm;
 OvWrt:Boolean;

procedure Accept(Zeile,Spalte,Feldlaenge:Byte;
                 Frage:string;
                 Validate:Validate_T;
                 var Ergebnis:string;
                 var Rueckmeldung:AccptRm);

procedure AcceptXYG(x,y:Integer; Feldlaenge:Byte;
                    Frage:string;
                    Validate:Validate_T;
                    var Ergebnis:string;
                    var Rueckmeldung:AccptRm);



function  AccptRmStr(rm:AccptRm):string;

procedure LoadMsk(MskFile:PathStr; Var MskPar:MskPar_T; Var OK:Boolean);
procedure SaveMsk(MskFile:PathStr;     MskPar:MskPar_T; Var OK:Boolean);
procedure EditMsk(Var  MskPar:MskPar_T; Var OK:Boolean; Var rm:AccptRm);
procedure EditMskG(Var MskPar:MskPar_T; Var OK:Boolean; Var rm:AccptRm);

procedure GetWertR(frage:String; Var wert:Real);
procedure GetWertI(frage:String; Var wert:Integer);
procedure GetWertW(frage:String; Var wert:Word);
procedure GetWertLongI(frage:String; Var wert:LongInt);
procedure GetStr(frage:String; feldl:Byte; Var s:String);
procedure Message(text:String);
procedure ErrorMessage(text:String);



implementation


procedure Accept(Zeile,Spalte,Feldlaenge:Byte;
                 Frage:string;
                 Validate:Validate_T;
                 Var Ergebnis:string;
                 Var Rueckmeldung:AccptRm);

 Var
  ta:     Word;
  s:      String;
  ch:     Char;
  fertig: Boolean;
  sp:     Word;
  p,l:    Word;

 procedure Cursor;
  begin
  if ovwrt then begin
                TextBackground(Red); TextColor(White);
                GotoXY(sp+p,zeile); Write(s[p+1]);
                end
           else begin
                TextBackGround(LightGray); TextColor(Red);
                GoToXY(sp+p,zeile); Write(s[p+1]);
                end;
  GoToXY(sp+p,zeile);
  TextAttr:=ta;
  end;

 begin
 ta:=TextAttr;
 l:=MinI(length(Ergebnis),Feldlaenge);
 s:='';
 for p:=1 to l do if (validate=[]) or (Ergebnis[p] in Validate)
                   then s:=s+Ergebnis[p]
                   else s:=s+' ';
 s:=s+RptStr(Feldlaenge-l,' ');
 GoToXY(Spalte,Zeile); Write(Frage);
 sp:=Spalte+Length(Frage);
 p:=0; fertig:=FALSE;
 GoToXY(sp,Zeile); Write(s); Cursor;
 while not fertig do
  begin
  ch:=ReadKey;
  case ch of
   #8:  if p>0 then begin
                    Delete(s,p,1); p:=MaxI(p-1,0);
                    Insert(' ',s,Feldlaenge);
                    end;
   #13: begin Rueckmeldung:=rtrn; fertig:=TRUE; end;
   #27: begin Rueckmeldung:=escp; fertig:=TRUE; end;
   #0:  begin
        if Keypressed then ch:=Readkey;
         case ch of
          #71:  begin Rueckmeldung:=home; fertig:=TRUE; end;
          #72:  begin Rueckmeldung:=zrck; fertig:=TRUE; end;
          #73:  begin Rueckmeldung:=pgup; fertig:=TRUE; end;
          #75:  p:=MaxI(p-1,0);
          #77:  p:=MinI(p+1,Feldlaenge-1);
          #79:  begin
                p:=Feldlaenge-1;
                While s[1+p]=' ' do p:=p-1;
                p:=MinI(p+1,Feldlaenge-1);
                end;
          #80:  begin Rueckmeldung:=wtr;  fertig:=TRUE; end;
          #81:  begin Rueckmeldung:=pgdn; fertig:=TRUE; end;
          #82:  ovwrt:=not ovwrt;
          #83:  begin
                Delete(s,1+p,1);
                Insert(' ',s,Feldlaenge);
                end;
          #117: s:=Copy(s,1,p)+RptStr(Feldlaenge-p,' ');
         end;
        end;
   else begin
        if (Validate=[]) or (ch in Validate) then
         begin
         if ovwrt then Delete(s,1+p,1);
         Insert(ch,s,1+p); p:=MinI(p+1,Feldlaenge-1);
         s:=Copy(s,1,Feldlaenge);
         end;
        end;
  end;
  GoToXY(sp,Zeile); Write(s); Cursor;
  end;
 GoToXY(sp,Zeile); Write(s);
 Ergebnis:=s;
 end;


procedure AcceptXYG(x,y:Integer; Feldlaenge:Byte;
                    Frage:string;
                    Validate:Validate_T;
                    Var Ergebnis:string;
                    Var Rueckmeldung:AccptRm);

 Var
  ta:     Word;
  s:      string;
  ch:     Char;
  fertig: Boolean;
  xa:     Integer;
  p:      Integer;
  l:      Word;

 procedure Cursor;
  begin
  if ovwrt then begin
                TextBackground(Red); TextColor(White);
                WriteXYG(xa+p*ChrPtch,y,s[p+1]);
                end
           else begin
                TextBackGround(LightGray); TextColor(Red);
                WriteXYG(xa+p*ChrPtch,y,s[p+1]);
                end;
  TextAttr:=ta;
  end;

 begin
 ta:=TextAttr;
 l:=MinI(length(Ergebnis),Feldlaenge);
 s:='';
 for p:=1 to l do if (validate=[]) or (Ergebnis[p] in Validate)
                   then s:=s+Ergebnis[p]
                   else s:=s+' ';
 s:=s+RptStr(Feldlaenge-l,' ');
 WriteXYG(x,y,Frage);
 xa:=x+Length(Frage)*ChrPtch;
 p:=0; fertig:=FALSE;
 WriteXYG(xa,y,s); Cursor;
 while not fertig do
  begin
  ch:=ReadKey;
  case ch of
   #8: if p>0 then begin
                   Delete(s,p,1); p:=MaxI(p-1,0);
                   Insert(' ',s,Feldlaenge);
                   end;
   #13: begin Rueckmeldung:=rtrn; fertig:=TRUE; end;
   #27: begin Rueckmeldung:=escp; fertig:=TRUE; end;
   #0:  begin
        if Keypressed then ch:=Readkey;
        case ch of
         #71:  begin Rueckmeldung:=home; fertig:=TRUE; end;
         #72:  begin Rueckmeldung:=zrck; fertig:=TRUE; end;
         #73:  begin Rueckmeldung:=pgup; fertig:=TRUE; end;
         #75:  p:=MaxI(p-1,0);
         #77:  p:=MinI(p+1,Feldlaenge-1);
         #79:  begin
               p:=Feldlaenge-1;
               While s[1+p]=' ' do p:=p-1;
               p:=MinI(p+1,Feldlaenge-1);
               end;
         #80:  begin Rueckmeldung:=wtr;  fertig:=TRUE; end;
         #81:  begin Rueckmeldung:=pgdn; fertig:=TRUE; end;
         #82:  ovwrt:=not ovwrt;
         #83:  begin
               Delete(s,1+p,1);
               Insert(' ',s,Feldlaenge);
               end;
         #117: s:=Copy(s,1,p)+RptStr(Feldlaenge-p,' ');
        end;
        end;
   else begin
        if (Validate=[]) or (ch in Validate) then
         begin
         if ovwrt then Delete(s,1+p,1);
         Insert(ch,s,1+p); p:=MinI(p+1,Feldlaenge-1);
         s:=Copy(s,1,Feldlaenge);
         end;
        end;
  end;
  WriteXYG(xa,y,s); Cursor;
  end;
 WriteXYG(xa,y,s);
 Ergebnis:=s;
 end;


function AccptRmStr(rm:AccptRm):string;
 const s: array [AccptRm] of string[7] = ('ESCAPE',
                                          'ZURCK',
                                          'WEITER',
                                          'HOME  ',
                                          'RETURN',
                                          'PGUP  ',
                                          'PGDN  ');
 begin AccptRmStr:=s[rm]; end;


procedure LoadMsk(MskFile:PathStr;
                  Var MskPar:MskPar_T;
                  Var OK:Boolean);

 Var f:text; s,vs:string; j:Word; vl:Validate_T;
 begin
 Assign(f,MskFile); {$I-} Reset(f); {$I+} OK:=(IOResult=0);
 if OK then
  with MskPar do
   begin
   anz:=0;
   ClearStrFld(erg);

   repeat readln(f,s); until (s[1]<>'*') and not Leer(s);
   GetPar(s);
   zeile  :=ValI(ParStr(1));
   spalte :=ValI(ParStr(2));
   hoehe  :=ValI(ParStr(3));
   breite :=ValI(ParStr(4));
   hgfarbe:=ValI(ParStr(5));
   vgfarbe:=ValI(ParStr(6));
   titel  :=     ParStr(7);

   repeat
    readln(f,s);
    if (s[1]<>'*') and not Leer(s) then
     begin
     GetPar(s); Inc(anz);
     if ParCount in [5,6] then
      begin
      par[anz].acczeile :=ValI(ParStr(1));
      par[anz].accspalte:=ValI(ParStr(2));
      par[anz].feldl    :=ValI(ParStr(3));
      par[anz].frage    :=ParStr(4);
      vs:=UpCaseWord(ParStr(5));
      if       vs='$GB' then vl:=ValGb
       else if vs='$KB' then vl:=ValKb
       else if vs='$BU' then vl:=ValBu
       else if vs='$ZI' then vl:=ValZi
       else if vs='$NU' then vl:=ValNu
       else if vs='$DN' then vl:=ValDn
       else if vs='$JN' then vl:=ValJN
       else if vs='$NL' then vl:=[]
       else begin
            vl:=[];
            for j:=1 to length(vs) do vl:=vl+[vs[j]];
            end;
      par[anz].validate:=vl;
      erg[anz]:=ParStr(6);
      end;
     end;
   until Eof(f);
   Close(f);
   end;
 end;


procedure SaveMsk(MskFile:PathStr;
                  MskPar:MskPar_T;
                  Var OK:Boolean);

 var f:text; vs,vorgabe:string; i,j:Byte;
 begin
 Assign(f,MskFile); {$I-} Rewrite(f); {$I+} OK:=(IOResult=0);
 if OK then
  with MskPar do
   begin
   if not Leer(titel) then titel:=' "'+titel+'"';
   writeln(f,zeile:4,
             spalte:4,
             hoehe:4,
             breite:4,
             hgfarbe:4,
             vgfarbe:4,
             titel);

   for i:=1 to anz do with par[i] do
    begin
    vorgabe:=erg[i];
    if       validate=ValGb then vs:=' $Gb'
     else if validate=ValKb then vs:=' $Kb'
     else if validate=ValBu then vs:=' $Bu'
     else if validate=ValZi then vs:=' $Zi'
     else if validate=ValNu then vs:=' $Nu'
     else if validate=ValDn then vs:=' $Dn'
     else if validate=ValJN then vs:=' $JN'
     else if validate=[]    then vs:=' $Nl'
     else begin
          vs:='';
          for j:=1 to 255 do if chr(j) in validate then vs:=vs+chr(j);
          end;
    if not Leer(frage)   then   frage:=' "'+frage+'"';
    if not Leer(vorgabe) then vorgabe:=' "'+vorgabe+'"';
    writeln(f,acczeile:4,
              accspalte:4,
              feldl:4,
              frage,
              vs,
              vorgabe);
    end;
   Close(f);
   end;
 end;


procedure EditMsk(Var MskPar:MskPar_T;
                  Var OK:Boolean;
                  Var rm:AccptRm);

 var f:text; s,vs,vorgabe:string; i,anz:Byte; fertig:Boolean;
     ta:Byte;

 begin
 ta:=TextAttr;
 OvWrt:=False;
 with MskPar do
  begin

  {Maske schreiben}
  TextBackGround(hgfarbe); TextColor(vgfarbe);
  Rahmen(zeile,spalte,breite,hoehe);
  GoToXY(spalte+2,zeile);writeln(Copy(titel,1,breite-4));
  for i:=1 to anz do
   begin
   with par[i] do
    begin
    GoToXY(spalte+accspalte,zeile+acczeile);
    write(frage+erg[i]);
    end;
   end;

  {Maske editieren}
  i:=1; fertig:=FALSE;
  repeat
   vorgabe:=erg[i];
   with par[i] do
    begin
    Accept(zeile+acczeile,spalte+accspalte+length(frage),feldl,'',validate,erg[i],rm);
    case rm of
     home : i:=1;
     rtrn : if i=anz then fertig:=TRUE else i:=succ(i);
     wtr  : i:=MinI(succ(i),anz);
     zrck : i:=MaxI(pred(i),1);
     pgup : fertig:=TRUE;
     pgdn : fertig:=TRUE;
     escp : begin erg[i]:=vorgabe; fertig:=TRUE; end;
    end;
    end;
  until fertig;
  end;
  TextAttr:=ta;
 end;


procedure EditMskG(Var MskPar:MskPar_T;
                   Var OK:Boolean;
                   Var rm:AccptRm);

 Const
  ChrHght=10;

 var f:text; s,vs,vorgabe:string; i,anz:Word; fertig:Boolean;
     ta:Word;

 begin
 ta:=TextAttr;
 OvWrt:=False;
 with MskPar do
  begin

  {Maske schreiben}
  TextBackGround(hgfarbe); TextColor(vgfarbe);
  RahmenXYG(spalte*ChrPtch,zeile*ChrHght,breite*ChrPtch,hoehe*ChrHght);
  WriteXYG((spalte+2)*ChrPtch,zeile*ChrHght,Copy(titel,1,breite-4));
  for i:=1 to anz do
   begin
   with par[i] do
    begin
    WriteXYG((spalte+accspalte)*ChrPtch,(zeile+acczeile)*ChrHght,frage+erg[i]);
    end;
   end;

  {Maske editieren}
  i:=1; fertig:=FALSE;
  repeat
   vorgabe:=erg[i];
   with par[i] do
    begin
    AcceptXYG((spalte+accspalte+length(frage))*ChrPtch,(zeile+acczeile)*ChrHght,feldl,'',validate,erg[i],rm);
    case rm of
     home : i:=1;
     rtrn : if i=anz then fertig:=TRUE else i:=succ(i);
     wtr  : i:=MinI(succ(i),anz);
     zrck : i:=MaxI(pred(i),1);
     pgup : fertig:=TRUE;
     pgdn : fertig:=TRUE;
     escp : begin erg[i]:=vorgabe; fertig:=TRUE; end;
    end;
    end;
  until fertig;
  end;
  TextAttr:=ta;
 end;


procedure GetWertR(frage:String; Var wert:Real);
 Const ChrHght=10;
 Var ta:Byte; l:Word; s:String;
 begin
 ta:=TextAttr;
 TextBackGround(Blue); TextColor(Yellow);
 l:=Length(frage)+16;
 RahmenXYG(XGet,YGet,l*ChrPtch,3*ChrHght);
 s:=StrR(wert,12,6);
 AcceptXYG(XGet+2*ChrPtch,YGet+ChrHght,11,frage,ValNu,s,rm);
 wert:=ValR(Trim(s));
 TextAttr:=ta;
 end;

procedure GetWertI(frage:String; Var wert:Integer);
 Const ChrHght=10;
 Var ta:Byte; l:Word; s:String;
 begin
 ta:=TextAttr;
 TextBackGround(Blue); TextColor(Yellow);
 l:=Length(frage)+15;
 RahmenXYG(XGet,YGet,l*ChrPtch,3*ChrHght);
 s:=StrI(wert,0);
 AcceptXYG(XGet+2*ChrPtch,YGet+ChrHght,11,frage,ValNu,s,rm);
 wert:=ValI(Trim(s));
 TextAttr:=ta;
 end;

procedure GetWertW(frage:String; Var wert:Word);
 Const ChrHght=10;
 Var ta:Byte; l:Word; s:String;
 begin
 ta:=TextAttr;
 TextBackGround(Blue); TextColor(Yellow);
 l:=Length(frage)+15;
 RahmenXYG(XGet,YGet,l*ChrPtch,3*ChrHght);
 s:=StrI(wert,0);
 AcceptXYG(XGet+2*ChrPtch,YGet+ChrHght,11,frage,ValNu,s,rm);
 wert:=ValI(Trim(s));
 TextAttr:=ta;
 end;


procedure GetWertLongI(frage:String; Var wert:LongInt);
 Const ChrHght=10;
 Var ta:Byte; l:Word; s:String;
 begin
 ta:=TextAttr;
 TextBackGround(Blue); TextColor(Yellow);
 l:=Length(frage)+15;
 RahmenXYG(XGet,YGet,l*ChrPtch,3*ChrHght);
 s:=StrLongI(wert,0);
 AcceptXYG(XGet+2*ChrPtch,YGet+ChrHght,11,frage,ValNu,s,rm);
 wert:=ValLongI(Trim(s));
 TextAttr:=ta;
 end;

procedure GetStr(frage:String; feldl:Byte; Var s:String);
 Const ChrHght=10;
 Var ta:Byte; l:Word;
 begin
 ta:=TextAttr;
 TextBackGround(Blue); TextColor(Yellow);
 l:=Length(frage)+feldl+4;
 RahmenXYG(XGet,YGet,l*ChrPtch,3*ChrHght);
 AcceptXYG(XGet+2*ChrPtch,YGet+ChrHght,feldl,frage,[],s,rm);
 TextAttr:=ta;
 end;


procedure Message(text:String);
 Const ChrHght=10;
 Var ta:Byte; l:Word;
 begin
 ta:=TextAttr;
 TextBackGround(LightGray); TextColor(Blue);
 l:=Length(text)+4;
 RahmenXYG(XMss,YMss,l*ChrPtch,3*ChrHght);
 WriteXYG(XMss+2*ChrPtch,YMss+ChrHght,text);
 TextAttr:=ta;
 end;

procedure ErrorMessage(text:String);
 Const ChrHght=10;
 Var ta:Byte; l:Word;
 begin
 ta:=TextAttr;
 TextBackGround(Red); TextColor(Black);
 l:=Length(text)+4;
 RahmenXYG(XMss,YMss,l*ChrPtch,3*ChrHght);
 WriteXYG(XMss+2*ChrPtch,YMss+ChrHght,text);
 TextAttr:=ta;
 end;




begin
OvWrt:=False;
end.