unit JS_FIO;


Interface

Uses
 graph,dos,crt,js_sub,js_tio,js_acc;

Type
 FileNameStr=String[12];
 FileEntry=  record
              name: FileNameStr;
              attr: Byte;
             end;
 DirCont_T=  record
              anz: Word;
              filefld: array [1..220] of FileEntry;
             end;

Var
 DirCont:DirCont_T;

procedure GetDirCont(pfad:PathStr; name:FileNameStr);

function  FileExists(pfad:PathStr; name:FileNameStr):Boolean;

procedure SlctFileName(zeile,spalte:Word;
                       Var name:FileNameStr;
                       Var attr:Byte);

procedure SlctFileNameG(x,y:Integer;
                       Var name:FileNameStr;
                       Var attr:Byte);

procedure GtRdFileName(zeile,spalte:Word;
                       Var pfad:PathStr;
                       Var name:PathStr);

procedure GtRdFileNameG(x,y:Integer;
                       Var pfad:PathStr;
                       Var name:PathStr);

procedure GtWrFileName(zeile,spalte:Word;
                       Var pfad:PathStr;
                       Var name:PathStr);

procedure GtWrFileNameG(x,y:Integer;
                        Var pfad:PathStr;
                        Var name:PathStr);


Implementation

procedure GetDirCont(pfad:PathStr; name:FileNameStr);
 Var Srch:SearchRec;
 begin
 with DirCont do
  begin
  FindFirst(pfad+'*.*',Directory,Srch);
  anz:=1;
  while DosError=0 do with filefld[anz] do
   begin
   if (Srch.attr=Directory) and (Srch.name<>'.') then
    begin
    name:=Srch.name;
    attr:=Srch.attr;
    Inc(anz);
    end;
   FindNext(Srch);
   end;
  FindFirst(pfad+name,Archive,Srch);
  while DosError=0 do with filefld[anz] do
   begin
   name:=Srch.name;
   attr:=Srch.attr;
   Inc(anz);
   FindNext(Srch);
   end;
  Dec(anz);
  end;
 end;


function FileExists(pfad:PathStr; name:FileNameStr):Boolean;
 Var Srch:SearchRec;
 begin
 FindFirst(pfad+name,Directory,Srch);
 FileExists:=(DosError=0);
 end;



procedure SlctFileName(zeile,spalte:Word;
                       Var name:FileNameStr;
                       Var attr:Byte);
 Const
  MaxDspl=10;
 Var
  i,j,k,anzdspl,ta:Word;
  s,sd:String;
  ch:Char;
  fertig,escape:Boolean;

 begin
 ta:=TextAttr;
 for j:=0 to MaxDspl-1 do begin
                          TextBackGround(Cyan);
                          GoToXY(spalte,zeile+j);
                          Write(RptStr(20,' '));
                          end;
 with DirCont do
  begin
  if anz=0 then
   begin
   Textbackground(Red); GoToXY(spalte+3,zeile+1); Write('no files found');
   escape:=True;
   end
  else
   begin
   i:=1; k:=i;
   anzdspl:=MinI(MaxDspl,anz);
   fertig:=False; escape:=False;
   TextBackGround(Cyan);
   repeat
    for j:=0 to anzdspl-1 do
     begin
     if filefld[i+j].attr=Directory then sd:='<DIR> ' else sd:='      ';
     if i+j=k then TextColor(Red) else TextColor(Black);
     s:=' '+FillStr(filefld[i+j].name,12)+' '+sd;
     GoToXY(spalte,zeile+j); Write(s);
     end;
    ch:=ReadKey;
    case ch of
     #13: fertig:=True;
     #27: begin fertig:=True; escape:=True; end;
     #0:  begin
          ch:=ReadKey;
          case ch of
           #71: if i=1 then k:=1 else i:=1;
           #72: if k=i then begin i:=MaxI(i-1,1); k:=i end
                       else Dec(k);
           #73: i:=MaxI(i-anzdspl+2,1);
           #79: i:=anz-anzdspl+1;
           #80: if k=i+anzdspl-1 then begin
                                   i:=MinI(i+1,anz-anzdspl+1);
                                   k:=i+anzdspl-1
                                   end
                              else Inc(k);
           #81: i:=MinI(i+anzdspl-2,anz-anzdspl+1);
          end;
          k:=MinI(MaxI(k,i),i+anzdspl-1);
          end;
    end;
    until fertig;
    end;
  if escape then begin name:=''; attr:=128; end
            else begin name:=filefld[k].name; attr:=filefld[k].attr; end;
  end;
 TextAttr:=ta;
 end;



procedure SlctFileNameG(x,y:Integer;
                        Var name:FileNameStr;
                        Var attr:Byte);
 Const
  MaxDspl=16;
  ChrHght=10;

 Var
  savecolor,ta:Word;
  fp:FillsettingsType;
  i:Integer;
  j,k,anzdspl:Word;
  s,sd:String;
  ch:Char;
  fertig,escape:Boolean;

 begin
 ta:=TextAttr;
 GetFillSettings(fp);
 SetFillStyle(SolidFill,Cyan);
 Bar(x,y,x+20*ChrPtch,y+MaxDspl*ChrHght);
 with DirCont do
  begin
  if anz=0 then
   begin
   Textbackground(Red);
   WriteXYG(x+3*ChrPtch,y+ChrHght,'no files found');
   escape:=True;
   end
  else
   begin
   i:=1; k:=i;
   anzdspl:=MinI(MaxDspl,anz);
   fertig:=False; escape:=False;
   TextBackGround(Cyan);
   repeat
    if not KeyPressed then
    for j:=0 to anzdspl-1 do
     begin
     if filefld[i+j].attr=Directory then sd:='<DIR> ' else sd:='      ';
     if i+j=k then TextColor(Red) else TextColor(Black);
     s:=' '+FillStr(filefld[i+j].name,12)+' '+sd;
     WriteXYG(x,y+j*ChrHght,s);
     end;
    ch:=ReadKey;
    case ch of
     #13: fertig:=True;
     #27: begin fertig:=True; escape:=True; end;
     #0:  begin
          ch:=ReadKey;
          case ch of
           #71: if i=1 then k:=1 else i:=1;
           #72: if k=i then begin i:=MaxI(i-1,1); k:=i end
                       else Dec(k);
           #73: i:=MaxI(i-anzdspl+2,1);
           #79: if i=anz-anzdspl+1 then k:=anz else i:=anz-anzdspl+1;
           #80: if k=i+anzdspl-1 then begin
                                   i:=MinI(i+1,anz-anzdspl+1);
                                   k:=i+anzdspl-1
                                   end
                              else Inc(k);
           #81: i:=MinI(i+anzdspl-2,anz-anzdspl+1);
          end;
          k:=MinI(MaxI(k,i),i+anzdspl-1);
          end;
    end;
    until fertig;
    end;
  if escape then begin name:=''; attr:=128; end
            else begin name:=filefld[k].name; attr:=filefld[k].attr; end;
  end;
 SetFillStyle(fp.Pattern,fp.Color);
 TextAttr:=ta;
 end;



procedure GtRdFileName(zeile,spalte:Word;
                       Var pfad:PathStr;
                       Var name:PathStr);

 Const
  Breite=50; Hoehe=15;
 Var
  ta:Word;
  fertig,escape,zurueck:Boolean;
  pfd:DirStr; nm:NameStr; ext:ExtStr;
  filter:FileNameStr;
  attr:Byte;

 begin
 ta:=TextAttr;
 with DirCont do
  begin
  TextBackGround(LightGray);
  TextColor(White); Rahmen(zeile,spalte,Breite,Hoehe);
  GoToXY(spalte,zeile+2); Write(''+RptStr(Breite-2,'')+'');
  TextColor(Black); GoToXY(spalte+2,zeile+3); Write('FILES');

  fertig:=False; escape:=False; ovwrt:=True; name:='';
  repeat
   Accept(zeile+1,spalte+2,Breite-10,'PATH: ',ValDn,pfad,rm);
   escape:=(rm=escp);
   if rm=rtrn then
    begin
    pfad:=FExpand(Trim(pfad)); FSplit(pfad,pfd,nm,ext);
    if Leer(nm) and Leer(ext) then begin nm:='*'; ext:='.*' end;
    filter:=nm+ext;
    zurueck:=False;
    repeat
     GoToXY(spalte+8,zeile+1); Write(FillStr(pfd+filter,Breite-10));
     GetDirCont(pfd,filter);
     With DirCont do begin
                     TextColor(Blue);
                      GoToXY(spalte+Breite-10,zeile+Hoehe-2);
                      Write(StrI(anz,3)+' Files');
                     TextColor(Black);
                     end;
     SlctFileName(zeile+4,spalte+2,name,attr);
     case attr of
      128:       zurueck:=True;
      Directory: if name='..' then repeat pfd:=Copy(pfd,1,length(pfd)-1);
                                   until pfd[Length(pfd)]='\'
                              else pfd:=pfd+name+'\';
      else       begin name:=pfd+name; fertig:=True; end;
     end;
   until (fertig or zurueck);
   end;
  until (fertig or escape);
  end;
 TextAttr:=ta;
 end;

procedure GtRdFileNameG(x,y:Integer;
                        Var pfad:PathStr;
                        Var name:PathStr);

 Const
  Breite=50; Hoehe=21; ChrHght=10;
 Var
  ta:Word;
  lp:LineSettingsType;
  fertig,escape,zurueck:Boolean;
  pfd:DirStr; nm:NameStr; ext:ExtStr;
  filter:FileNameStr;
  attr:Byte;

 begin
 ta:=TextAttr;
 GetLineSettings(lp);
 with DirCont do
  begin
  TextBackGround(LightGray);
  TextColor(White); RahmenXYG(x,y,Breite*ChrPtch,Hoehe*ChrHght);
  SetColor(White); MoveTo(x+6,y+22); LineTo(x+Breite*ChrPtch-7,y+22);
  TextColor(Black); WriteXYG(x+2*ChrPtch,y+3*ChrHght,'FILES');

  fertig:=False; escape:=False; ovwrt:=True; name:='';
  repeat
   AcceptXYG(x+2*ChrPtch,y+ChrHght+1,Breite-10,'PATH: ',ValDn,pfad,rm);
   escape:=(rm=escp);
   if rm=rtrn then
    begin
    pfad:=FExpand(Trim(pfad)); FSplit(pfad,pfd,nm,ext);
    if Leer(nm) and Leer(ext) then begin nm:='*'; ext:='.*' end;
    filter:=nm+ext;
    zurueck:=False;
    repeat
     WriteXYG(x+8*ChrPtch,y+ChrHght+1,FillStr(pfd+filter,Breite-10));
     GetDirCont(pfd,filter);
     With DirCont do
      begin
      TextColor(Blue);
      WriteXYG(x+(Breite-10)*ChrPtch,y+(Hoehe-2)*ChrHght,StrI(anz,3)+' Files');
      TextColor(Black);
      end;
     SlctFileNameG(x+2*ChrPtch,y+4*ChrHght,name,attr);
     case attr of
      128:       zurueck:=True;
      Directory: if name='..' then repeat pfd:=Copy(pfd,1,length(pfd)-1);
                                   until pfd[Length(pfd)]='\'
                              else pfd:=pfd+name+'\';
      else       begin name:=pfd+name; fertig:=True; end;
     end;
   until (fertig or zurueck);
   end;
  until (fertig or escape);
  end;
 SetLineStyle(lp.LineStyle,lp.Pattern,lp.Thickness);
 TextAttr:=ta;
 end;



procedure GtWrFileName(zeile,spalte:Word;
                       Var pfad:PathStr;
                       Var name:PathStr);

 Const
  Breite=50; Hoehe=15;
 Var
  ta:Word;
  fertig,escape,zurueck,akzept:Boolean;
  pfd:DirStr; nm:NameStr; ext:ExtStr;
  filter:FileNameStr;
  attr:Byte;

 function OvrWrtChck:Boolean;
  Var chr:Char; ta:Byte;
  begin
  if not FileExists(pfd,name) then OvrWrtChck:=True else
   begin
   ta:=TextAttr;
   OvrWrtChck:=False;
   TextBackground(LightGray); TextColor(Red);
   GoToXY(spalte+26,zeile+6); Write('File');
   GoToXY(spalte+26,zeile+7); Write('already exists');
   GoToXY(spalte+26,zeile+8); Write('overwrite y/n?');
   chr:=ReadKey;
   if chr='y' then OvrWrtChck:=True;
   GoToXY(spalte+26,zeile+6); Write('    ');
   GoToXY(spalte+26,zeile+7); Write('              ');
   GoToXY(spalte+26,zeile+8); Write('               ');
   TextAttr:=ta;
   end;
  end;


 begin
 ta:=TextAttr;
 with DirCont do
  begin
  TextBackGround(LightGray);
  TextColor(White); Rahmen(zeile,spalte,Breite,Hoehe);
  GoToXY(spalte,zeile+2); Write(''+RptStr(Breite-2,'')+'');
  TextColor(Black);
  GoToXY(spalte+ 2,zeile+3); Write('FILES');
  GoToXY(spalte+26,zeile+3); Write('FILENAME');

  fertig:=False; escape:=False; ovwrt:=True; name:='';
  repeat
   Accept(zeile+1,spalte+2,Breite-10,'PATH: ',ValDn,pfad,rm);
   escape:=(rm=escp);
   if rm=rtrn then
    begin
    pfad:=FExpand(Trim(pfad)); FSplit(pfad,pfd,nm,ext);
    if Leer(nm) and Leer(ext) then begin nm:='*'; ext:='.*' end;
    filter:=nm+ext;
    zurueck:=False;
    repeat
     GoToXY(spalte+8,zeile+1); Write(FillStr(pfd+filter,Breite-10));
     GetDirCont(pfd,filter);
     With DirCont do begin
                     TextColor(Blue);
                      GoToXY(spalte+Breite-10,zeile+Hoehe-2);
                      Write(StrI(anz,3)+' Files');
                     TextColor(Black);
                     end;
     SlctFileName(zeile+4,spalte+2,name,attr);
     case attr of
      Directory: if name='..' then repeat pfd:=Copy(pfd,1,length(pfd)-1);
                                   until pfd[Length(pfd)]='\'
                              else pfd:=pfd+name+'\';
      0,Archive,128: begin
                     TextBackground(Green);
                     akzept:=False;
                     repeat
                      Accept(zeile+4,spalte+26,12,'',ValDn,name,rm);
                      case rm of
                       rtrn: begin
                             if OvrWrtChck then begin
                                                name:=pfd+name;
                                                akzept:=True;
                                                fertig:=True;
                                                end;
                             end;
                       escp: begin akzept:=True; zurueck:=True; end;
                       else  begin
                             GoToXY(spalte+26,zeile+4);
                             Write(RptStr(12,' '));
                             akzept:=True;
                             end;
                      end;
                     until akzept;
                     Textbackground(LightGray);
                     end;
     end;
   until (fertig or zurueck);
   end;
  until (fertig or escape);
  end;
 TextAttr:=ta;
 end;


procedure GtWrFileNameG(x,y:Integer;
                        Var pfad:PathStr;
                        Var name:PathStr);

 Const
  Breite=50; Hoehe=21; ChrHght=10;
 Var
  ta:Word;
  lp:LineSettingsType;
  fertig,escape,zurueck,akzept:Boolean;
  pfd:DirStr; nm:NameStr; ext:ExtStr;
  filter:FileNameStr;
  attr:Byte;


 function OvrWrtChck:Boolean;
  Var chr:Char; ta:Byte; xx:Integer;
  begin
  if not FileExists(pfd,name) then OvrWrtChck:=True else
   begin
   ta:=TextAttr;
   xx:=x+26*ChrPtch;
   OvrWrtChck:=False;
   TextBackground(LightGray); TextColor(Red);
   WriteXYG(xx,y+6*ChrHght,'File');
   WriteXYG(xx,y+7*ChrHght,'already exists');
   WriteXYG(xx,y+9*ChrHght,'overwrite y/n?');
   chr:=ReadKey;
   if chr='y' then OvrWrtChck:=True;
   WriteXYG(xx,y+6*ChrHght,'    ');
   WriteXYG(xx,y+7*ChrHght,'              ');
   WriteXYG(xx,y+9*ChrHght,'               ');
   TextAttr:=ta;
   end;
  end;


 begin
 ta:=TextAttr;
 GetLineSettings(lp);
 with DirCont do
  begin
  TextBackGround(LightGray);
  TextColor(White); RahmenXYG(x,y,Breite*ChrPtch,Hoehe*ChrHght);
  SetColor(White); MoveTo(x+6,y+22); LineTo(x+Breite*ChrPtch-7,y+22);
  TextColor(Black);
  WriteXYG(x+ 2*ChrPtch,y+3*ChrHght,'FILES');
  WriteXYG(x+26*ChrPtch,y+3*ChrHght,'FILENAME');

  fertig:=False; escape:=False; ovwrt:=True; name:='';
  repeat
   AcceptXYG(x+2*ChrPtch,y+ChrHght+1,Breite-10,'PATH: ',ValDn,pfad,rm);
   escape:=(rm=escp);
   if rm=rtrn then
    begin
    pfad:=FExpand(Trim(pfad)); FSplit(pfad,pfd,nm,ext);
    if Leer(nm) and Leer(ext) then begin nm:='*'; ext:='.*' end;
    filter:=nm+ext;
    zurueck:=False;
    repeat
     WriteXYG(x+8*ChrPtch,y+ChrHght+1,FillStr(pfd+filter,Breite-10));
     GetDirCont(pfd,filter);
     With DirCont do
      begin
      TextColor(Blue);
      WriteXYG(x+(Breite-10)*ChrPtch,y+(Hoehe-2)*ChrHght,StrI(anz,3)+' Files');
      TextColor(Black);
      end;
     SlctFileNameG(x+2*ChrPtch,y+4*ChrHght,name,attr);
     case attr of
      Directory: if name='..' then repeat pfd:=Copy(pfd,1,length(pfd)-1);
                                   until pfd[Length(pfd)]='\'
                              else pfd:=pfd+name+'\';
      0,Archive,128: begin
                     TextBackground(Green);
                     akzept:=False;
                     repeat
                      AcceptXYG(x+26*ChrPtch,y+4*ChrHght,12,'',ValDn,name,rm);
                      case rm of
                       rtrn: begin
                             if OvrWrtChck then begin
                                                name:=pfd+name;
                                                akzept:=True;
                                                fertig:=True;
                                                end;
                             end;
                       escp: begin akzept:=True; zurueck:=True; end;
                       else  begin
                             WriteXYG(x+26*ChrPtch,y+4*ChrHght,RptStr(12,' '));
                             akzept:=True;
                             end;
                      end;
                     until akzept;
                     Textbackground(LightGray);
                     end;
     end;
   until (fertig or zurueck);
   end;
  until (fertig or escape);
  end;
 SetLineStyle(lp.LineStyle,lp.Pattern,lp.Thickness);
 TextAttr:=ta;
 end;


begin
end.