unit JS_GRA;


Interface

Uses
 graph;

Type
 ChckF_T=function(x,y:Integer;nr1,nr2:Word):Boolean;

Const
 LMuster: array[0..9] of Word = ($FFFF,          {****************}
                                 $5555,          { * * * * * * * *}
                                 $3333,          {  **  **  **  **}
                                 $0F0F,          {    ****    ****}
                                 $2727,          {  *  ***  *  ***}
                                 $5F5F,          { * ***** * *****}
                                 $33FF,          {  **  **********}
                                 $1111,          {   *   *   *   *}
                                 $0101,          {       *       *}
                                 $0001);         {               *}

VAR
 l_art: Word;                     {ausgewhltes Muster}
 p_mst: Word;                     {Pointer im Muster  }
 x_vrg: Integer;                  {letzter Wert der Bildsp.-Koordinate x }
 y_vrg: Integer;                  {letzter Wert der Bildsp.-Koordinate y }


procedure LPutPixel(x,y:Integer);      
procedure LMoveTo(x,y:Integer);
procedure LLineTo(x,y:Integer);

procedure LPutPixelChck(x,y:Integer; nr1,nr2:Word;Chck:ChckF_T);
procedure LMoveToChck(x,y:Integer; nr1,nr2:Word;Chck:ChckF_T);
procedure LLineToChck(x,y:Integer; nr1,nr2:Word;Chck:ChckF_T);


Implementation


procedure LPutPixel(x,y:Integer);
 begin                                {malt Punkt nach gegebenem Muster l_art}
 if (l_art AND p_mst)=p_mst then PutPixel(x,y,GetColor);
 p_mst:=p_mst shl 1; if p_mst=0 then p_mst:=1;
 end;

procedure LMoveTo(x,y:Integer);
 begin                              {initialisiert zeichnen mit Muster l_art }
 p_mst:=1; LPutPixel(x,y); x_vrg:=x; y_vrg:=y;
 end;

procedure LLineTo(x,y:Integer);
                                    {zeichnet Linie nach x,y mit Muster l_art}
 VAR delx,dely,j: Integer; mm:real;
 begin
 delx:=x-x_vrg; dely:=y-y_vrg;
 case ( Abs(delx) >= Abs(dely) ) of
  TRUE : begin
         if delx<>0 then
          begin
          mm:=dely/delx;
          if delx>0 then for j:= 1     to delx do LPutPixel(x_vrg+j,y_vrg+round(mm*j))
                    else for j:=-1 downto delx do LPutPixel(x_vrg+j,y_vrg+round(mm*j));
          end;
         end;
  FALSE: begin
         if dely<>0 then
          begin
          mm:=delx/dely;
          if dely>0 then for j:= 1     to dely do LPutPixel(x_vrg+round(mm*j),y_vrg+j)
                    else for j:=-1 downto dely do LPutPixel(x_vrg+round(mm*j),y_vrg+j);
          end;
         end;
 end;
 x_vrg:=x; y_vrg:=y;
 end;


procedure LPutPixelChck(x,y:Integer; nr1,nr2:Word;Chck:ChckF_T);
 begin                                {malt Punkt nach gegebenem Muster l_art}
 if Chck(x,y,nr1,nr2) and ((l_art AND p_mst)=p_mst) then PutPixel(x,y,GetColor);
 p_mst:=p_mst shl 1; if p_mst=0 then p_mst:=1;
 end;

procedure LMoveToChck(x,y:Integer; nr1,nr2:Word;Chck:ChckF_T);
 begin                              {initialisiert zeichnen mit Muster l_art }
 p_mst:=1; LPutPixelChck(x,y,nr1,nr2,Chck); x_vrg:=x; y_vrg:=y;
 end;

procedure LLineToChck(x,y:Integer; nr1,nr2:Word;Chck:ChckF_T);
                                    {zeichnet Linie nach x,y mit Muster l_art}
 VAR delx,dely,j: Integer; mm:real;
 begin
 delx:=x-x_vrg; dely:=y-y_vrg;
 case ( Abs(delx) >= Abs(dely) ) of
  TRUE : begin
         if delx<>0 then
          begin
          mm:=dely/delx;
          if delx>0 then for j:= 1     to delx do LPutPixelChck(x_vrg+j,y_vrg+round(mm*j),nr1,nr2,Chck)
                    else for j:=-1 downto delx do LPutPixelChck(x_vrg+j,y_vrg+round(mm*j),nr1,nr2,Chck);
          end;
         end;
  FALSE: begin
         if dely<>0 then
          begin
          mm:=delx/dely;
          if dely>0 then for j:= 1     to dely do LPutPixelChck(x_vrg+round(mm*j),y_vrg+j,nr1,nr2,Chck)
                    else for j:=-1 downto dely do LPutPixelChck(x_vrg+round(mm*j),y_vrg+j,nr1,nr2,Chck);
          end;
         end;
 end;
 x_vrg:=x; y_vrg:=y;
 end;


begin
end.