unit JS_HERC;


interface

uses dos,crt,js_sub;

Type
 BldopT = (rnd_bld, cop_bld, not_bld, and_bld, or_bld, xor_bld);

Const
 SgmPage: Array[0..1] of Longint = ($B000, $B800);



function  ChkHerc:Boolean;

procedure WrBild(name:PathStr; page:Word; Var OK:Boolean);
procedure RdBildH(name:PathStr; page:Word; Var OK:Boolean);
procedure RdBild(name:PathStr; page:Word; Var OK:Boolean);

procedure BildOp(op:BldopT; p1,p2,pa:Word);


implementation

function ChkHerc:Boolean;
 var chk:Boolean;
 begin
 chk:=(GrDr=7);
 if not chk then begin
                 writeln('Voraussetzung HerculesMode nicht erfllt');
                 writeln('Vor Programmstart HERC und INT10 aufrufen');
                 end;
 ChkHerc:=chk;
 end;


procedure WrBild(name:PathStr; page:Word; Var OK:Boolean);
 Var
  datei:File;                      
  sgm:Longint;

 begin
 Assign(datei,name); {$I-} Rewrite(datei) {$I+}; OK:=(IOResult=0);
 if OK then begin
            sgm:=SgmPage[page];
            BlockWrite(datei,Mem[sgm:0],256);
            Close(datei);
            end;
 end;




procedure RdBildH(name:PathStr; page:Word; Var OK:Boolean);
          {Spezialversion fr Hardcard Plus}
 Var
  datei:File;
  sgm:Longint;
  buff:Array [0..127] of Byte;
  i:Integer;

 begin
 Assign(datei,name); {$I-} Reset(datei) {$I+}; OK:=(IOResult=0);
 if OK then begin
             sgm:=SgmPage[page];
             BlockRead(datei,buff,1);
             for i:=1 to 127 do Mem[sgm:(i-1)]:=buff[i];
             BlockRead(datei,Mem[sgm:127],255);
             Close(datei);
             end;
 end;



procedure RdBild(name:PathStr; page:Word; Var OK:Boolean);
 Var
  datei:File;
  sgm:Longint;

 begin
 Assign(datei,name); {$I-} Reset(datei) {$I+}; OK:=(IOResult=0);
 if OK then begin
            sgm:=SgmPage[page];
            BlockRead(datei,Mem[sgm:0],256);
            Close(datei);
            end;
 end;


procedure BildOp(op:BldopT; p1,p2,pa:Word);
 Var
  i,i0,j,j0,k:Integer;
  sgm1,sgm2,sgma:Longint;

 begin
 sgm1:=SgmPage[p1]; sgm2:=SgmPage[p2]; sgma:=SgmPage[pa];
 for i:=0 to 86 do
  begin
  i0:=90*i;
  for j:=0 to  3 do
   begin
   j0:=j shl 13;
   case op of
    rnd_bld: for k:=0 to 89 do
              Mem[sgma:i0+j0+k]:=random(256);
    cop_bld: for k:=0 to 44 do
              Memw[sgma:i0+j0+2*k]:= Memw[sgm1:i0+j0+2*k];
    not_bld: for k:=0 to 44 do
              Memw[sgma:i0+j0+2*k]:= not Memw[sgm1:i0+j0+2*k];
    and_bld: for k:=0 to 44 do
              Memw[sgma:i0+j0+2*k]:= Memw[sgm1:i0+j0+2*k] and Memw[sgm2:i0+j0+2*k];
     or_bld: for k:=0 to 44 do
              Memw[sgma:i0+j0+2*k]:= Memw[sgm1:i0+j0+2*k]  or Memw[sgm2:i0+j0+2*k];
    xor_bld: for k:=0 to 44 do
              Memw[sgma:i0+j0+2*k]:= Memw[sgm1:i0+j0+2*k] xor Memw[sgm2:i0+j0+2*k];
   end;
   end;
  end;
 end;

begin
end.