unit JS_LSTR;

Interface

Uses js_sub;

Const
 LStrLen=5000;


Type
 LStr_T  = record
            Len: Word;
            Seq: Array[1..LStrLen] of Char;
           end;
 LStrF_T = File of Char;

Var
 LStrF:LStrF_T;
 Cr:Char;
 Lf:Char;

procedure MkLStr(Var l:LStr_T; s:String);
procedure ApLStr(Var l:LStr_T; s:String);
procedure ExLStr(l:LStr_T; p:Word; ls:Byte; Var s:String);

procedure WrLStrLn(Var f:LStrF_T; l:LStr_T);
procedure RdLStrLn(Var f:LStrF_T; Var l:LStr_T);


Implementation

procedure MkLStr(Var l:LStr_T; s:String);
 Var i,lneu:Word;
 begin
 lneu:=MinI(Length(s),LStrLen);
 for i:=1 to lneu do l.seq[i]:=s[i];
 l.Len:=lneu;
 end;

procedure ApLStr(Var l:LStr_T; s:String);
 Var i,lalt,lneu,ls:Word;
 begin
 ls:=Length(s);
 lalt:=l.Len; lneu:=MinI(lalt+ls,LStrLen);
 for i:=1 to ls do l.seq[lalt+i]:=s[i];
 l.Len:=lneu;
 end;

procedure ExLStr(l:LStr_T; p:Word; ls:Byte; Var s:String);
 Var i:Word;
 begin
 s:='';
 for i:=p to MinI(p+ls-1,l.Len) do s:=s+l.seq[i];
 end;


procedure WrLStrLn(Var f:LStrF_T; l:LStr_T);
 Var i:Word;
 begin
 for i:=1 to l.Len do write(f,l.Seq[i]);
 write(f,Cr);
 write(f,Lf);
 end;

procedure RdLStrLn(Var f:LStrF_T; Var l:LStr_T);
 Var i:Word; ch:Char;
 begin
 i:=0; ch:=#32;
 while not (ch=Cr) do begin
                      Inc(i); read(f,ch); l.Seq[i]:=ch;
                      end;
 l.Len:=i;
 read(f,ch);
 end;


begin
 Cr:=#13; Lf:=#10;
end.