unit JS_MAT;

Interface

Uses
 js_sub,js_mtr;

function  SinH(x:real):real;
function  CosH(x:real):real;

function  Nvt:real;
procedure NvtV(Var v:Vector_2);
function  WdNvt(x:real; mittelwert:real; sigma:real):real;
function  WdNvtV(ikv:Matrix_2; pmax:Real; cen:Vector_2; v:Vector_2):Real;
function  Sigmoid(x:Real):Real;



Implementation

function  SinH(x:real):real;
 begin SinH:=0.5*(exp(x)-exp(-x)); end;

function  CosH(x:real):real;
 begin CosH:=0.5*(exp(x)+exp(-x)); end;

function  Nvt:real;
 VAR i: integer; w: real;
 begin
 w:=-6;
 for i:=1 to 12 do w:=w+Random;
 Nvt:=w;
 end;

procedure NvtV(Var v:Vector_2);
 begin v[1]:=Nvt; v[2]:=Nvt; end;

function  WdNvt(x:real; mittelwert:real; sigma:real):real;
 begin
 WdNvt:=1/(sqrt(2*PI)*sigma)*exp(MaxR(-70,-0.5*sqr((x-mittelwert)/sigma)));
 end;

function  WdNvtV(ikv:Matrix_2; pmax:Real; cen:Vector_2; v:Vector_2):Real;
 begin
 SubVV(v,cen,v);
 WdNvtV:=pmax*exp(MaxR(-70,-0.5*Quaf(ikv,v)))
 end;

function  Sigmoid(x:Real):Real;
 begin
 Sigmoid:=1/(1+Exp(MinR(70,MaxR(-70,-x))));
 end;


begin
end.