unit JS_NNT;


Interface

Uses
 dos,crt,graph,js_gra,js_sub,js_tio,js_acc,js_mtr,js_koor,js_mat,js_stm;

Const
 MaxAnzNodes = 10;

Type
 NntModul_T = record
               AnzIn, AnzOut: Integer;
               VectIn: Array[0..MaxAnzNodes] of Real;
               VectOut, DiffIn, DiffOut: Array[1..MaxAnzNodes] of Real;
               Koeff: Array[1..MaxAnzNodes,0..MaxAnzNodes] of Real;
              end;

 Nnt_T = record
          AnzModuls: Integer;
          NntClasses: ClsLst_T;
          NntModul: Array[1..3] of NntModul_T;
         end;



Var
 NntPfad,              NntRdDatei,  NntSvDatei:   PathStr;
 ProPfad,                           ProSvDatei:   PathStr;

 ClsfMode:     Word;       {0<=>not  1<=>KLF  2<=>NNT}
 NntDatFertig: Boolean;
 WrPro:        Boolean;
 ShPro:        Boolean;
 SumRadQ:      Real;
 SumErr:       Integer;
 SumDeltaD:    DVkt_T;
 StepPro:      LongInt;
 AnzSmpl:      LongInt;
 ProSvFile:    Text;

 Netz:         Nnt_T;
 InitGew:      Real;
 AlphaNnt:     Real;
 AlphaKlf:     Real;
 Lernen:       Boolean;
 StAnz:        Longint;
 AlphaCon:     Boolean;
 AlphaZykl:    LongInt;
 AlphaFak:     Real;
 AlphaMin:     Real;

 ClsLst:       ClsLst_T;
 Klanz:        Word;

 HDiagInv:     Array[1..6] of Real;

 FirstLayerNode:     Word;
 NntFirstLColor:     Word;
 NntFirstLLineStyle: Integer;



procedure PfadeInitNnt(PfadeMaske: MskPar_T);
procedure ColorInitNnt(FarbeMaske:MskPar_T);
procedure ProtokollKopf;
procedure Protokoll;

procedure InitNntVar(Var Nnt:Nnt_T);
procedure InitNntGew(Var Nnt:Nnt_T);
procedure SaveNnt(NntSvDatei:PathStr; Nnt:Nnt_T; Var OK:Boolean);
procedure LoadNnt(NntRdDatei:PathStr; Var Nnt:Nnt_T; Var OK:Boolean);

procedure InputVNnt(v:Vector_2; Var Nnt:Nnt_T);
procedure OutputNnt(Nnt:Nnt_T; Var d:DVkt_T);
procedure InputErrorNnt(deltad:DVkt_T; Var Nnt:Nnt_T);
procedure ConnectForwNnt(m:Word; Var Nnt:Nnt_T);
procedure ConnectBackwNnt(m:Word; Var Nnt:nnt_T);
procedure ForwNnt(m:Word; Var Nnt:Nnt_T);
procedure DVektNnt(Var Nnt:Nnt_T; v:Vector_2; SmplClass:Char; Var ErkErg:ErkErg_T);
procedure BackProp(v:Vector_2; SmplClass:Char; ErkErg:ErkErg_T; Var Nnt:Nnt_T);

procedure ClsLstFromStMod(StMod:StMod_T; Var ClsLst:ClsLst_T; Var KlAnz:Word);
procedure ClsLstFromNnt(Nnt:Nnt_T; Var ClsLst:ClsLst_T; Var Klanz:Word);
procedure ClsLstFromClSlct(ClSlct:SetChar_T; Var Klanz:Word; Var ClsLst:ClsLst_T);

procedure InitKlf(Var KlfDat:KlfDat_T);
procedure InitHDiagInv;
procedure KlfRek(v:Vector_2; SmplClass:Char; ErkErg:ErkErg_T; Var KlfDat:KlfDat_T);

procedure GetNxtSmplNnt(Var v:Vector_2; Var StchpEnde:Boolean);
procedure PlotClassRegionsNnt(Nnt:Nnt_T);
procedure PlotClassBordersNnt(Nnt:Nnt_T);
procedure PlotZeroLineFirstLayerNnt(Nnt:Nnt_T; node:Word);


Implementation

procedure PfadeInitNnt(PfadeMaske: MskPar_T);
 begin
 KoorPfad:=   PfadeMaske.erg[ 1];
 KoorRdDflt:= PfadeMaske.erg[ 2];
 StModPfad:=  PfadeMaske.erg[ 3];
 StModRdDflt:=PfadeMaske.erg[ 4];
 FarbePfad:=  PfadeMaske.erg[ 5];
 FarbeRdDflt:=PfadeMaske.erg[ 6];
 StchpPfad:=  PfadeMaske.erg[ 7];
 StchpRdDflt:=PfadeMaske.erg[ 8];
 DVektPfad:=  PfadeMaske.erg[ 9];
 NntPfad:=    PfadeMaske.erg[10];
 ProPfad:=    PfadeMaske.erg[11];
 KlfPfad:=    PfadeMaske.erg[12];
 StatPfad:=   PfadeMaske.erg[13];
 EditorPfad:= PfadeMaske.erg[14];

 KoorRdDatei:= KoorRdDflt;
 StModRdDatei:=StModRdDflt;
 FarbeRdDatei:=FarbeRdDflt;
 StchpRdDatei:=StchpRdDflt;
 end;


procedure ColorInitNnt(FarbeMaske:MskPar_T);
 Var i:Word; s:String; wert:Real;
 begin
 DskTpColor[0]:=     ColorFromStr(FarbeMaske.erg[1]);
 DskTpColor[1]:=     ColorFromStr(FarbeMaske.erg[2]);
 KoorColor:=         ColorFromStr(FarbeMaske.erg[3]);
 if UpCaseWord(FarbeMaske.erg[4])='KLASSE'
  then HauptachsenColor:= 255
  else HauptachsenColor:= ColorFromStr(FarbeMaske.erg[4]);
 HauptachsenLnWdth:= ValI(Trim(FarbeMaske.erg[5]));
 if UpCaseWord(FarbeMaske.erg[6])='KLASSE'
  then EllipsenColor:=    255
  else EllipsenColor:=    ColorFromStr(FarbeMaske.erg[6]);
 s:=UpCaseWord(Trim(FarbeMaske.erg[7]));
 EllipsenTyp:=s[1];
 i:=0;
 wert:=ValR(Trim(FarbeMaske.erg[8+i]));
 while wert<>0 do
  begin
  Inc(i);
  EllipsenWert[i]:=wert;
  wert:=ValR(Trim(FarbeMaske.erg[8+i]));
  end;
 EllipsenAnz:=i;
 ModellGrenzenColor:=     ColorFromStr(FarbeMaske.erg[14]);
 ModellGrenzenLineStyle:= ValI(Trim(FarbeMaske.erg[15]));
 if UpCaseWord(FarbeMaske.erg[16])='KLASSE'
  then DFunktColor:=      255
  else DfunktColor:=      ColorFromStr(FarbeMaske.erg[16]);
 QMKGrenzenColor:=        ColorFromStr(FarbeMaske.erg[17]);
 QMKGrenzenLineStyle:=    ValI(Trim(FarbeMaske.erg[18]));
 end;


procedure ProtokollKopf;
 begin
 writeln(ProSvFile,'* Protokolldatei aus NNTREK.PAS');
 writeln(ProSvFile,'* -----------------------------');
 writeln(ProSvFile,'* Klassifikator ..........: '+KlfSrc);
 writeln(ProSvFile,'* Merkmals-Vektoren aus ..: '+StchpSrc);
 writeln(ProSvFile,'* Stichprobenanzahl = '+StrLongI(StAnz,12));
 writeln(ProSvFile,'* --------------------------------------');
 writeln(ProSvFile,'*      Anz       MeanRest      MeanError    MeanDeltaDQ');
                   {1234567890123456789012345678901234567890123456789012345}
 end;


procedure Protokoll;
 Var MeanRadQ,MeanErr:Real; MeanDeltaD:DVkt_T; k:Word; MeanDeltaDQ:Real;
 begin
 SumRadQ:=SumRadQ+ErkErg.radqcls;
 for k:=1 to ErkErg.anz do
  if ClsLst[k]<>SmplClass then SumDeltaD[k]:=SumDeltaD[k]+ErkErg.dvkt[k]
                          else SumDeltaD[k]:=SumDeltaD[k]+ErkErg.dvkt[k]-1;
 If not (ErkErg.labl[1]=ErkErg.class) then Inc(SumErr);
 if (AnzSmpl mod StepPro)=0 then
  begin
  MeanRadQ:=SumRadQ/StepPro; MeanErr:=SumErr/StepPro;
  MeanDeltaDQ:=0;
  for k:=1 to ErkErg.anz do MeanDeltaDQ:=MeanDeltaDQ+Sqr(SumDeltaD[k]/StepPro);
  If WrPro then Writeln(ProSvFile,AnzSmpl:10,
                                  MeanRadQ:15:5,
                                  MeanErr:15:5,
                                  MeanDeltaDQ:15:8);
  If ShPro then begin
                WriteXYG(460, 0,'Samples     = '+StrLongI(AnzSmpl,8));
                WriteXYG(460,10,'MeanRadQ    = '+StrR(MeanRadQ,8,3));
                WriteXYG(460,20,'MeanErr     = '+StrR(MeanErr,8,3));
                WriteXYG(460,30,'MeanDeltaDQ = '+StrR(MeanDeltaDQ,8,6));
                end;
  SumRadQ:=0; SumErr:=0; for k:=1 to ErkErg.anz do SumDeltaD[k]:=0;
  end;
 end;


procedure GetNxtSmplNnt(Var v:Vector_2; Var StchpEnde:Boolean);
 Var w:Vector_2; zuf:Real; modnr:Word; ch:Char; k:Word; slct:Boolean;
 begin
 if SmplSrcMod then
  begin
  zuf:=Random;
  modnr:=1; while not (zuf<=ModPar^.par[modnr].sumapr) do Inc(modnr);
  NvtV(w); ProjWV(modnr,w,v);
  SmplClass:=ModPar^.par[modnr].class;
  SmplColor:=ModPar^.par[modnr].color;
  Inc(SmplNr);
  end
 else
  begin
  if Eof(StchpRdFile) then
   begin
   if SmplZykl then Reset(StchpRdFile)
   else StchpEnde:=True;
   end;
  if not StchpEnde then
   begin
   if Stchp40 then RdVersion40(StchpRdFile,SmplClass,SmplNr,Index1,Index2,v)
              else ReadLn(StchpRdFile,SmplClass,SmplNr,v[1],v[2]);
   modnr:=1;
   while (not (SmplClass=ModPar^.par[modnr].class)
          and (modnr<ModPar^.anz)) do Inc(modnr);
   SmplColor:=ModPar^.par[modnr].color;
   end;
  end;
 if not StchpEnde then
  if (ClSlct=[]) or (SmplClass in ClSlct) then
   begin

   Inc(AnzSmpl);

   case PltSmpl of
    1: PlotV(v,SmplColor);
    2: begin
       SetColor(SmplColor);
       PlotSymbV(v,SmplClass);
       end;
   end;

   slct:=True;

   if Classify  then begin
                     case ClsfMode of
                      1: begin
                         DVekt(KlfDat,v,SmplClass,ErkErg);
                         if Lernen then KlfRek(v,SmplClass,ErkErg,KlfDat);
                         end;
                      2: begin
                         DVektNnt(Netz,v,SmplClass,ErkErg);
                         if Lernen then BackProp(v,SmplClass,ErkErg,Netz);
                         end;
                     end;
                     if DsplErkErg then ShowErkErg(ErkErg);

                     if (WrPro or ShPro) then Protokoll;
                     slct:=((Quality(ErkErg) and Byte(SlctCode))>0);
                     if WrDVkt and slct then with ErkErg do
                                              begin
                                              Write(DvektSvFile,SmplClass:1,
       		                                                SmplNr:12);
                                              for k:=1 to anz do
                                               Write(DVektSvFile,dvkt[k]:12:6);
                                              WriteLn(DvektSvFile);
                                              end;
                     if AkkStat then AkkumStatistik;
                     end;

   if WrSmpl and slct then WriteLn(StchpSvFile,SmplClass:1,
       		                               SmplNr:12,
                                               v[1]:12:6,
                                               v[2]:12:6);
   if SmplCount then CountClasses;
   if SmplMom   then AkkumMom;

   if (not AlphaCon) and ((AnzSmpl mod AlphaZykl)=0) then AlphaNnt:=MaxR(AlphaNnt*AlphaFak,AlphaMin);

   if KeyPressed or SnglStp then begin
                                 ch:=ReadKey;
                                 case ch of
                                  's','S': Snglstp   :=not Snglstp;
                                  #27:     StchpEnde :=True;
                                  end;
                                 end;

   end;
 end;


procedure InitNntVar(Var Nnt:Nnt_T);
 Var n,i: Word;
 begin
 with Nnt do for n:=1 to AnzModuls do with NntModul[n] do
             begin
             VectIn[0]:= 1;
             for i:=1 to AnzIn  do begin
                                   VectIn[i]:= 0;
                                   DiffIn[i]:= 0;
                                   end;
             for i:=1 to AnzOut do begin
                                   VectOut[i]:=0;
                                   DiffOut[i]:=0;
                                   end;
             end;
 end;


procedure InitNntGew(Var Nnt:Nnt_T);
 Var i,j,n: Word;
 begin
 with Nnt do for n:=1 to AnzModuls do with NntModul[n] do
             begin
             for i:=1 to AnzOut do
              for j:=0 to AnzIn do Koeff[i,j]:=InitGew*(random-0.5);
             end;
 end;


procedure SaveNnt(NntSvDatei:PathStr; Nnt:Nnt_T; Var OK:Boolean);
 Var i,j,k,n:Word; f:Text;
 begin
 Assign(f,NntSvDatei); {$I-} Rewrite(f); {$I+} OK:=(IOResult=0);
 if Ok then 
  begin
  writeln(f,'NNT');
  with Nnt do
   begin
   writeln(f,AnzModuls:3);
   for k:=1 to NntModul[AnzModuls].AnzOut do write(f,NntClasses[k]:3);
   writeln(f);
   for n:=1 to AnzModuls do with NntModul[n] do
    begin
    writeln(f,n:3,AnzIn:3,AnzOut:3);
    for i:=1 to AnzOut do
     begin
     for j:=0 to AnzIn do write(f,Koeff[i,j]:12:6);
     writeln(f);
     end;
    end;
   end;
  Close(f);
  end;
 end;


procedure LoadNnt(NntRdDatei:PathStr; Var Nnt:Nnt_T; Var OK:Boolean);
 Var i,j,k,n:Word; f:Text; s:String; dummy:Integer; 
 begin
 Assign(f,NntRdDatei); {$I-} ReSet(f); {$I+} OK:=(IOResult=0);
 if Ok then
  begin
  readln(f,s); OK:=(Trim(s)='NNT');
  if OK then with Nnt do
   begin
   readln(f,AnzModuls);
   readln(f,s); GetPar(s); NntModul[AnzModuls].AnzOut:=ParCount;
   for k:=1 to NntModul[AnzModuls].AnzOut do begin
                                             s:=ParStr(k);
                                             NntClasses[k]:=s[1];
                                             end;

   for n:=1 to AnzModuls do with NntModul[n] do
    begin
    readln(f,dummy,AnzIn,AnzOut);
    for i:=1 to AnzOut do
     begin
     for j:=0 to AnzIn do read(f,Koeff[i,j]);
     readln(f);
     end;
    end;

   end;
  Close(f);
  end;
 end;


procedure InputVNnt(v:Vector_2; Var Nnt:Nnt_T);
 begin
 with Nnt.NntModul[1] do begin
                         VectIn[1]:=v[1];
                         VectIn[2]:=v[2];
                         end;
 end;


procedure OutputNnt(Nnt:Nnt_T; Var d:DVkt_T);
 Var k:Word;
 begin
 with Nnt.NntModul[Nnt.AnzModuls] do for k:=1 to AnzOut do d[k]:=VectOut[k];
 end;


procedure InputErrorNnt(deltad:DVkt_T; Var Nnt:Nnt_T);
 Var k:Word;
 begin
 with Nnt.NntModul[Nnt.AnzModuls] do for k:=1 to AnzOut do DiffOut[k]:=deltad[k];
 end;


procedure ConnectForwNnt(m:Word; Var Nnt:Nnt_T);
 Var i:Word;
 begin
 with Nnt.NntModul[m] do for i:=1 to AnzOut do Nnt.nntModul[m+1].VectIn[i]:=VectOut[i];
 end;


procedure ConnectBackwNnt(m:Word; Var Nnt:nnt_T);
 Var i:Word;
 begin
 if m>1 then
  with Nnt.NntModul[m] do for i:=1 to AnzIn do Nnt.NntModul[m-1].DiffOut[i]:=DiffIn[i];
 end;


procedure ForwNnt(m:Word; Var Nnt:Nnt_T);
 Var i,j: Word; sum:Real;
 begin
 with Nnt.NntModul[m] do
  for i:=1 to AnzOut do
   begin
   sum:=0;
   for j:=0 to AnzIn do sum:=sum+koeff[i,j]*VectIn[j];
   VectOut[i]:=Sigmoid(sum);
   end;
 end;


procedure BackwNnt(m:Word; Var Nnt:Nnt_T);
 Var i,j:Word; sum:Real;
 begin
 with Nnt.NntModul[m] do
  begin

  for j:=1 to AnzIn do
   begin
   sum:=0;
   for i:=1 to AnzOut do sum:=sum+DiffOut[i]*(1-VectOut[i])*VectOut[i]*Koeff[i,j];
   DiffIn[j]:=sum;
   end;

  for i:=1 to AnzOut do
   for j:=0 to AnzIn do
    koeff[i,j]:=Koeff[i,j]-AlphaNnt*DiffOut[i]*(1-VectOut[i])*VectOut[i]*VectIn[j];

  end;
 end;


procedure DVektNnt(Var Nnt:Nnt_T; v:Vector_2; SmplClass:Char; Var ErkErg:ErkErg_T);
 Var i,m,n:Word; d:DVkt_T;
     anz,cmax:Word; sum,dk,dmax,deigen:Real;
     ind:array[1..AnzElemMod] of Word;
     fertig:Boolean;

 begin
 InputVNnt(v,Nnt);
 for m:=1 to Nnt.AnzModuls-1 do begin
                              ForwNnt(m,Nnt);
                              ConnectForwNnt(m,Nnt);
                              end;
 ForwNnt(Nnt.AnzModuls,Nnt);
 OutputNnt(Nnt,d);

 anz:=Nnt.NntModul[Nnt.AnzModuls].AnzOut;

  {berechne Radien}
  sum:=1; dmax:=0; deigen:=0;
  for n:=1 to anz do
   begin
   dk:=d[n];
   sum:=sum+sqr(dk);
   if dk>dmax then begin dmax:=dk; cmax:=n; end;
   if Nnt.NntClasses[n]=SmplClass then deigen:=dk;
   end;
  ErkErg.radqnxt:=sum-2*dmax;
  ErkErg.radqcls:=sum-2*deigen;

  {sortieren nach dk abfallend}
  for n:=1 to anz do ind[n]:=n;
  repeat
   fertig:=True;
   for n:=1 to anz-1 do if d[ind[n]]<d[ind[n+1]] then
    begin
    i:=ind[n]; ind[n]:=ind[n+1]; ind[n+1]:=i; fertig:=False;
    end;
  until fertig;

  {deponiere Ergebnisse unsortiert in dvkt       }
  {                 und sortiert in glbw und labl}
  for n:=1 to anz do
   begin
   ErkErg.clnr[n]:=ind[n];
   ErkErg.glbw[n]:=d[ind[n]];
   ErkErg.labl[n]:=Nnt.NntClasses[ind[n]];
   ErkErg.dvkt[n]:=d[n];
   end;

  ErkErg.anz:=anz;
  ErkErg.class:=SmplClass;

 end;


procedure BackProp(v:Vector_2; SmplClass:Char; ErkErg:ErkErg_T; Var Nnt:Nnt_T);
 Var deltad:DVkt_T; k,m:Word;
 begin
 for k:=1 to Klanz do
  if Nnt.NntClasses[k]=SmplClass then deltad[k]:=ErkErg.dvkt[k]-1
                                 else deltad[k]:=ErkErg.dvkt[k];
 InputErrorNnt(deltad,Nnt);
 for m:=Nnt.AnzModuls downto 2 do begin
                                  BackwNnt(m,Nnt);
                                  ConnectBackwNnt(m,Nnt);
                                  end;
 BackwNnt(1,Nnt);
 end;



procedure ClsLstFromStMod(StMod:StMod_T; Var ClsLst:ClsLst_T; Var KlAnz:Word);
 Const dontcare='-';
 Var i,k:Word;
 begin
 with StMod do
  begin
  k:=0;
  for i:=1 to anz do
   if tab[i].class<>dontcare then begin
                                  Inc(k);
                                  ClsLst[k]:=tab[i].class;
                                  end;
  Klanz:=anzcl;
  end;
 end;


procedure ClsLstFromNnt(Nnt:Nnt_T; Var ClsLst:ClsLst_T; Var Klanz:Word);
 begin
 with Nnt do
  begin
  ClsLst:=NntClasses;
  Klanz:=NntModul[AnzModuls].AnzOut;
  end;
 end;


procedure ClsLstFromClSlct(ClSlct:SetChar_T; Var Klanz:Word; Var ClsLst:ClsLst_T);
 Var i,k:Word;
 begin
 k:=0;
 for i:=33 to 255 do
 if Char(i) in ClSlct then begin
                           Inc(k);
                           ClsLst[k]:=Char(i);
                           end;
 KlAnz:=k;
 end;


procedure PlotClassRegionsNnt(Nnt:Nnt_T);
 Const dontcare='-';
 Var   i,j:Word; x,y,xx,yy:Word; v:Vector_2; ErkErg:ErkErg_T;
       korr:Integer;
       zeile,zeilev:array [0..199] of Byte;
       akt:Byte;

 function Erg(x,y:Word):Byte;
  begin
  SetV(XFInv(XSInv(x)),YFInv(YSInv(y)),v);
  DVektNnt(Nnt,v,dontcare,ErkErg);
  if ((ClSlct=[]) or (ErkErg.labl[1] in ClSlct)) and (ErkErg.glbw[1]>GlbwSchw) then Erg:=ErkErg.clnr[1]
  else Erg:=0;
  end;
                       
 begin
 korr:=KlAnz-1;

 {Buffer zeile initialisieren}
 y:=0; x:=0;
 for i:=0 to AnzPxH div Block do
  begin zeile[i]:=Erg(x,y); x:=x+Block; end;

 y:=Block;
 for j:=1 to AnzPxV div Block do
  begin
  {Vorgngerzeile nach zeilev[], neue Zeile in zeile[] bringen}
  zeilev:=zeile;
  x:=0;
  for i:=0 to AnzPxH div Block do begin zeile[i]:=Erg(x,y); x:=x+Block; end;
  {Bild aus den beiden Zeilen erzeugen}
  x:=Block;
  for i:=1 to AnzPxH div Block do
   begin
   akt:=zeile[i];
   if (zeile[i-1]=akt) and (zeilev[i-1]=akt) and (zeilev[i]=akt) then
    begin
    if akt<>0 then
     begin
     SetFillStyle(Solidfill,ClassColor[(akt+korr) mod 12]);
     Bar(x-Block,y-Block,x-1,y-1);
     end;
    end
   else
    for yy:=y-Block to y-1 do
     for xx:=x-Block to x-1 do
      begin
      akt:=Erg(xx,yy);
      if akt<>0 then PutPixel(xx,yy,ClassColor[(akt+korr) mod 12]);
      end;
   x:=x+Block;
   end;
  y:=y+Block;
  if KeyPressed then Exit;
  end;
 end;


procedure PlotClassBordersNnt(Nnt:Nnt_T);
 Const dontcare='-';
 Var   i,ii,j,jj:Word; x,y,xx,yy:Word; v:Vector_2; ErkErg:ErkErg_T;
       zeile,zeilev:array [0..199] of Byte;
       localimage:array [0..20,0..20] of Byte;
       akt:Byte;

 function Erg(x,y:Word):Byte;
  begin
  SetV(XFInv(XSInv(x)),YFInv(YSInv(y)),v);
  DVektNnt(Nnt,v,dontcare,ErkErg);
  if (ClSlct=[]) or (ErkErg.labl[1] in ClSlct) then Erg:=ErkErg.clnr[1]
  else Erg:=0;
  end;

 begin

 {Buffer zeile initialisieren}
 y:=0; x:=0;
 for i:=0 to AnzPxH div Block do
  begin zeile[i]:=Erg(x,y); x:=x+Block; end;

 y:=Block;
 for j:=1 to AnzPxV div Block do
  begin
  {Vorgngerzeile nach zeilev[], neue Zeile in zeile[] bringen}
  zeilev:=zeile;
  x:=0;
  for i:=0 to AnzPxH div Block do begin zeile[i]:=Erg(x,y); x:=x+Block; end;
  {Bild aus den beiden Zeilen erzeugen}
  x:=Block;
  for i:=1 to AnzPxH div Block do
   begin
   akt:=zeile[i];
   if not ((zeile[i-1]=akt) and (zeilev[i-1]=akt) and (zeilev[i]=akt)) then
    begin
    {localimage bereitstellen}
    for ii:=0 to Block+1 do
     for jj:=0 to Block+1 do
     localimage[ii,jj]:=Erg(MaxI(x-Block-1+ii,0),MaxI(y-Block-1+jj,0));

    for ii:=1 to Block+1 do
     for jj:=1 to Block+1 do
      begin
      akt:=localimage[ii,jj];
      if (localimage[ii-1,jj]<>akt) or (localimage[ii,jj-1]<>akt) then
       PutPixel(x-Block-1+ii,y-Block-1+jj,QMKGrenzenColor);
      end;
    end;
   x:=x+Block;
   end;
  y:=y+Block;
  if KeyPressed then Exit;
  end;
 end;


procedure PlotZeroLineFirstLayerNnt(Nnt:Nnt_T; node:Word);
 Var   v,v1,v2:Vector_2;
       xl,xr,yu,yo:Real;
       a0,a1,a2:Real;
       flu,flo,fro,fru:Real;
       found1,found2:Boolean;
 
 begin
 xl:=Koor.lmtl; xr:=Koor.lmtr;
 yu:=Koor.lmtu; yo:=Koor.lmto;
 with Nnt.NntModul[1] do begin
                         a0:=koeff[node,0];
                         a1:=koeff[node,1];
                         a2:=koeff[node,2];
                         end;

 flu:=a0+a1*xl+a2*yu;
 flo:=a0+a1*xl+a2*yo;
 fro:=a0+a1*xr+a2*yo;
 fru:=a0+a1*xr+a2*yu;

 found1:=False; found2:=False;

 if Sign(flu)<>Sign(flo) then begin
                              found1:=True;
                              SetV(xl,-(a0+a1*xl)/a2,v1);
                              end;
 if Sign(flo)<>Sign(fro) then
               if found1 then begin
                              found2:=True;
                              SetV(-(a0+a2*yo)/a1,yo,v2);
                              end
                         else begin
                              found1:=True;
                              SetV(-(a0+a2*yo)/a1,yo,v1);
                              end;
 if not found2
    and (Sign(fro)<>Sign(fru)) then
               if found1 then begin
                              found2:=True;
                              SetV(xr,-(a0+a1*xr)/a2,v2);
                              end
                         else begin
                              found1:=True;
                              SetV(xr,-(a0+a1*xr)/a2,v1);
                              end;
 if (not found2) and found1
    and (Sign(fru)<>Sign(flu)) then
                              begin
                              found2:=True;
                              SetV(-(a0+a2*yu)/a1,yu,v2);
                              end;
 if found2 then begin
                LMoveToV(v1); LLineToV(v2);
                end;
 end;


procedure InitKlf(Var KlfDat:KlfDat_T);
 Var k,i:Word; p:Real;
 begin
 with KlfDat do begin
                typ:='QMK';
                anz:=Klanz;
                p:=1/anz;
                for k:=1 to Klanz do
                 begin
                 dat[k].class:=ClsLst[k];
                 dat[k].koeff[1]:=p;
                 for i:=2 to 10 do dat[k].koeff[i]:=0;
                 end;
                end;
 end;


procedure InitHDiagInv;
 Var i:Word;
 begin for i:=1 to 6 do HDiagInv[i]:=1; end;


procedure KlfRek(v:Vector_2; SmplClass:Char; ErkErg:ErkErg_T; Var KlfDat:KlfDat_T);
 Var xv:Vector_6; deltad:Real; k,i:Word;
 begin

 VqPV(v,xv);
 for i:=1 to 6 do HDiagInv[i]:=HDiagInv[i]/(1+6*AlphaKlf*(HdiagInv[i]*sqr(xv[i])-1));
 
 with KlfDat do
  begin
  for k:=1 to anz do
   begin
   if dat[k].class=SmplClass then deltad:=ErkErg.dvkt[k]-1
                             else deltad:=ErkErg.dvkt[k];
   for i:=1 to 6 do
    dat[k].koeff[i]:=dat[k].koeff[i]-AlphaKlf*HDiagInv[i]*xv[i]*deltad
   end;
  end;
 end;

begin
end.