unit JS_PLTR;


Interface

Uses
 graph,dos,crt,js_sub,js_acc,js_tio,js_koor,
 js_mtr,js_mat,js_gra;

Const
 AnzIntPro = 500;

Type
 Pro_T = record
          stpktanz: Integer;
          anz:      Array[1..AnzIntPro] of LongInt;
          rst:      Array[1..AnzIntPro] of Real;
          err:      Array[1..AnzIntPro] of Real;
          del:      Array[1..AnzIntPro] of Real;
         end;

Var
 PfadePfad,PfadeRdDflt,PfadeRdDatei,PfadeSvDatei: PathStr;
 KoorPfad, KoorRdDflt, KoorRdDatei, KoorSvDatei:  PathStr;
 FarbePfad,FarbeRdDflt,FarbeRdDatei,FarbeSvDatei: PathStr;
 ProPfad,              ProRdDatei:                PathStr;
 EditorPfad: PathStr;


 KoorColor:    Word;
 BeschrColor:  Word;

 RstLineColor:   Word;
 RstLineArt:     Integer;
 ErrLineColor:   Word;
 ErrLineArt:     Integer;
 DelLineColor:   Word;
 DelLineArt:     Integer;
 IncColor:       Boolean;
 IncLnArt:       Boolean;
 ProFertig:      Boolean;

 pro:            Pro_T;


procedure PfadeInitPltrek(PfadeMaske:MskPar_T);
procedure ColorInitPltrek(FarbeMaske:MskPar_T);
procedure RdPro(ProRdDatei:PathStr);
procedure PlotRst;
procedure PlotErr;
procedure PlotDel;


Implementation

procedure PfadeInitPltrek(PfadeMaske: MskPar_T);
 begin
 KoorPfad:=     PfadeMaske.erg[ 1];
 KoorRdDflt:=   PfadeMaske.erg[ 2];
 FarbePfad:=    PfadeMaske.erg[ 3];
 FarbeRdDflt:=  PfadeMaske.erg[ 4];
 ProPfad:=      PfadeMaske.erg[ 5];
 EditorPfad:=   PfadeMaske.erg[ 6];

 KoorRdDatei:=   KoorRdDflt;
 FarbeRdDatei:=  FarbeRdDflt;
 end;


procedure ColorInitPltrek(FarbeMaske:MskPar_T);
 Var i:Word; s:String; wert:Real;
 begin
 DskTpColor[0]:=     ColorFromStr(FarbeMaske.erg[1]);
 DskTpColor[1]:=     ColorFromStr(FarbeMaske.erg[2]);
 KoorColor:=         ColorFromStr(FarbeMaske.erg[3]);
 RstLineColor:=      ColorFromStr(FarbeMaske.erg[4]);
 RstLineArt:=        ValI(Trim(FarbeMaske.erg[5]));
 ErrLineColor:=      ColorFromStr(FarbeMaske.erg[6]);
 ErrLineArt:=        ValI(Trim(FarbeMaske.erg[7]));
 DelLineColor:=      ColorFromStr(FarbeMaske.erg[8]);
 DelLineArt:=        ValI(Trim(FarbeMaske.erg[9]));
 end;




procedure RdPro(ProRdDatei:PathStr);
 Var f:Text; i:Integer; s:String; DataFound:Boolean;
 begin
 Assign(f,ProRdDatei); {$I-} Reset(f); {$I+} OK:=(IOResult=0);
 if OK then
  begin
  repeat
   readln(f,s);
   if s[1]='*' then begin
                    GetPar(s);
                    DataFound:=(ParStr(2)='Anz');
                    end;
  until DataFound;
  i:=1;
  repeat
   readln(f,pro.anz[i],pro.rst[i],pro.err[i],pro.del[i]);
   Inc(i);
  until Eof(f);
  Close(f);
  pro.stpktanz:=i-1;
  end;
 end;


procedure PlotRst;
 Var
  i:Integer; 
 begin
 SetV(pro.anz[1],pro.rst[1],v); LMoveToV(v);
 for i:=2 to pro.stpktanz do
  begin
  SetV(pro.anz[i],pro.rst[i],v); LLineToV(v);
  end;
 end;


procedure PlotErr;
 Var
  i:Integer; 
 begin
 SetV(pro.anz[1],pro.err[1],v); LMoveToV(v);
 for i:=2 to pro.stpktanz do
  begin
  SetV(pro.anz[i],pro.err[i],v); LLineToV(v);
  end;
 end;


procedure PlotDel;
 Var
  i:Integer; 
 begin
 SetV(pro.anz[1],pro.del[1],v); LMoveToV(v);
 for i:=2 to pro.stpktanz do
  begin
  SetV(pro.anz[i],pro.del[i],v); LLineToV(v);
  end;
 end;


begin
end.