unit JS_SUB;


interface

uses graph,dos,crt,pc_mouse;

Const
 StrFldLen=20;

Type
 StrFld_T = array[0..StrFldLen] of string[79];

Var
 Parfld:StrFld_T;
 OK:Boolean;
 GrDr,GrMd:Integer;
 ChrW,ChrH,AnzPxH,AnzPxV:Integer;
 ActPage,VisPage:Word;
 DskTpColor: Array[0..1] of Word;
 BGIPfad:PathStr;


function  Exts(dateiname:string):ExtStr;
function  Name(dateiname:string):NameStr;

function  MaxR(a,b:real):real;
function  MinR(a,b:real):real;
function  MaxI(a,b:integer):integer;
function  MinI(a,b:integer):integer;
function  Sign(x:Real):Integer;
function  Log(x,b:Real):Real;
function  XHochY(x,y: real):real;

function  RptStr(i:Word; s:string):string;
function  StrR(r:real; n,m:Word):string;
function  StrI(i:integer; n:Word):string;
function  StrLongI(i:LongInt; n:Word):string;
function  ValR(s:string):real;
function  ValI(s:string):integer;
function  ValLongI(s:string):Longint;

function  Leer(s:string):boolean;
function  UpCaseWord(s:string):string;
function  Trim(s:string):string;
function  FillStr(s:string; l:Word):string;
function  BoolStr(b:Boolean):String;
function  BoolFromStr(s:String):Boolean;
function  ColorToStr(w:Word):String;
function  ColorFromStr(s:String):Word;

procedure ClearParFld;
procedure GetPar(s:string);
function  ParCount:Word;
function  ParStr(i:Word):string;

procedure ClearStrFld(var StrFld:StrFld_T);
function  ParCountStrFld(StrFld:StrFld_T):Word;

procedure DtctGrphPar(Var ChrW,ChrH,AnzPxH,AnzPxV:Integer);
function  GraphicMode:boolean;
procedure SetVPage(pg:word);
procedure SetAPage(pg:word);
function  TxtForGr:Word;
function  TxtBckGr:Word;
procedure ClrDsktp(ActPage:Word);
procedure ClrDsktpG(ActPage:Word);
procedure Titel(s:String);

procedure Wait(s:string);
procedure WaitForReturn;
function  WaitForReturnOrEscape:Boolean;


implementation

function Exts(dateiname:string):ExtStr;
 Var p: integer;
 begin
 p:=Pos('.',dateiname);
 if p>0 then Exts:=Copy(dateiname,p+1,3) else Exts:='';
 end;

function Name(dateiname:string):NameStr;
 Var p: integer;
 begin
 p:=Pos('.',dateiname);
 if p>0 then Name:=Copy(dateiname,1,p-1) else Name:=dateiname;
 end;

function MaxR(a,b:real):real;
 begin if a>=b then MaxR:=a else MaxR:=b end;

function MinR(a,b:real):real;
 begin if a>=b then MinR:=b else MinR:=a end;

function MaxI(a,b:integer):integer;
 begin if a>=b then MaxI:=a else MaxI:=b end;

function MinI(a,b:integer):integer;
 begin if a>=b then MinI:=b else MinI:=a end;

function Sign(x:Real):Integer;
 begin
 if x<0      then Sign:=-1
 else if x=0 then Sign:=0
 else             Sign:=+1;
 end;

function Log(x,b:Real):Real;
 begin Log:=Ln(x)/Ln(b); end;

function XHochY(x,y: real):real;
 begin XHochY:=exp(MinR(MaxR(y*ln(x),-70),70)); end;


function RptStr(i:Word; s:string):string;
 VAR j:integer; t:string;
 begin t:=''; for j:=1 to i do t:=t+s; RptStr:=t; end;

function StrR(r:real; n,m:Word):string;
 VAR t:string;
 begin
 if (n<>0) and (m<>0) then Str(r:n:m,t) else Str(r,t);
 StrR:=t;
 end;

function StrI(i:integer; n:Word):string;
 VAR t:string;
 begin
 if n<>0 then Str(i:n,t) else Str(i,t);
 StrI:=t;
 end;

function StrLongI(i:LongInt; n:Word):string;
 VAR t:string;
 begin
 if n<>0 then Str(i:n,t) else Str(i,t);
 StrLongI:=t;
 end;

function ValR(s:string):real;
 VAR r:real; c : integer;
 begin Val(s,r,c); if c=0 then ValR:=r else ValR:=0.0; end;

function ValI(s:string):integer;
 VAR i,c:integer;
 begin Val(s,i,c); if c=0 then ValI:=i else ValI:=0; end;

function ValLongI(s:string):Longint;
 VAR i:Longint; c:Integer;
 begin Val(s,i,c); if c=0 then ValLongI:=i else ValLongI:=0; end;

function Leer(s:string):boolean;
 begin if s=RptStr(length(s),' ') then Leer:=TRUE else Leer:=FALSE; end;

function UpCaseWord(s:string):string;
 VAR i:integer; t:string;
 begin
  t:=''; for i:=1 to length(s) do t:=t+UpCase(s[i]); UpCaseWord:=t;
 end;

function Trim(s:string):string;
 begin
 while (length(s)>0) and (s[1]=#32)         do s:=Copy(s,2,255);
 while (length(s)>0) and (s[length(s)]=#32) do s:=Copy(s,1,length(s)-1);
 Trim:=s;
 end;

function FillStr(s:string; l:Word):string;
 begin
 if length(s)>l then FillStr:=Copy(s,1,l)
                else FillStr:=s+RptStr(l-length(s),' ');
 end;

function BoolStr(b:boolean):String;
 Const bt:array[Boolean] of String[5]=('False','True ');
 begin BoolStr:=bt[b]; end;

function BoolFromStr(s:String):Boolean;
 begin if UpCaseWord(Trim(s))='TRUE' then BoolFromStr:=True else BoolFromStr:=False; end;

function ColorToStr(w:Word):String;
 Const
  ct:array[0..15] of String[12]
   =('Black       ','Blue        ','Green       ','Cyan        ',
     'Red         ','Magenta     ','Brown       ','LightGray   ',
     'DarkGray    ','LightBlue   ','LightGreen  ','LightCyan   ',
     'LightRed    ','LightMagenta','Yellow      ','White       ');
 begin if w in [0..15] then ColorToStr:=ct[w]
                       else ColorToStr:=''; end;

function ColorFromStr(s:String):Word;
 Var i:Word;
 begin
 s:=UpCaseWord(Trim(s));
 i:=0;
 while s<>UpCaseWord(Trim(ColorToStr(i))) do
  if i<15 then Inc(i) else begin ColorFromStr:=255; Exit; end;
 ColorFromStr:=i;
 end;

procedure ClearParFld;
 var i:Word;
 begin for i:=0 to StrFldLen do ParFld[i]:=''; end;

procedure GetPar(s:string);
 Var i,p:Word; ch:Char;
 begin
  ClearParFld; i:=0;
  while (length(s)>0) and (i<StrFldLen) do
  begin
  s:=Trim(s);
  case s[1] of
   #34: begin ch:=#34; s:=Copy(s,2,255); end;
   else ch:=#32;
  end;
  p:=Pos(ch,s); inc(i);
  if p>0 then begin ParFld[i]:=Copy(s,1,p-1); s:=Copy(s,p+1,255); end
         else begin ParFld[i]:=s; s:=''; end;
  end;
  ParFld[0]:=StrI(i,0);
 end;

function ParCount:Word;
 begin
 ParCount:=ValI(Trim(ParFld[0]));
 end;

function ParStr(i:Word):string;
 begin
 if (i=0) or (i>StrFldLen) then ParStr:='' else ParStr:=ParFld[i];
 end;

procedure ClearStrFld(var StrFld:StrFld_T);
 var i:Byte;
 begin
 for i:=0 to StrFldLen do StrFld[i]:='';
 end;

function ParCountStrFld(StrFld:StrFld_T):Word;
 begin
 ParCountStrFld:=ValI(Trim(StrFld[0]));
 end;


procedure Wait(s:string);
 var ch:Char;
 begin
 if leer(s) then s:='Weiter mit beliebiger Taste';
 Writeln(s);
 ch:=ReadKey;
 end;

procedure WaitForReturn;
 Var ch:Char;
 begin
 ch:=#0;
 repeat
  if KeyPressed then ch:=ReadKey;
 until (ch=#13) or RightButton;
 end;

function  WaitForReturnOrEscape:Boolean;
 Var ch:Char;
 begin
 ch:=#0;
 repeat
  if KeyPressed then ch:=ReadKey;
 until (ch=#13) or (ch=#27) or RightButton;
 WaitForReturnOrEscape:=not (ch=#27);
 end;


procedure DtctGrphPar(Var ChrW,ChrH,AnzPxH,AnzPxV:Integer);
 begin
 case GrMd of
  1: begin ChrW:=8; ChrH:=14; AnzPxH:=640; AnzPxV:=350; end;
  2: begin ChrW:=8; ChrH:=16; AnzPxH:=640; AnzPxV:=480; end;
  else begin ChrW:=8; ChrH:=16; AnzPxH:=640; AnzPxV:=480; end;
 end;
 end;

function GraphicMode:boolean;
 var mode:Byte;
 begin
 mode:=mem[$40:$49];
 GraphicMode:= not (mode in [0,1,2,3,7]);
 end;

procedure SetVPage(pg:word);
begin
 SetVisualPage(pg);
 VisPage:=pg;
end;

procedure SetAPage(pg:word);
begin
 SetActivePage(pg);
 ActPage:=pg;
end;

function TxtForGr:Word;
 begin TxtForGr:=TextAttr and 15; end;

function TxtBckGr:Word;
 begin TxtBckGr:=TextAttr shr 4; end;

procedure ClrDsktp(ActPage:Word);
 begin
 TextBackGround(DskTpColor[ActPage]);
 ClrScr;
 end;

procedure ClrDsktpG(ActPage:Word);
 begin
 SetFillStyle(1,DskTpColor[ActPage]);
 bar(0,0,AnzPxH-1,AnzPxV-1);
 end;


procedure Titel(s:String);
 Var
  savecolor:Word;
  tp:TextSettingsType;
  i:Integer;
 begin
 savecolor:=GetColor;
   SetColor(Red);
   GetTextSettings(tp);
     SetTextJustify(0,2);
     SetTextStyle(TriplexFont,HorizDir,8);
     for i:=0 to 3 do OutTextXY(50+i,120,s);
   SetTextStyle(tp.Font,tp.Direction,tp.CharSize);
   SetTextJustify(tp.Horiz,tp.Vert);
 SetColor(savecolor);
 end;


begin
 ClearParFld;
 OK:=FALSE;
end.