unit JS_TIO;


Interface

Uses
 graph,dos,crt,js_sub;

Const
  ChrPtch=  8;
  ChrHght=  8;


procedure WriteXYG(x,y:Integer; s:string);
procedure WriteG(s:string);
procedure WriteLnG(s:string);

procedure Rahmen(zeile,spalte,breite,hoehe:Word);
procedure RahmenXYG(x,y,b,h:Integer);

procedure Beschrifte;


Implementation

procedure WriteXYG(x,y:Integer; s:string);
 Var
  savecolor:Word;
  fp:FillsettingsType;
  tp:TextSettingsType;

 begin
 if s<>'' then
  begin
  savecolor:=GetColor;
    SetColor(TxtBckGr);
    GetFillSettings(fp);
      SetFillStyle(SolidFill,TxtBckGr);
      Bar(x,y,x+ChrPtch*Length(s)-1,y+ChrHght-1);
    SetFillStyle(fp.Pattern,fp.Color);
    SetColor(TxtForGr);
    GetTextSettings(tp);
      SetTextStyle(0,0,1);
      SetTextJustify(0,2);
      OutTextXY(x,y,s);
    SetTextStyle(tp.Font,tp.Direction,tp.CharSize);
    SetTextJustify(tp.Horiz,tp.Vert);
  SetColor(savecolor);
  end;
 end;


procedure WriteG(s:string);
 Var x,y,xn:Integer;
 begin
 x:=GetX; y:=GetY; xn:=x+ChrPtch*Length(s);
 WriteXYG(x,y,s);                             
 MoveTo(xn,y);
 end;


procedure WriteLnG(s:string);
 Var y,yn:Integer;
 begin
 y:=GetY; yn:=y+ChrHght;
 WriteG(s);
 MoveTo(0,yn);
 end;


procedure Rahmen(zeile,spalte,breite,hoehe:Word);
 var i:Byte; s1,s2,s3:string;
 begin
 s1:=''+RptStr(breite-2,'')+'';
 s2:=''+RptStr(breite-2,' ')+'';
 s3:=''+RptStr(breite-2,'')+'';
 GoToXY(spalte,zeile); write(s1);
 for i:=1 to hoehe-2 do
  begin GoToXY(spalte,zeile+i); write(s2); end;
 GoToXY(spalte,zeile+hoehe-1); write(s3);
 end;


procedure RahmenXYG(x,y,b,h:Integer);
 Var
  savecolor:Word;
  fp:FillsettingsType;
  lp:LineSettingsType;

 begin
 savecolor:=GetColor;
   SetColor(TxtBckGr);
   GetFillSettings(fp);
     SetFillStyle(SolidFill,TxtBckGr);
     Bar(x,y,x+b-1,y+h-1);
   SetFillStyle(fp.Pattern,fp.Color);
   SetColor(TxtForGr);
   GetLineSettings(lp);
     SetLineStyle(SolidLn,0,NormWidth);
     Rectangle(x+3,y+2,x+b-4,y+h-3);
     Rectangle(x+6,y+5,x+b-7,y+h-6);
   SetLineStyle(lp.LineStyle,lp.Pattern,lp.Thickness);
 SetColor(savecolor);
 end;


procedure Beschrifte;
 Const ChrHght=10;
 Var   ch,ch2:Char;
       x,y,xstart,ystart:Integer;
       xanf:Integer; newline:Boolean;

 procedure Cursor;
  begin Line(x,y+ChrHght-1,x+ChrPtch-1,y+ChrHght-1); end;

 procedure NextLine;
  begin y:=MinI(y+ChrHght,AnzPxV-1); end;

 procedure BeforeLine;
  begin y:=MaxI(y-ChrHght,0); end;

 procedure NextChar;
  begin x:=MinI(x+ChrPtch,AnzPxH-1); end;

 procedure BeforeChar;
  begin x:=MaxI(x-ChrPtch,0); end;



 begin
 SetColor(Yellow); SetWriteMode(XorPut);
 xstart:=AnzPxH div 2; x:=xstart;
 ystart:=AnzPxV div 2; y:=ystart;
 xanf:=xstart; newline:=True;
 repeat
  Cursor;
  ch:=ReadKey;
  Cursor;
  case ch of
   #0: if KeyPressed then begin
                          ch2:=Readkey;
                          case ch2 of
                           #71: begin x:=xstart; y:=ystart; end;
                           #72: begin BeforeLine; newline:=True; end;
                           #80: begin NextLine;   newline:=True; end;
                           #75: BeforeChar;
                           #77: NextChar;
                          end;
                          end;
   #8 :       begin BeforeChar; WriteXYG(x,y,#32); end;
   #13:       begin x:=xanf; NextLine; newline:=True; end;
   #32..#255: begin
              WriteXYG(x,y,ch);
              if newline and (ch<>#32) then
               begin xanf:=x; newline:=False; end;
              NextChar; end;
  end;
 until ch=#27;
 SetWriteMode(NormalPut);
 end;

begin
end.